# Generated by Makefile. Do not edit!
commit e2c21d7c25f07af9d249bfe9018b9ce2a7d4a8e0
Author: Feitian Technologies <hongbin@ftsafe.com>
Date:   Mon Nov 30 23:24:05 2015 +0800

    Add new Feitian PKI Card ATR into OpenSC
    
    Add new PKI Card ATR into OpenSC support, all of these ATR using same
    PKI Applet. and the ATR/JAVA CARD is provided by Feitian.
    
    More information, please check www.javacardos.com
    
    Fixes a memory leak in `entersafe_select_fid`
    
    Closes https://github.com/OpenSC/OpenSC/pull/625

commit 5c018dcd8c423b3b5346831148f464e46434a868
Merge: 7cce5d4 6b2fcf8
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Tue Feb 2 02:59:22 2016 +0100

    Merge pull request #664 from sfff/fix-648
    
    Fix #648

commit 7cce5d432e1b6e3261958cd75fa6aa2e84809c98
Merge: 14953f2 848ce19
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Tue Feb 2 02:52:01 2016 +0100

    Merge branch 'master' of https://github.com/OpenSC/OpenSC

commit 848ce1947a98fe597ce627f9d971c7d557fd9e01
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu Jan 21 16:39:48 2016 +0100

    iasecc: fix default name of SM module

commit 6b2fcf825f6e6203c51791f4a45f351b7c3a312f
Author: Aleksey Samsonov <s4ms0n0v@gmail.com>
Date:   Sun Jan 24 01:30:59 2016 +0300

    Rutoken ECP: additional Miller-Rabin tests aren't needed
    
    Make universal properties at RSF-files. Additional Miller-Rabin tests
    aren't needed for 'Rutoken ECP' and for 'Rutoken ECP 2.0'
    
    fixes https://github.com/OpenSC/OpenSC/issues/648 :
    'Incorrect parameters in APDU' at 'Rutoken ECP 2.0' when 'pkcs15-init -G
    rsa/1024 ...'

commit e1a3bf8805f712a0c99a8fa8fa1b2d8f3aa9428b
Author: Aleksey Samsonov <s4ms0n0v@gmail.com>
Date:   Sun Jan 24 01:14:21 2016 +0300

    Rutoken ECP: set more universally 'Attempts' for RFS-files

commit 79cd06ba30452f6de28b7d07d36f384586285927
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Fri Jan 22 18:42:10 2016 +0200

    Use "native" badges
    
    shields.io has been very unreliable and overloaded recently, so ease their load and use directly native badges where available.
    
    Also, add some formatting to the pale README so that Github front page would look better.

commit aa8ad8d5b286772518ff865fad26410946f4fb9f
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri Jan 22 15:18:58 2016 +0100

    build: restore build on Win32

commit 4f4b6c962a15c1f5e071ea2af8bdf4f97089fd15
Merge: b09d277 89f9d9e
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Fri Jan 22 14:36:42 2016 +0100

    Merge pull request #661 from frankmorgner/strnlen
    
    implemented strnlen

commit b09d2777d14a6b8211dce89ff171f833cd487e4d
Merge: f3f6e76 c56378b
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Fri Jan 22 14:36:02 2016 +0100

    Merge pull request #663 from digitallumens/pkcs15-crypt/stdin
    
    pkcs15-crypt: Allow the use of stdin if no input file is specified.

commit c56378b8ba3b16c125ed39805017955181892886
Author: Chris Elledge <celledge@digitallumens.com>
Date:   Thu Jan 21 11:30:26 2016 -0500

    pkcs15-crypt: Document defaults of stdin/stdout.

commit f3f6e7647f849c0dbd358e944d499dc04fb7e011
Merge: a0c0087 f01a8ad
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Thu Jan 21 00:23:59 2016 +0100

    Merge pull request #662 from digitallumens/pkcs11-tool/fix-pipes
    
    pkcs11-tool: Switched some printfs to fprintfs to allow pipes to work.
    
    fixes https://github.com/OpenSC/OpenSC/issues/657

commit 92e02b50dce9801dfdd713765dc35e6224e83f90
Author: Chris Elledge <celledge@digitallumens.com>
Date:   Wed Jan 20 15:35:44 2016 -0500

    pkcs15-crypt: Allow the use of stdin if no input file is specified.

commit 89f9d9e85d3ad7c2b45fe1a6da5ed9be034e9645
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Jan 20 10:45:06 2016 +0100

    add compatibility implementation for strnlen
    
    fixes https://github.com/OpenSC/OpenSC/issues/660

commit f01a8ad22e522a0ba0f7a6c338eabefe41762cbf
Author: Chris Elledge <celledge@digitallumens.com>
Date:   Tue Jan 19 14:54:02 2016 -0500

    pkcs11-tool: Switched some printfs to fprintfs to allow pipes to work.

commit a0c008744608ff2a425a7062479dce3712add5ca
Merge: 75c14ce e9f94d7
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Fri Jan 15 10:32:46 2016 +0100

    Merge pull request #637 from germanblanco/sm_get_response_loop_fix
    
    Stop reading a file when an error happened *or* all data requested was read.
    
    Fixes https://github.com/OpenSC/OpenSC/issues/632 , but may need adjustments when used with SM

commit 14953f20759b9eec04f65d05d24c2791f76e8918
Merge: 4734721 75c14ce
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Thu Jan 14 05:03:56 2016 +0100

    Merge remote-tracking branch 'origin/master'

commit 75c14ce815e76980e93fb8a80520dbef5fc5e7a0
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Thu Jan 14 05:02:28 2016 +0100

    Fixed possible NULL dereference
    
    fixes https://github.com/OpenSC/OpenSC/issues/656

commit d7559f154666efd0d639b572bc4cd94082097a40
Author: Lukas Wunner <lukas@wunner.de>
Date:   Sat Oct 3 11:55:55 2015 +0200

    card-gemsafeV1: Support signing SHA256
    
    GemSAFE V1 cards support signing 36 bytes of free form data.
    When signing a hash, the hash must be prepended by the DigestInfo
    header. The PKCS#1 padding is done on the card. The 36 bytes limit
    is sufficient for MD5 (16 + 18 bytes for the header), SHA1 and
    RIPEMD160 (both use 20 + 15 bytes for the header) and MD5_SHA1
    (16 + 20 bytes, no header). The algorithm reference ("cryptographic
    mechanism reference" in ISO 7816 parlance) for signing free form data
    is 0x12.
    
    GemSAFE V3 cards changed the algorithm reference for signing free
    form data to 0x02. In addition, they gained the ability to sign SHA256.
    Since SHA256 exceeds the 36 bytes limit (32 + 19 bytes for the header),
    it must be sent to the card *without* DigestInfo header. The header
    will be prepended by the card and it is instructed to do so by sending
    algorithm reference 0x42.
    
    This scheme is also supported for SHA1, the algorithm reference is
    0x12 in this case. However using this is not necessary as SHA1 fits
    within the 36 bytes limit, including the header.
    
    Supporting SHA256 is straightforward, we just add it to the flags
    before adding the RSA algorithms. When sc_pkcs15_compute_signature()
    calls sc_get_encoding_flags(), the input will be "iFlags 0x202, card
    capabilities 0x8000021A" and the output will be "pad flags 0x0, secure
    algorithm flags 0x202". I.e. the hash is neither prepended by the
    DigestInfo header nor PKCS#1 padded and the hash algorithm is passed
    to gemsafe_set_security_env() which can send the appropriate algorithm
    reference 0x42 to the card.
    
    However there's a catch: Once we add SHA256 to the flags, PKCS#11
    applications will be unable to use the other hashes like SHA1 or
    RIPEMD160. That's because register_mechanisms() checks if the card
    supports no hashes, and if so, adds all of them:
    
    		if (!(rsa_flags & SC_ALGORITHM_RSA_HASHES)) {
    			rsa_flags |= SC_ALGORITHM_RSA_HASHES;
    		}
    
    We cannot add these missing hashes to the flags like we did with SHA256
    because like SHA256, they would be sent to the card *without* DigestInfo
    header. What we want is to send all hashes *with* DigestInfo header,
    *except* for SHA256.
    
    We can achieve that by registering a fake RSA algorithm which includes
    the missing hashes in its flags. This fake algorithm is never used
    because sc_card_find_rsa_alg() searches the algorithm list in-order
    and we register the fake algorithm *after* the real algorithms.
    
    The fake algorithm persuades register_mechanisms() to register the
    missing hashes because it ORs the flags of all RSA algorithms together:
    
    	num = card->algorithm_count;
    	while (num--) {
    		switch (alg_info->algorithm) {
    			case SC_ALGORITHM_RSA:
    				rsa_flags |= alg_info->flags;
    				break;
    		}
    	}
    
    So when signing e.g. a RIPEMD160 hash and sc_pkcs15_compute_signature()
    calls sc_get_encoding_flags(), the input will be "iFlags 0x102, card
    capabilities 0x8000021A" and the output will be "pad flags 0x100, secure
    algorithm flags 0x2". This will result in the hash being prepended by
    the DigestInfo header, which is what we want.

commit e8d8f9f2bb87f2ddb6dc370c20c2b3433049a003
Merge: 611e520 6e5ae84
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Jan 6 07:30:15 2016 +0100

    Merge pull request #650 from vletoux/pkcs11-crash-when-read-public-key-fails
    
    fix a pkcs11 crash when the public key reading fails
    
    fixes #649

commit 611e5200b16ddebbbeede26a4966c133d4604ab3
Merge: e96d3cc 56275c6
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Jan 6 07:28:56 2016 +0100

    Merge pull request #647 from vletoux/visual-studio-warning
    
    remove visual studio compilation error

commit 6e5ae841eb398b6393d7349d45f2386f820c9f5f
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Sat Jan 2 09:31:36 2016 +0100

    fix a pkcs11 crash when the public key reading fails

commit 56275c699370457278a6ce24415bd0a16609aa51
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Thu Dec 31 18:09:45 2015 +0100

    remove visual studio compilation error
    
    quote:
    avoid error C4703: potentially uninitialized local pointer variable 'obj' used line 1414

commit e96d3ccf663ed721b43616144567c5082c0d5510
Merge: 2f95e7c 76ed069
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Mon Dec 28 00:48:40 2015 +0100

    Merge pull request #642 from mouse07410/master
    
    Fix public key access and attributes

commit 2f95e7cb5042c391d4b7c70c6563d986c46c37fd
Merge: 47835f7 57f52b1
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Mon Dec 28 00:45:23 2015 +0100

    Merge pull request #645 from vletoux/zlib-inclusion-appveyor
    
    add zlib compilation into the appveyor built process
    
    closes https://github.com/OpenSC/OpenSC/issues/586

commit 57f52b1936b1b8a58fa8ecb5660230e451781b40
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Sun Dec 27 13:13:24 2015 +0100

    cache the zlib.zip when building from Appveyor

commit 40440e70f48e554401d6ed6679fa5e47dcba55d0
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Sat Dec 26 18:44:57 2015 +0100

    add zlib compilation into the appveyor built process
    
    zlib feature now available for x64

commit 47835f719f0c8b4205cd2fdf8b89ec8841b4c100
Merge: 07be93a aa4b089
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Dec 23 21:06:44 2015 +0100

    Merge pull request #643 from dengert/piv-pubkey-auth_id
    
    PIV pubkey auth_id fix

commit 07be93a59745ebc23236afec663d4d97ee199ad5
Merge: 2fd32fd 48782e7
Author: Frank Morgner <frankmorgner@gmail.com>
Date:   Wed Dec 23 20:51:56 2015 +0100

    Merge pull request #644 from vletoux/appveyor-fixes
    
    Fix AppVeyor builds

commit 48782e768de6933e3aec666439604c66b0cea8cc
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Wed Dec 23 18:52:49 2015 +0100

    appveyor: fix wix lib not found

commit 9a6e11e28a8c4132967cf02cf4f3d3ea0655d68d
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Wed Dec 23 18:46:30 2015 +0100

    appveyor: fix wcautil.h not found

commit 51be65ba9b48966465e3bcd40c898c15f7b74120
Author: LE TOUX Vincent <HG2025@sdmn01.sirius.infra.com>
Date:   Wed Dec 23 18:44:05 2015 +0100

    appveyor: fix OpenSSL version

commit 76ed06981bde35d979754122fc250ccbf854493d
Author: Uri Blumenthal <uri@ll.mit.edu>
Date:   Tue Dec 22 13:31:42 2015 -0500

    Made sure attribute CKA_TOKEN is set to TRUE.

commit aa4b089a419807a6517b32457743b9ac19e8312a
Author: Doug Engert <deengert@gmail.com>
Date:   Tue Dec 22 09:41:39 2015 -0600

    PIV pubkey auth_id fix
    
    pkcs15-piv.c was setting the auth_id of the public keys
    which would cause some appications to require a login to access
    a public key. The public keys are obtained from the certificates
    which do not require the PIN to read.
    
    Very early drafts of NIST 800-73 did require the PIN to access the
    certificates, and the auth_id  was removed in the opensc code for
    certificates many years ago, but not from the public keys.

commit 2b6b0ee05a0a89af72a9b3cd5bcbc3f32fe495fb
Author: Uri Blumenthal <uri@ll.mit.edu>
Date:   Mon Dec 21 12:11:48 2015 -0500

    According to PKCS#11 standard, public key should not have the
    attribute CKA_SENSITIVE set to TRUE. This attribute is for
    private and secret keys only.

commit 25dae28ab55c8aa80e323a0bddde9d41bc97dec3
Author: Uri Blumenthal <uri@ll.mit.edu>
Date:   Mon Dec 21 12:10:46 2015 -0500

    Access to public key should not be PIN-authenticated. Especially
    since access to certificate (from which one can get public key)
    is not currently PIN-authenticated.

commit 2fd32fdd731205c087b2a0d0f5766bdae836ec4e
Merge: 200b09b de42dea
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 16 08:21:03 2015 +0100

    Merge pull request #638 from ibpl/master-IB#1047758
    
    Fix smartcard certificate removal and update

commit de42deaae10dd0a198b61902169c7f4e2cb8e6da
Author: Pawel Boguslawski <pawel.boguslawski@ib.pl>
Date:   Tue Dec 15 20:09:03 2015 +0100

    Fix smartcard certificate removal and update
    
    This patch fixes bug found in opensc 0.14.0-2 (Debian 8) that blocks
    certificate update and removal on Athena ASEPCOS smartcard with error
    
        Failed to update certificate: Security status not satisfied
    
    OpenSC tries to get the parent's 'DELETE' access before cert removal
    and leaves path variable pointing to dir not file to be removed.
    
    Author-Change-Id: IB#1047758

commit e9f94d781879f7a5fb71dc89db2b9a2a80fe19fc
Author: German Blanco <german.blanco@gmail.com>
Date:   Tue Dec 15 10:43:48 2015 +0100

    Align end of the loop with comment in previous line (exit when 90 00 or length completed).

commit 47347211805578c638a0271e77e2734f23a66605
Author: Lukas Wunner <lukas@wunner.de>
Date:   Sat Oct 3 11:55:55 2015 +0200

    card-gemsafeV1: Support signing SHA256
    
    GemSAFE V1 cards support signing 36 bytes of free form data.
    When signing a hash, the hash must be prepended by the DigestInfo
    header. The PKCS#1 padding is done on the card. The 36 bytes limit
    is sufficient for MD5 (16 + 18 bytes for the header), SHA1 and
    RIPEMD160 (both use 20 + 15 bytes for the header) and MD5_SHA1
    (16 + 20 bytes, no header). The algorithm reference ("cryptographic
    mechanism reference" in ISO 7816 parlance) for signing free form data
    is 0x12.
    
    GemSAFE V3 cards changed the algorithm reference for signing free
    form data to 0x02. In addition, they gained the ability to sign SHA256.
    Since SHA256 exceeds the 36 bytes limit (32 + 19 bytes for the header),
    it must be sent to the card *without* DigestInfo header. The header
    will be prepended by the card and it is instructed to do so by sending
    algorithm reference 0x42.
    
    This scheme is also supported for SHA1, the algorithm reference is
    0x12 in this case. However using this is not necessary as SHA1 fits
    within the 36 bytes limit, including the header.
    
    Supporting SHA256 is straightforward, we just add it to the flags
    before adding the RSA algorithms. When sc_pkcs15_compute_signature()
    calls sc_get_encoding_flags(), the input will be "iFlags 0x202, card
    capabilities 0x8000021A" and the output will be "pad flags 0x0, secure
    algorithm flags 0x202". I.e. the hash is neither prepended by the
    DigestInfo header nor PKCS#1 padded and the hash algorithm is passed
    to gemsafe_set_security_env() which can send the appropriate algorithm
    reference 0x42 to the card.
    
    However there's a catch: Once we add SHA256 to the flags, PKCS#11
    applications will be unable to use the other hashes like SHA1 or
    RIPEMD160. That's because register_mechanisms() checks if the card
    supports no hashes, and if so, adds all of them:
    
    		if (!(rsa_flags & SC_ALGORITHM_RSA_HASHES)) {
    			rsa_flags |= SC_ALGORITHM_RSA_HASHES;
    		}
    
    We cannot add these missing hashes to the flags like we did with SHA256
    because like SHA256, they would be sent to the card *without* DigestInfo
    header. What we want is to send all hashes *with* DigestInfo header,
    *except* for SHA256.
    
    We can achieve that by registering a fake RSA algorithm which includes
    the missing hashes in its flags. This fake algorithm is never used
    because sc_card_find_rsa_alg() searches the algorithm list in-order
    and we register the fake algorithm *after* the real algorithms.
    
    The fake algorithm persuades register_mechanisms() to register the
    missing hashes because it ORs the flags of all RSA algorithms together:
    
    	num = card->algorithm_count;
    	while (num--) {
    		switch (alg_info->algorithm) {
    			case SC_ALGORITHM_RSA:
    				rsa_flags |= alg_info->flags;
    				break;
    		}
    	}
    
    So when signing e.g. a RIPEMD160 hash and sc_pkcs15_compute_signature()
    calls sc_get_encoding_flags(), the input will be "iFlags 0x102, card
    capabilities 0x8000021A" and the output will be "pad flags 0x100, secure
    algorithm flags 0x2". This will result in the hash being prepended by
    the DigestInfo header, which is what we want.

commit 200b09b89fb93925f69c593a18238140b85e1c02
Merge: 3732ec2 d1a1830
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Dec 14 20:50:45 2015 +0100

    Merge pull request #622 from germanblanco/dnie_memory_leaks_2
    
    Removing memory leaks in DNIe
    
    Refactoring pending. Continued from #606

commit 3732ec2936aef87ec9c577eb54a3155990eedd48
Merge: 5129c5a 06f296b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Dec 14 20:38:34 2015 +0100

    Merge pull request #635 from frankmorgner/sc-hsm
    
    minidriver: add logout function to avoid smart card reset
    
    - closes #633
    - closes #634

commit 06f296b978ceecfa9cdd3a50b0d2042d2cc668d0
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Dec 9 22:10:54 2015 +0100

    sc-hsm: implement logout function
    
    - re-selection of the applet resets the applet's state
    - removes path in key object and fixes #631

commit 57e05d33597bbce811750f472abaf58bf1da6b6e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Dec 9 21:41:37 2015 +0100

    minidriver: use sc_logout for CardDeauthenticate

commit 5129c5a06034a6b45dcd0ecc86d77bd122c156fd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 9 08:22:24 2015 +0100

    Fixed memory leaks

commit 2bb0cb2615ce02e43ff4e960e0eddf09c6599fb3
Merge: 9cc7da4 36ceb89
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Dec 8 14:34:21 2015 +0100

    Merge pull request #618 from frankmorgner/atomic
    
    Implemented atomic transactions for PKCS#11
    
    See discussion here http://opensc.1086184.n5.nabble.com/State-of-stateless-support-td15513.html
    
    fixes https://www.opensc-project.org/opensc/ticket/186
    fixes #596

commit 36ceb890ab51799b8d74995a54860e4dd856f853
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 4 09:22:15 2015 +0100

    Avoid duplicated code of handling security environment

commit ee65ab85ce41c97364d6d0cb4d7292a9b5fb02b0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Dec 3 17:51:10 2015 +0100

    Avoid duplicated code by unifying key usage

commit 5ed3df90248146f4cc5b46809bd3169acf21633d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Dec 3 17:33:21 2015 +0100

    extend PIN-revalidation to key preparation

commit 33841136168f1c2fd9787e205c8b5b3e4c3c4fc5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 2 10:24:50 2015 +0100

    reset `login_user` with `reset_login_state`

commit b43ea19320cf69dfcfaaa921b1d8d4140975b4e1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 30 02:45:11 2015 +0100

    reset login_user on  CKR_USER_NOT_LOGGED_IN

commit 43a844c94936d73e4085805fef3f31632e9b1254
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Nov 26 07:55:26 2015 +0100

    cardos 4.3+: enable logout command

commit 83ef7537998f2f307a7bfe7314d647d3242daf00
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Nov 26 07:11:06 2015 +0100

    Implemented atomic PKCS#11 transactions

commit 9cc7da4c8021fd73788c70a70f6f4959f2ffc5ed
Merge: 56d52af 5de1ec4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 2 01:57:25 2015 +0100

    Merge pull request #609 from yoe/master
    
    Allow ASN.1 decoding if the file seems incomplete

commit 5de1ec45181bb11f4287e22b496ca40c03efae12
Author: Wouter Verhelst <w@uter.be>
Date:   Tue Dec 1 16:20:17 2015 +0100

    Allow ASN.1 decoding if the file seems incomplete
    
    Some cards (e.g., BELPIC) have a hardcoded file length that does not
    match the actual file length (e.g., 65535 bytes), and simply return the
    data that is actually on the card when asked.
    
    It is useful to still be able to do an ASN.1 decode in that case.
    
    Signed-off-by: Wouter Verhelst <w@uter.be>

commit 56d52afb17f8ad9025957849ed6bea811d0b31d2
Merge: b6856e8 fa9da7a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Dec 1 11:21:35 2015 +0100

    Merge pull request #617 from mtrojnar/os_locking
    
    Enable OS locking

commit fa9da7ad01ec500266a6eedfe192e6a6e67d97f0
Author: Michał Trojnara <Michal.Trojnara@mirt.net>
Date:   Tue Dec 1 09:19:03 2015 +0100

    configurable OS thread locking

commit b6856e8dbf2afb7583373652d02f1ea06371d9e6
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 30 01:33:11 2015 +0100

    don't use unicode ticks

commit 83ed69e46a83bfe480172c12ac1c6468d4e4b548
Merge: 7a2858d b9adbae
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 30 00:43:53 2015 +0100

    Merge pull request #623 from flaviommedeiros/master
    
    Avoiding conditional directives that split up parts of statements.

commit b9adbae5f045626046e2f3977a9049a63736e23c
Author: Flavio Medeiros <flaviomotamedeiros@gmail.com>
Date:   Sat Nov 28 11:33:38 2015 -0300

    Avoiding conditional directives that split up parts of statements.

commit d1a1830115a648aedb4eec85021811b72c067a86
Author: German Blanco <german.blanco@gmail.com>
Date:   Fri Nov 27 11:32:33 2015 +0100

    Removing all memory leaks in DNIe but one. Refactoring pending.

commit 7a2858d7a63be1a5fcebc4ae9a8a567eb6a04168
Merge: a454dd7 f9e6148
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Nov 26 21:00:38 2015 +0100

    Merge pull request #616 from mtrojnar/buffer_overflow
    
    Heap-based buffer overflow fix in mutex_create() with PKCS11_THREAD_LOCKING and HAVE_PTHREAD defined

commit f9e614890da5e514106a8e2ba7c36aff423c444e
Author: Michał Trojnara <Michal.Trojnara@mirt.net>
Date:   Thu Nov 26 12:32:47 2015 +0100

    Fix a buffer overflow in thread mutex create

commit a454dd7fc9e5bb4261bfad282be1295e634f07d8
Merge: d9fc49d 1596ca4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Nov 21 19:22:07 2015 +0100

    Merge pull request #605 from germanblanco/dnie_ui_depends_on_ssl_2
    
    DNIe UI moved into card-dnie.c
    
    closes #362

commit d9fc49daa55713adf830baa1c99f3d2042c9e1a7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Nov 17 00:52:49 2015 +0100

    reader-pcsc: get tlv properties only when supported

commit 641a71a2f40dc6ec7183f297258d3f133d78b360
Merge: 53dc94d 613d698
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 16 12:29:57 2015 +0100

    Merge pull request #601 from frankmorgner/coverity
    
    Some more fixes for problems reported by Coverity scan

commit 1596ca4244dc182102cbf56195b5f4eb0613602b
Author: German Blanco <german.blanco@gmail.com>
Date:   Tue Nov 10 12:10:56 2015 +0100

    DNIe user interface moved into card-dnie.c.

commit 53dc94de1bffd15bfc0f836871d1cc0f06a119cb
Merge: fd67f79 d45c961
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Nov 10 11:00:51 2015 +0100

    Merge pull request #604 from germanblanco/dnie_ui_config_doc
    
    Adding configuration of pinentry application for DNIe.

commit d45c96106acf7b34cf86db47ded9d8c53f67b825
Author: German Blanco <german.blanco@gmail.com>
Date:   Tue Nov 10 09:37:39 2015 +0100

    Adding configuration of pinentry application for DNIe.

commit fd67f794f16cec5fdbd1bde6648f34f4ff8aaa4d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Nov 3 00:03:17 2015 +0100

    Added minimum version of OS X to pkg

commit 3bbe59fed6824cbf49430d9971eb13a3cc1f3e38
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 2 23:54:36 2015 +0100

    link README to README.md

commit f13da8abfa921cf4fd4ca1ac25deaaee452a581b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 2 23:51:28 2015 +0100

    removed unsupported opensc_pkcs11_install.js

commit d00ee08fb08ddf7bc5f7e9f88a6ed62a82dbf999
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Nov 2 22:48:52 2015 +0100

    use shield.io for badge images

commit 622b71970f3ab3e42341b3655aa59e5420369d28
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 21:02:34 2015 +0100

    add compat_report_rangecheckfailure.c to libcompat

commit d6cea60500cbdc73660e15e4849b267a5d2ffd1d
Merge: 21a8e7e 8a47f23
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 20:59:49 2015 +0100

    Merge pull request #600 from vletoux/patch_openSSL
    
    win32: link OpenSSL statically again

commit 613d698d3d236f5633cf64537b98abb7d1b35c0a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 17:13:24 2015 +0100

    fixed potential NULL dereference

commit 8a47f238de9feb410678a2504240c971e9ed7df3
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Nov 1 13:35:05 2015 +0100

    win32: link OpenSSL statically again

commit 681e8aef98a0d443c08a58ec657e1879ec90ca33
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 13:22:26 2015 +0100

    Fixed accessing Application label
    regression of 78018a2b49f3855b11d54861e1f3c39a9c4b9e5e

commit 218a9eb52c38cfdfa072bebe453ea3ba2e515014
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 13:18:39 2015 +0100

    make casting explicit

commit 98d7578113893d61063de1d65fc97e569b690fb7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 11:33:40 2015 +0100

    ctbcs.c: fixed out of bounds write

commit a649d66b02ba62f5c6ba861235e2ee68b7250d90
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:49:19 2015 +0100

    card-westcos.c: fixed dead code

commit a34d1f7dcd225fe19a34263bb2dcab26c240b99f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:44:24 2015 +0100

    sc-hsm-tool.c: fixed potential resource leak

commit 4ca7daf31c5eaba6154c919eec446297e8366895
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:44:24 2015 +0100

    pkcs15-tool.c: fixed potential resource leak

commit 5399c264fbee4b591a71890541da65f565940c96
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:44:23 2015 +0100

    cryptoflex-tool.c: fixed potential resource leak

commit c2ff4f090a6484981dcf7501646bb505b20e693e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:44:23 2015 +0100

    pkcs15-pubkey.c: fixed potential resource leak

commit 0f9645587a0566ce6a917afebcdd712c0cc4dd03
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Nov 1 10:44:23 2015 +0100

    cwa14890.c: fixed potential resource leak

commit 21a8e7e5f9e87dc8633775066ec44ded8c2f8a4a
Merge: 4513868 206eb71
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 31 02:28:21 2015 +0100

    Merge pull request #591 from vletoux/isoApplet
    
    isoApplet: fix card not recognized by minidriver

commit 451386886d208e0af9f8d4128696fc36cc9ad43a
Merge: ad5d169 8e7049c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 31 02:24:51 2015 +0100

    Merge pull request #573 from frankmorgner/coverity
    
    Fix some more memory leaks reported by Coverity

commit 8e7049c2fae29fc1f1a4d3df8ae157abe99bf8fb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 30 18:01:04 2015 +0100

    removed unused variables

commit fa9ffb7b90aee231310dcd1770ec0a8470ce3a3a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 30 17:47:02 2015 +0100

    fixed uninitialized variable
    
    regression of baab26d8718c0aca8ff92b7b47bf4f6ab7486ba7

commit 9f0087d968e847e734dc34fc37539f6db79493a5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 12 08:24:46 2015 +0200

    fixed missing includes

commit ad5d16927cd391b8329639fc3120e9f66f86eb23
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 30 16:45:22 2015 +0100

    fixed cflags for onepin module

commit 00ea7a68befd2e3ab3be2f76769844dd36d92a35
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 12 08:12:16 2015 +0200

    Removes unused variables

commit 7e29fcd26cf96d73222117571672c01d2b7b04a0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 23:37:21 2015 +0200

    pkcs15-authentic.c: fixed potential resource leak

commit f9a73c0b207da0ac05179ec77da82c5a1342804e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 23:11:03 2015 +0200

    pkcs15-sc-hsm.c: fixed potential resource leak

commit 0853ecd88704e91eeb87a964747874c4d108a0a4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 23:11:03 2015 +0200

    pkcs15-pubkey.c: fixed potential resource leak

commit 98b9b37e12b8529f8992d86f55c06bad55e4895c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 23:11:03 2015 +0200

    card-openpgp.c: fixed potential resource leak

commit 9e1a5447d4d27995ffadb13d165776bda825c363
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:58:11 2015 +0200

    profile.c: fixed potential resource leak

commit fd904fbcb8ded5462d52c53717995d5818bd66aa
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:22 2015 +0200

    pkcs15-oberthur-awp.c: fixed potential resource leak

commit e7316b60e3c50a606ad66a544b00c204103ffca4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:22 2015 +0200

    pkcs15-myeid.c: fixed potential resource leak

commit baab26d8718c0aca8ff92b7b47bf4f6ab7486ba7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:22 2015 +0200

    pkcs15-lib.c: fixed potential resource leak

commit 4f4c4aa5ecf8c1fa505ddc78fdd06d48c0b8aa34
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:21 2015 +0200

    pkcs15-iasecc.c: fixed potential resource leak

commit 34b6d95ec655ed69616223d1410dada4489e7398
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:21 2015 +0200

    card-westcos.c: fixed potential resource leak

commit ecf147099aecfb659c21f478f7336a7065c244dd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:21 2015 +0200

    card-epass2003.c: fixed potential resource leak

commit 2963588887c82cd318632517a8cb21322592f990
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 17:37:21 2015 +0200

    card-authentic.c: fixed potential resource leak

commit b96ba14aae3218b2152b7634de2f643632ce93ad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 9 11:09:57 2015 +0200

    added fall through comment

commit 7af89d0f91620e20006decdffa7500ab654fce0b
Merge: decd5ab 0caf0d1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 30 11:58:30 2015 +0100

    Merge pull request #593 from CardContact/fix_warning_from_580
    
    sc-hsm: Add missing include introduced by #580

commit 0caf0d1dd6a0f16a3213e95a5a55b763228b18df
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Thu Oct 29 13:58:42 2015 +0100

    sc-hsm: Add missing include introduced by #580

commit decd5ab987b6263bd855b683a271d10725dcf06e
Merge: c50a951 e1073c0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Oct 29 13:30:37 2015 +0100

    Merge pull request #580 from frankmorgner/select
    
    Fix issues related to selecting a file

commit c50a95133711922be994ef75879b0f2f6e1daafd
Merge: 8398d3e 9874521
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 24 23:32:42 2015 +0200

    Merge pull request #566 from vletoux/ecc_minidriver
    
    First ECC support for the minidriver

commit 8398d3e35b6f06a5b3896dd1d346746cfa0f0e66
Merge: 6b52d96 52b6505
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 24 23:27:56 2015 +0200

    Merge pull request #590 from pspacek/export_everything
    
    export all C_* symbols

commit 6b52d96029f2a6dd9036032517393974438a2404
Merge: b9936f4 5422887
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 24 23:27:40 2015 +0200

    Merge pull request #577 from frankmorgner/elcapitane
    
    Fixes build and installation on OS X 10.11

commit 206eb7124a829467d6567bac1d4b735105db7a42
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Oct 23 23:03:25 2015 +0200

    isoApplet: fix card not recognized by minidriver

commit 52b6505909fe8d4aa63c9f0a0a870a0efe7850a3
Author: Petr Spacek <pspacek@redhat.com>
Date:   Thu Oct 22 18:07:19 2015 +0200

    export all C_* symbols
    
    Header files distributed with PKCS#11 v2.30 define all functions as
    extern and some applications (like BIND 9.10) do not work without all
    functions.

commit b9936f4701426d197739aa75e47bcd98d62cc04e
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Wed Oct 21 10:15:09 2015 +0200

    github: no more 'default' Windows builds
    
    MSI are built with AppVeyor

commit 249f258ff25bd85dafad09283e9fa575d313db46
Merge: 4ddf2cc 6109a87
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 17 17:36:40 2015 +0200

    Merge pull request #584 from marschap/card-openpgp-cleanup2
    
    OpenPGP card cleanup

commit 4ddf2cc04288ed55b54015f0fb9042b4d5abddcf
Merge: 76f81b5 65bc754
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 17 17:34:39 2015 +0200

    Merge pull request #579 from dengert/piv-cac
    
    Do not expose access to PIV emulated files from utilities

commit 76f81b5b6312b6219d01751b609a2634a9269433
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri Oct 16 11:33:00 2015 +0200

    github: include status of Windows build

commit 98745219ce459dec87bf2373a5730161c44ae2a8
Merge: 35175a8 0ca4691
Author: vletoux <vletoux@users.noreply.github.com>
Date:   Fri Oct 16 11:09:43 2015 +0200

    Merge pull request #3 from frankmorgner/ecc_minidriver
    
    use tabs only for indenting

commit 0ca46910f7549f11a0dcb8c7e289d11f6e47047c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 16 09:58:01 2015 +0200

    use tabs only for indenting

commit 35175a814c05b84a2466902bc38527f6694042d8
Author: vletoux <vincent.letoux@gmail.com>
Date:   Thu Oct 15 22:40:36 2015 +0200

    minidriver: fix according to frank's comments

commit 6109a8792dc1185175c23a51f4a7d2ac016d1dc0
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 23:29:44 2015 +0200

    OpenPGP: add additional manufacturers

commit a0ca6b2ef06de29b7839187962782ac65c72a969
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 21:40:18 2015 +0200

    OpenPGP: set card's version in pgp_init()

commit 7078fbd505bedbeb8706364eebed4ffbafc905da
Author: Peter Marschall <peter@adpm.de>
Date:   Sun Sep 20 21:31:46 2015 +0200

    OpenPGP: cleanup pgp_init()
    
    - use LOG_FUNC_RETURN instead of return for symmetry with LOG_FUNC_CALLED

commit e1db96b73b2474f235cd9734d9e56a748029fd9a
Author: Peter Marschall <peter@adpm.de>
Date:   Sun Sep 20 20:36:40 2015 +0200

    OpenPGP: extend pgp_match_card()
    
    - explicitly check for supported versions
    - log successful matches by AID with their type
    - log detection of unsupported OpenPGP-type cards

commit 7c2adb1fc8ff4a897d277ac85085b24ca95e867a
Author: Peter Marschall <peter@adpm.de>
Date:   Sun Sep 20 10:52:45 2015 +0200

    OpenPGP: 1st preparations for newer versions
    
    - add references to new specs
    - add new enum _version constants

commit 69b482dce6ebda9ca3b03154b55ec6b7753077e6
Author: Peter Marschall <peter@adpm.de>
Date:   Sun Sep 20 08:49:20 2015 +0200

    OpenPGP: cleanup pgp_get_card_features()
    
    - bug fix: re-initialize index to start searching at the right place
    - get rid of unnecessary variable
    - add some line breaks & comemnts for easier understanding

commit 2a269c526732134134fb5bcb12557092dd2d8ffe
Author: Peter Marschall <peter@adpm.de>
Date:   Sat Sep 19 18:14:44 2015 +0200

    OpenPGP: cleanup pgp_build_tlv()
    
    - get rid of intermediate variable
    - clarify check in while() loop
    - line breaks for easier reading

commit 3d492ae3768f847f5dffabc988dbc8c1cfaa1c23
Author: Peter Marschall <peter@adpm.de>
Date:   Sat Sep 19 17:40:57 2015 +0200

    OpenPGP: cleanup pgp_erase_card()
    
    - get rid of unnecessary variable
    - use easily understandable hex representation of APDUs
    - auto-calculate APDU length based on hex representation
    - restrict scope of some variables
    - use sc_log() instead of directly writing to console
    - line breaks & comments for easier reading/understanding
    - fix typo in log message

commit 3d4fbd776df2a340a440db38d7a797b78255653b
Author: Peter Marschall <peter@adpm.de>
Date:   Sat Sep 19 16:52:51 2015 +0200

    OpenPGP: harmonize coding style
    
    - 2 line breaks between functions for easier reading
    - function type on separate line
    - mark each function as 'ABI' or 'Internal'
    - slightly doxygen-ize comments introducing functions
    - fix typos in comments
    - break over-long comment lines
    - break comment lines at sensible places
    - consistent calling style for DRVDATA()
    
    - no code change

commit 7ba47fd5a97ea03a16bf00c715c6da0e4f5279ed
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Sep 14 22:59:19 2015 +0200

    OpenPGP: consistently use card->ctx in pgp_put_data_plain()
    
    - get rid of unnecessary variable
    - harmonize coding style: adapt to prevailing use of card->ctx

commit 1a05f968bdfe779522ff9dfffffcdcfda4877a1a
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Sep 14 22:27:43 2015 +0200

    OpenPGP: simplify gnuk_write_certificate()
    
    - get rid of unnecessary variables
    - use for-loop to initialize/check/increase run variable in one place
    - restrict variables to the necessary scope
    - use ternary operator inside a statement instead of if...else...

commit d2b1c8228f19741a59d26f071e4cc238f4b65f45
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Sep 14 22:01:00 2015 +0200

    OpenPGP: set apdu_case on declaration
    
    - use ternary operator to set apdu_case immediately on declaration
      for the GNUK and non-GNUK case

commit 3341c5bb8f97de858a27e5350236817bc5c8e0bc
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Sep 14 21:48:48 2015 +0200

    OpenPGP: make logical structure clearer
    
    - one line per sub-term in the condition of the conditional statement

commit e316bf31407b0ab9119979553e0cb2eecc3ba9c5
Merge: 71aa6bb 7de373b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Oct 15 13:13:18 2015 +0200

    Merge pull request #582 from marschap/openpgp-tool-fixes
    
    Openpgp tool fixes

commit 71aa6bbced540509c817f3aa45b582fb3756a27d
Merge: 851e0a2 6498721
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Oct 15 13:09:56 2015 +0200

    Merge pull request #581 from marschap/piv-doc-fixes
    
    piv: fix typos in usage & man page

commit 6498721076d0fbeda86dfd1af6bd04820bc09640
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 11:55:13 2015 +0200

    piv: fix typos in usage & man page

commit 7de373b3b947a8da1c7f22246ec0cb093f6a25cf
Author: Peter Marschall <peter@adpm.de>
Date:   Tue Oct 13 13:04:19 2015 +0200

    OpenPGP: mark do_erase as an action in openpgp-tool
    
    - avoid the unintended output of user info when only erasing was requested

commit 524ad56146f1fd07139924822971097c8f311eba
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 21:07:58 2015 +0200

    OpenPGP: remove unnecessary semicolons in openpgp-tool
    
    - this is C, not a shell script

commit 392bc08d8613202a58a8c97069e8b0c1fef3bcae
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 16:40:59 2015 +0200

    OpenPGP: fix pretty name for gender code 39 in openpgp-tool
    
    - use the same term that GnuPG uses

commit e79f1f4b01fa03afc01318d1b88cc4a5ce62f246
Author: Peter Marschall <peter@adpm.de>
Date:   Mon Oct 12 12:37:40 2015 +0200

    OpenPGP: accept -E as option in openpgp-tool
    
    - make behaviour match the usage message by accepting '-E' as
      alternative short form of '--erase'

commit e1073c09eac5238d636219def5eb2623a919b0f9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 23:22:35 2015 +0200

    handle checking of file output in sc_select_file
    
    fixes https://github.com/OpenSC/OpenSC/issues/576

commit bcf9b2bc84715c626c496b7637ffe1f03dcb2d3a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 23:13:27 2015 +0200

    added error checking

commit e634169a9204d3cea15d50b9547ce0fe75cb191a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 23:10:48 2015 +0200

    added error checking

commit c371c3b5ecfe8c5003ea1d453275cc4de3f3fbe9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 23:08:39 2015 +0200

    removed unused variable

commit f9011b7dc02c45d5e01044946544a51d0ad69095
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:57:10 2015 +0200

    fixed indenting

commit 4f13fde7f160099508878c3f139ea22d51102bf8
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:56:53 2015 +0200

    use size_t for a length instead of int

commit 4275dac4953510d167f5b699d9ef3a536c22a82a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:51:55 2015 +0200

    fixed indenting

commit 0bf1f3755ce0b581762ff16232cff042e017d6fb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:48:45 2015 +0200

    removed unused variable

commit fed64b0636475ff4a114c102e1cf4ea7ab54ae0e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Oct 14 22:48:41 2015 +0200

    minidriver: fixes according to Frank's comments

commit 949d8614d2c428a5ef2cf5d2690d0917aebd51e8
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:46:55 2015 +0200

    removed unused variable

commit 0258c91f300899320e78bfc1e5f3fbeb69f30fd3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:43:12 2015 +0200

    removed unused variable

commit 0a966160340f27b8baa281c6bca140199ebf44dc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:37:33 2015 +0200

    remove unused variable

commit 6573a93d4b1bd234d1c79c56dc3c7ae7b0f26ddc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:37:12 2015 +0200

    fixed memory leak

commit a5685b537eb2cebe3671181b88c7a7572310ef94
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:34:44 2015 +0200

    fixed memory leak

commit 15f204c5d6f877557230185ca8a622b5890c54cc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:32:51 2015 +0200

    fixed indenting

commit 895005f4df9bf94c277e60e4c7698cd5ccb3605d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:28:49 2015 +0200

    added error checking

commit 65bc754b8b86edaa36f62d01dd4ca16c8953c360
Author: Doug Engert <deengert@gmail.com>
Date:   Wed Oct 14 15:04:34 2015 -0500

    Do not expose access to PIV emulated files from utilities
    
    PIV cards uses get/put data not select file and read_binary.
    To allow access via pkcs15 emulation card-piv.c emulates
    select_file and read_binary but only when used with the path as
    created by the piv emulation.
    
    There are no MF.DIR or ED.DIR files.
    opensc-tool and opensc-explorer will not work with this emulation.
    
    Patch removes code that caused problems with opensc-tooland opensc-explorer.

commit 00daa3f53566d46d7728e7dc59617879b08a3cf6
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:27:32 2015 +0200

    added error checking

commit 9a82ddea8aa8d119e0d2890b6fcd79c2c3da7aa4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:26:53 2015 +0200

    fixed memory leak

commit 3916117008f040cc0243c927c5b1a089897907b6
Merge: 747678c 75d76f5
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Oct 14 22:23:18 2015 +0200

    Merge branch 'OpenSC-master' into ecc_minidriver

commit 75d76f5ce4c18f3b276bf9337aa17d514e12f8dc
Merge: 747678c 851e0a2
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Oct 14 22:22:19 2015 +0200

    Merge branch 'master' of https://github.com/OpenSC/OpenSC into OpenSC-master
    
    Conflicts:
    	src/minidriver/minidriver.c

commit 5558b9d3689d3d4656407cbc586287e163aa86a2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:17:33 2015 +0200

    removed unused parameters

commit 2ed4c8ae6cdf6a5fcc5f5b18e4546a26ccadf87c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:16:44 2015 +0200

    Adds error checking

commit 94772c870ab9569642cf4396302cc2f5d11297ad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:15:17 2015 +0200

    Adds error checking

commit c9420046c5d11f7bc6eee4eb61852ee7794b2152
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:08:14 2015 +0200

    Removed unused parameter

commit 77b5138860725e3784a777eb0fde28affe283e76
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 22:02:35 2015 +0200

    Removed unused parameter

commit 851e0a24ff383df5c8a3e1560c6def3dab3bf022
Merge: ee59157 a6b3650
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 18:56:29 2015 +0200

    Merge pull request #571 from frankmorgner/label
    
    Fixes accessing fixed size arrays

commit 5422887f9b157b2050f286ca81fa7614cf225c8b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 14:03:51 2015 +0200

    reflect dependency to OS X 10.10 in dmg description

commit 094179ce5c6daefc20c7767415e44187ff0a9b4d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 11:37:18 2015 +0200

    '.so' is also the OS X suffix for pkcs11

commit b9b3b2a86ee3038dba5d0d7db8ca68d41c860e38
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 14 09:16:23 2015 +0200

    check for OpenSSL headers in auto-detection
    
    OpenSSL headers have been removed on El Capitane which renders it
    unusable for us.

commit bccf2120cdf3ae457fccd6af62dbeb660e931514
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 13 15:05:28 2015 +0200

    use PREFIX as shortcut in build script

commit 66415690d943c78e029596e492e1947bbadedbfb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 13 15:01:40 2015 +0200

    OSX: link pkcs11 library to /usr/local/lib
    
    Circumvents SIP on El Capitan

commit ee5915700c0f4dfba09cf705d891c5b1de56b671
Merge: a912004 da1d4cc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 13 14:11:29 2015 +0200

    Merge pull request #516 from frankmorgner/lock
    
    Only re-lock for Windows and Apple

commit a912004a7ff646b9403b8f1966e39f9f8fed17e5
Merge: 5dd8068 0b268f7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 12 17:28:42 2015 +0200

    Merge pull request #574 from dengert/piv-cac
    
    Partial fix for #570. Select AID for PIV

commit 0b268f789aa077dd3a9fa6b51060e7b4287eadfd
Author: Doug Engert <deengert@gmail.com>
Date:   Sun Oct 11 19:14:02 2015 -0500

    Allow PIV driver to use cards where default application in not PIV
    
    card-piv.c was not selecting the PIV AID correctly from piv_find_aid.
    This cause a CAC card that also has the PIV application to fail a VERIFY command
    of the pin would use a VERIFY  APDU P2 where P2 for PIV is 80, but for CAC was 00.
    
    A CAC card could work if the caller requested the serial number of the card
    which did call piv_select_aid. All the OpenSC tools, minidriver and
    PKCS#11 do this, but Tokend does not.
    
    This is a partial fix for https://github.com/OpenSC/OpenSC/issues/570.
    Tokend in later MacOS versions still has other issues.
    
    A  more complete solution is needed for cards with multiple applications.
    
    I do not have a CAC card or MAC to do any testing.
    
    Thanks to https://github.com/mouse07410 who has a CAC card, and a Mac,
    and has tested this fix.

commit 747678c83d4dd583bfb2582674682a96b9d25260
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Oct 11 18:51:36 2015 +0200

    minidriver: remove unnecessary logs on console (certutil -scinfo)

commit b968fcfb1fea948e2e2a374ef344ba9a9e484f96
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Oct 11 15:20:04 2015 +0200

    minidriver: Windows x509 enrollment works
    
    Removed cmap_record in sc_pkcs15_prkey_info (not used by any driver nor code)
    Remove cardcf specific code (cardcf neutralized by CP_CACHE_MODE_NO_CACHE and it maintened by the Base CSP/KSP, not the minidriver)
    Add conversion code for Windows GUID / OpenSC self computed GUID

commit bee1a450c9e0b9cdf9a56e5a14a533938303c2e4
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Oct 11 10:39:02 2015 +0200

    minidriver: modified configuration functions

commit 7551baafbda858c6c272c43197f9e478b080252a
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 10 22:07:49 2015 +0200

    minidriver: add crt secure functions (*_s)

commit ebfb76d3119bbd87d7eef6abb4373cbbbc7c3189
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 10 19:01:14 2015 +0200

    minidriver: fix library import for guid & one compilation warning

commit 8f4420cb78e68b64ee965d75af697866100875af
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 10 15:39:27 2015 +0200

    minidriver: factorize container naming code

commit 227f48d7b0ea54c6e9a4cacf29ffbcf7203d4655
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 10 14:15:23 2015 +0200

    minidriver: replace one sprintf by sprintf_s

commit da1d4cc78a3f150761c4d636aec98f7698c91687
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 7 17:55:53 2015 +0200

    Fix locking issue on OS X
    
    Works around Apple shipping PCSC-Lite headers without PCSC-Lite. Let's
    say they do it for "backward compatibility"...

commit a6b36507a3822787fa103596b338892408934086
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 6 22:48:52 2015 +0200

    removed unused parent in md directory/file

commit d18ddcb446fda466cdcb07234fa8c7f4a6d5d85e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 6 22:47:50 2015 +0200

    fixed accessing fixed size md file/directory name

commit 6c61bf6815cbe7a0d04300f1db42e9906055e7c0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Oct 6 08:21:20 2015 +0200

    fixed accessing fixed size guid

commit 5dd806815de8ee56c4458a6a00ec7404aa6241b8
Merge: b7f794a f42a1c2
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Mon Oct 5 21:15:33 2015 +0200

    Merge pull request #572 from okirch/email-fixup-olaf
    
    Update outdated address okir@lst.de -> okir@suse.de

commit f42a1c25637e8b88286737f9fbd7054979e3c53c
Author: Olaf Kirch <okir@suse.de>
Date:   Mon Oct 5 14:06:23 2015 +0200

    Replace outdated address okir@lst.de -> okir@suse.de
    
    Signed-off-by: Olaf Kirch <okir@suse.de>

commit 137afb10b794a9f7bed99c7d396b30f0a9188485
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 5 08:30:47 2015 +0200

    Check for NUL in label to test its presence

commit 5b0332528f27b2d71c9b73b467e28d55e317d0b2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 5 08:23:02 2015 +0200

    fixed accessing app_label in sc_pkcs15_data_info_t

commit 811a86e72a3974326c8fd38e3847393bfd1f58ed
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Oct 4 19:49:31 2015 +0200

    fix: set the container name as the id if md_guid_as_label is set

commit f9cd1fc47603dbd62f9053a75f3e4fb491da0ba5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:53:51 2015 +0200

    fixed accessing fixed size cvc members

commit 161e84f06609ba511c15a299873ae0dee4265a59
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pkcs15-tool.c: fixed accessing label in sc_pkcs15_object_t

commit 35f028a57cb8a655abc5dd4da6c967b1ece68b30
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pkcs15-init.c: fixed accessing label in sc_pkcs15_object_t

commit d709347c2b8994a2417e8cf57100248a1fe519a1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pkcs15-crypt.c: fixed accessing label in sc_pkcs15_object_t

commit 191af692c89f320325720458dee6ec6d6438a8bd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    print.c: fixed accessing label in sc_pkcs15_object_t

commit e171789dad161494d01b09648db18eee5b6c368b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pintest.c: fixed accessing label in sc_pkcs15_object_t

commit 7c1feb1b8a217c88a1baf2845e0b6069cbe248c8
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pkcs15-oberthur.c: fixed accessing label in sc_pkcs15_object_t

commit fa3f4d632c9e10fa106d6c79688d6956261ff4b3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    pkcs15-lib.c: fixed accessing label in sc_pkcs15_object_t

commit 1046d951ba079420b6150e30783b35733a8908da
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    framework-pkcs15.c: fixed accessing label in sc_pkcs15_object_t

commit c56fe19b313b078b8f0e5932d34f21f7927878ad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 17:33:14 2015 +0200

    minidriver.c: fixed accessing label in sc_pkcs15_object_t

commit b7f794ae48c6be2e9e905b1bd1442a4f022f8d47
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 14:04:57 2015 +0200

    AppVeyor: build with zlib on 32 bit only

commit 64417c271e72fa4733f5b1298344b4247dffd9ff
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 13:10:20 2015 +0200

    fixed out of bounds access

commit 78018a2b49f3855b11d54861e1f3c39a9c4b9e5e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 13:07:39 2015 +0200

    fixed string operation on fixed size array

commit d33517a58b2b59ae9c75c5587df68e245a75f782
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 12:55:25 2015 +0200

    fixed missing comma

commit 9e500e0b9a1f7a3f90c02cb86d98ddcf0a51e65f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 12:52:49 2015 +0200

    fixed bad typecast

commit 50e81d1de09c126b94ca275e9f78869c79451cf2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Oct 4 12:45:25 2015 +0200

    added missing break

commit 3edf32ca9cc7fc0951f0a03276cc460f543e5079
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 3 19:41:34 2015 +0200

    fix: when exporting immediatly an ECC key when the ECC key just has been created
    
    This test case is triggered when requesting a ECC certificate from ADCS:
    NCryptCreatePersistedKey followed by NCryptExportKey

commit c3f2cb142f2e66bacefcf4a53bff744954687c87
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 3 18:59:52 2015 +0200

    fix "use guid as label"
    
    Allow to use as pkcs15 label the windows container name (max: 39 characters)

commit b6676457975c5e9a92a2a63994342e0a8a289b81
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Oct 3 18:56:19 2015 +0200

    fix compilation warning

commit ac65af06692891b6bac6506cdc22018eb0d12adf
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Oct 3 12:48:56 2015 +0200

    Fixes unreleased locks with pcsc-lite
    
    This is a bug in PCSC-Lite propably won't be fixed, see
    https://alioth.debian.org/tracker/index.php?func=detail&aid=315083&group_id=30105&atid=410088
    
    Fixes https://github.com/OpenSC/OpenSC/issues/480
    Closes https://github.com/OpenSC/OpenSC/pull/487

commit 5e242c5fb21febd56fefed87cd6a5f6e9ad423c7
Merge: a153631 7fd4edf
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 2 15:18:14 2015 +0200

    Merge pull request #560 from CardContact/fix_sc_pkcs15init_finalize_profile
    
    Removed error check to support card with PKCS#15 emulation but no mat…

commit a15363198c2f5b9a4fc0a636cb35bc055e72b4d0
Merge: 4f4643e 34d6c10
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 2 15:16:42 2015 +0200

    Merge pull request #569 from mdealencar/patch-2
    
    fix: change SC_TERMINATE (undefined) to SC_CTX_FLAG_TERMINATE

commit 4f4643ee3e06b0e5af9eb615f25ae902588f66c1
Merge: e0a4e0b c399bc9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 2 15:13:34 2015 +0200

    Merge pull request #452 from frankmorgner/memory-leaks
    
    Fix some memory leaks

commit e0a4e0bfecfe2ab843134a4c7b3fae429a879971
Merge: f851197 16fb74c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 2 15:13:07 2015 +0200

    Merge pull request #532 from frankmorgner/sloppy
    
    implemented sloppy initialization for C_GetSlotInfo

commit f85119712983928a2394b2812df81389f5d0ba94
Merge: c5cf4f6 90fb40f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Oct 2 15:12:41 2015 +0200

    Merge pull request #565 from frankmorgner/sm-openssl
    
    Build a lightweight version of OpenSC

commit 34d6c10fa090592cd8d919c7e21095d6ee97704d
Author: mdealencar <mdealencar@gmail.com>
Date:   Thu Oct 1 08:38:23 2015 -0300

    fix: change SC_TERMINATE (undefined) to SC_CTX_FLAG_TERMINATE
    
    This file was not compiling because SC_TERMINATE is not defined anywhere. It seems like the intended expression is what I propose.

commit 16fb74cca96b7708e1cbc696dd63c11533b61b5b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Oct 1 07:45:59 2015 +0200

    fixed generating opensc.conf in AppVeyor

commit 1480a4ef4a0e6a7948dc236cbae95da22fd8e0ae
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 30 08:20:19 2015 +0200

    use one configuration file for all systems

commit a4ca19019e9538f3707abe137ddbe3f51d5210f3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 25 09:25:09 2015 +0200

    Documented whitelisting drivers with opensc.conf
    
    closes https://github.com/OpenSC/OpenSC/issues/358

commit 7b677837a0d2809bff800d4ebc857ce2a4e9cfe1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 25 09:22:56 2015 +0200

    Always uses tabs instead of spaces in opensc.conf

commit f252277fab64a50214779dc8f3dbaeb7481e1bf5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 16 07:16:21 2015 +0200

    Add configuration for sloppy PKCS#11 initialization

commit 3307dd6f452325721762471689e310f260fc66b5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Aug 23 23:41:54 2015 +0200

    implemented sloppy initialization for C_GetSlotInfo
    
    Makes things work for Java and closes #523

commit a9897f995661cb2e655ce8b8811c6b30a855c9ca
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Sep 30 22:52:37 2015 +0200

    First implementation of CardDeleteContainer
    
    Container now can be created, deleted, in short, a read write card

commit 67740fb9554fc7f386f3b547ab6f99f58790cfcf
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Sep 30 22:49:41 2015 +0200

    quality improvement of CardDeriveKey

commit 9a590d64e4a87d26d45d5e9606411c1bee8ef242
Author: vletoux <vincent.letoux@gmail.com>
Date:   Wed Sep 30 22:47:16 2015 +0200

    do not reset the authentication state before each operation

commit c5cf4f69a27ad545e492c4db6c29c8ef37488624
Merge: fb705b6 328176d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 30 08:14:25 2015 +0200

    Merge pull request #559 from philipWendland/ecc-sig-format
    
    ECDSA helper functions: strip zeroes when converting from R,S to sequence

commit 90fb40f65e028b9337b224364076734fad8afc49
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 30 07:13:59 2015 +0200

    include zlib1.dll and libeay32.dll in installer

commit 9f7583a022caa3582857586f621cecef87fb6a56
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 30 06:26:13 2015 +0200

    fixed indenting error in Makefile

commit fb705b6a2d4e73513ac4d0da901934dd16ec806a
Merge: 7120a9b 83a28a1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Sep 29 20:09:00 2015 +0200

    Merge pull request #563 from CardContact/fix_reselect_applet_for_pin_verification
    
    Fix reselect applet for pin verification

commit c00f9830babfcffa73697c378bc4a746d2e42e5e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Sep 25 22:56:26 2015 +0200

    force recompilation on integration plateforms

commit 701d45e89de8dbb5a2ab8da4d0958012d4fa55a1
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Sep 25 22:30:11 2015 +0200

    fix delay load library import

commit 6cbeea3942d65d3f25fda3f311049736bb4903b7
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Sep 25 22:22:29 2015 +0200

    First ECC support for the minidriver

commit 83a28a1bc3214ccda38bc337d1da5028dea08198
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Fri Sep 25 11:56:32 2015 +0200

    pkcs15: Observe path.aid for PIN operation

commit 7fd4edf7b61c5d66690b11f3cbb581595b67f9f0
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Sun Sep 20 23:12:58 2015 +0200

    Allow cards without EF.DIR using default application
    
    Removed error check to support card with PKCS#15 emulation but no matching card app

commit 7120a9b549ba55f2ebac41300e129b9fe95dd454
Merge: 4814863 1e2a42d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 25 11:13:17 2015 +0200

    Merge pull request #554 from frankmorgner/fixes
    
    Some more fixes for problems reported by Coverity scan

commit 30c90448fbbdfce92b441d2d6aedb56b5a0a47e4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 24 16:41:22 2015 +0200

    Adds missing Advapi32.lib to opensc_a.lib

commit a7bd14c77f4f0645325a5ff5ae00edfb968d90b2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 23 08:21:57 2015 +0200

    Builds lightweight Windows binaries by default
    
    ... without OpenSSL and zlib

commit 97f8731402ba6a52e01ebaacc2b69059d0bfa512
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 24 09:40:52 2015 +0200

    Properly describe OpenSSL dependencies in WiX installer

commit d8d47bb06fdc405c5367528547357e5ac6411694
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Sep 23 15:38:57 2015 +0200

    sc-hsm: Bind PIN object to applet aid to ensure SELECT before PIN verification

commit c41153aa134a966c984271c2afe4830160ac5e3f
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Sep 23 15:36:56 2015 +0200

    pkcs15: Select application defined by path.aid for PIN verification

commit e14e02845394711d94e3ceb846ace3b1bbca897b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 23 08:23:28 2015 +0200

    Properly describe OpenSSL dependencies in .mak files

commit ffd85adae78d4f49fcd9de66e7cb6cc17ffe5e77
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 23 08:32:58 2015 +0200

    Decouples SM from OpenSSL

commit 4814863d188f4fbbd516017d851c95cfa5640d3f
Merge: bc9e42d d20290d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 21 13:23:18 2015 +0200

    Merge pull request #551 from frankmorgner/507
    
    Fix OpenPGP driver to work correctly with YubiKey NEO

commit 328176d28b73787a0c74a8f065c5318288c27fd0
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Sep 18 17:37:36 2015 +0200

    ECDSA helper functions: strip zeroes when converting from R,S to sequence
    
    For ECDSA signatures, there are multiple ways to format the signature:
    - R|S (R and S filled with zeroes at the most significant bytes)
    - ASN1 sequence of R,S integers (e.g. used by OpenSSL).
    
    It is rare that the filling with zeroes is needed.
    But if it is, in the second case, the filling zeroes should not be there
    or the verification of the signature by OpenSSL will fail.

commit bc9e42ddd761729c283b62b8fa8ad2aedd0f9243
Merge: ba02d69 09fb1e7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 18 17:54:12 2015 +0200

    Merge pull request #556 from philipWendland/dead-code
    
    IsoApplet: fix dead code + pincache

commit 09fb1e71a9f3f849f89307262277728b7d6256d4
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Sep 18 16:41:28 2015 +0200

    IsoApplet: add PIN to pincache upon creation

commit 6bffeb7a363a4d17b5acc4ed927f6ec02ff5adf7
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Sep 18 16:34:31 2015 +0200

    IsoApplet: fix dead code

commit ba02d69f2bc255f4580698ab4d600d98fecb13ae
Merge: 547494f 24a3999
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 18 10:13:23 2015 +0200

    Merge pull request #555 from dengert/piv-readability
    
    Fix indentation for readability

commit 24a39993865390e1c3fa7bd1d01f12d755d1cf3b
Author: Doug Engert <deengert@gmail.com>
Date:   Thu Sep 17 19:03:44 2015 -0500

    Fix indentation for readability

commit c399bc94ec25effb00d0dee16d529991b4e74070
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:30 2015 +0200

    piv-tool: fixed resource leak

commit 2dca6ced06675b3bc8015e5b119042237dda6bab
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    pkcs15-oberthur: fixed resource leak

commit 4e280b4741e1dee283eabe4b2ff88182def84c7c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    pkcs15-lib: fixed resource leak

commit 5854aff155501f98c169283170d4ca79bddf73a7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    pkcs15-epass2003: fixed resource leak

commit 4fd359406e0e56b38a77041f3c38d1d99079c22e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    iasecc-sdo: fixed resource leak

commit 1308fd06183758a3bef3d1b55603c0c9322dd581
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    cwa14890: fixed resource leak

commit 7fe4819a025a7e964f06b5777945463469e2e48b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    card-tcos: fixed resource leak

commit 1e2a42dae582ee48c601d821f76c77d0b85ea988
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 22:11:22 2015 +0200

    Fixes warning about unused variables

commit fe31aceacb86a02d138748e316de7af25269f551
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 22:04:22 2015 +0200

    Fixes signature of iasecc_read_public_key

commit be073396be865c3b35c670a1abfab9e6d259639d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:50:19 2015 +0200

    Fixes warnings about unused variables/functions

commit 0fe282414f17777487cb6bd09ca7897f1f595a7e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:24:10 2015 +0200

    Fixed warning about unused function

commit 5902587889f8d70499ad76366af044a7e5a0be70
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:22:08 2015 +0200

    Removed dead code

commit c22ffd95bf7932cfe230d59e2b92a9aa69f345be
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:21:37 2015 +0200

    Fixed warning about unused variable

commit 6c01750ba80e57f4be35c9f4e8e34ee2dec321fa
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:17:17 2015 +0200

    Removes dead code

commit e4bce1ca6126efb1eed3acd1c943af2875abc6a2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:16:05 2015 +0200

    Fixes dependency on uninitialized data

commit 07038225a74a738f1916e882d97a45ac4b344c13
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:14:49 2015 +0200

    Fixes out of bounds read

commit 69320f9d54605f1c4d18ef9843f4a0a9582bb0a7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 21:11:05 2015 +0200

    Checks for out of bounds write

commit f08985086ac31f3b5a74b1b5637ac8f3339e8753
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:59:01 2015 +0200

    Fixes potential buffer overrun

commit 69de207c21deaa9bd6aef9b69d7d3167cd845cee
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:48:08 2015 +0200

    Fixes bad type cast

commit 59254d9d88a0023c32698fb109405180189817b7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:40:02 2015 +0200

    Checks on errors for ftell and fseek

commit b5de72fe13b3f2246963ebd7fa48c6a2bc8fb68c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:32:32 2015 +0200

    fix potention NULL deref

commit 63a9ad79b6ffb609758c643a0797f59498ec71a0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:30:10 2015 +0200

    Assumes that p15card->card are set
    
    The check for NULL was bogus anyway

commit 8a225eb42b067c07f674b10432464538a2ca9106
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:21:05 2015 +0200

    Avoids potential NULL pointer deref

commit 30d4f52718437cb998a26ab926698386fd949e15
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:11:03 2015 +0200

    Checks untrusted input

commit ba3890f8e0280e68f91cc4d0ce235d11c6319560
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:07:46 2015 +0200

    Checks result of calloc

commit de58f5101236f6a1b835cc8304fbf230d6aa1af4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 20:06:19 2015 +0200

    msc: check the length of input

commit 547494f01215718b3cb9798bee451756d37c6980
Merge: bdb856f 989c06b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 13:23:56 2015 +0200

    Merge pull request #552 from frankmorgner/innosetup
    
    Improve the state of travis ci

commit bdb856ffa2eeaecca21c5482002f2a7c4aec7978
Merge: cc6d767 8aba7b9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 17 13:23:14 2015 +0200

    Merge pull request #553 from frankmorgner/488
    
    added missing files to WiX installer

commit d20290d2b3bb9364a9c8cb5b9321780807207147
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jul 29 00:26:19 2015 +0200

    openpgp: match application, not ATR
    
    fixes #391
    closes #507

commit b28c48afe0f5c231a4437230ac5216bf8697b3ae
Author: Robert Ou <rqou@robertou.com>
Date:   Sat Aug 1 02:25:31 2015 -0700

    Fix OpenPGP driver to work correctly with YubiKey NEO

commit 8aba7b9598395c97091f70cf82076a99cce43b3f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 16 03:00:12 2015 +0200

    added missing files to WiX installer
    
    fixes https://github.com/OpenSC/OpenSC/issues/488

commit 989c06b25d2080567dd494a3c929c23af63aad9c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Sep 15 16:10:23 2015 +0200

    OSX: don't ship with libp11/engine_pkcs11 anymore
    
    both spin off projects should ship with a separate installer. See
    discussion here https://github.com/OpenSC/OpenSC/issues/488

commit 8fe89743330a714ef46e1e32c80ea153f1dd8909
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Sep 15 08:57:03 2015 +0200

    Uses container based travis and caching

commit fcfb0cebeebbef1084e8d5e5e4ee3a83be81326c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 22:45:13 2015 +0200

    build cross compiled installer with innosetup

commit a524b4a0e370f5c84f1af18d6299254f7e93d48a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 22:18:17 2015 +0200

    Removes obsolete windows installer files

commit 69783f4e6cb5d803d401aa73b1093dc3e0f65e88
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 22:11:49 2015 +0200

    Unifies project wide vendor/product strings

commit cc6d7677da5f254b1f4c9c84c94b50ffaf75ba4c
Merge: bf65454 d794baf
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 18:35:54 2015 +0200

    Merge pull request #550 from frankmorgner/appveyor
    
    adjust Make.rules.mak to work with AppVeyor

commit bf654540c5b30cb945cf02b58d18feee55177593
Merge: 89be9d6 d551f9a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 12:41:37 2015 +0200

    Merge pull request #545 from frankmorgner/duplicate
    
    avoid registering pkcs11 mechanisms multiple times

commit d794baf0c6f64d0f3c58dc295a47e5b1476b13b2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 14 07:49:51 2015 +0200

    Add workaround for canceling pending build jobs
    
    As suggested here
    https://github.com/appveyor/ci/issues/38#issuecomment-70628826

commit fb9dfc5b713c02180378fcea74dea30bea60fa03
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Sep 13 14:18:34 2015 +0200

    fixed warnings about possible data loss

commit f2614263030871ba6751ccc9a5c06df56ef5ee92
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Sep 13 10:56:28 2015 +0200

    travis: cross compile for 64 bit windows

commit 428385d8b44888482d1e3d066d930258194a5285
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 11 10:55:34 2015 +0200

    adjust Make.rules.mak to work with AppVeyor
    
    - The AppVeyor configuration of VS2014/VS2015 does not currently work
      with this script
    - We are using the pre-built zlib binaries. As consequence, we can build
      the 32 bit installer only. Also, we can't use static linking anymore
    - The current pre-built binaries of OpenSSL from
      https://slproweb.com/products/Win32OpenSSL.html include security
      measures (https://blogs.microsoft.com/cybertrust/2012/01/26/enhancements-to-gs-in-visual-studio-11/)
      that are not compatible with our version of VS `(error LNK2001:
      unresolved external symbol ___report_rangecheckfailure)`. That's why
      we can't use static linking anymore
    
    works with
    - OpenSSL 1.0.2
    - zlib 2.1.8
    - WiX 3.10

commit 89be9d6e1857299f0d60f97c1d6847d874dae6d7
Merge: a906c6d 76b6b48
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Sep 13 22:45:37 2015 +0200

    Merge pull request #303 from hongquan/gnuk
    
    Gnuk support

commit 76b6b483c74499018b2a5b0661208b6d18c0e1b6
Merge: a64bbc5 a906c6d
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Sep 13 22:09:59 2015 +0800

    Merge branch 'master' into gnuk

commit a906c6d7b82e3f570834040ee8fc4f4e071365f3
Merge: 5944915 2897e6f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Sep 12 18:51:10 2015 +0200

    Merge pull request #530 from NWilson/yubikey-neo-pin
    
    Yubikey NEO pin functions support

commit 5944915e0ef8d8af73c5c41deb9f12c6d35b80c0
Merge: 0f2b9a4 6e3f94b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 11 12:47:04 2015 +0200

    Merge pull request #549 from frankmorgner/547
    
    fixed bad string comparison

commit 0f2b9a4a4e3dd155da5b5070a0c31b8d1e787e04
Merge: 17c0ffc 819a668
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 10 16:40:58 2015 +0200

    Merge pull request #543 from frankmorgner/appveyor
    
    Use AppVeyor as good as we can

commit 819a6686c91548cba4dbc1bfc9fb422c66d9a5ae
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 9 14:51:09 2015 +0200

    use _WIN32 instead of WIN32

commit b40e2226b2009f8162c85aec03100fa8a92f87d2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 4 00:01:44 2015 +0200

    AppVeyor: build with cccl wrapper for windows
    
    currently every job finally fails, but at least we can see most
    compilation errors

commit 17c0ffc17e840289e4322340460b26cb0b61ad69
Merge: b0c1e1f b2508b6
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 10 09:41:07 2015 +0200

    Merge pull request #520 from frankmorgner/vendor-product
    
    added call back for getting vendor/product id

commit 6e3f94b3c9c694c872a364919604a6e3ef56ecb7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 10 08:31:30 2015 +0200

    fixed bad string comparison
    
    fixes #547

commit d551f9a8e0e5f605687a2f99713a51a4fba93c32
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Sep 7 09:53:02 2015 +0200

    avoid registering pkcs11 mechanisms multiple times
    
    fixes #349

commit b0c1e1fc89c5e5a891f2e6cc7760ee7dad0d6f4a
Merge: 0930803 e9b1b2e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 4 15:31:16 2015 +0200

    Merge pull request #540 from nioncode/readDataObjectRawOption
    
    add '--raw' option to pkcs15-tools '--read-data-object'

commit e9b1b2e9e8cf540f3cb4d5f7e4447a71e7bac603
Author: Nicolas Schneider <nioncode+git@gmail.com>
Date:   Fri Sep 4 13:09:54 2015 +0200

    update pkcs15 documentation to describe --raw option

commit f44e229865ec063d103feeee8de32d64b1c1d659
Author: Nicolas Schneider <nioncode+git@gmail.com>
Date:   Fri Sep 4 13:04:24 2015 +0200

    update help message to clarify that --raw only affects stdout behavior

commit 09308033004a54e16eff153f6b28d7681aa5df28
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Fri Sep 4 09:01:20 2015 +0200

    add AppVeyor build status
    
    For now it uses my own appveyor account.
    Maybe it is possible to use an OpenSC team appveyor account or something like that instead.

commit 1d4c38402695dd2336598afc5ed7c4b0983b2d21
Merge: 10aa2d8 72e25db
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Sep 4 08:19:48 2015 +0200

    Merge pull request #542 from CardContact/fixv20
    
    sc-hsm: Add status info support for SmartCard-HSM V2.0

commit 72e25db360fd4d3dadd3c8bd5e40d7da2a4c967a
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Thu Sep 3 21:18:40 2015 +0200

    sc-hsm: Add status info support for SmartCard-HSM V2.0

commit 10aa2d826987c9006e7b888dcf525623a6a86723
Merge: a52b292 69f92fa
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Thu Sep 3 20:57:19 2015 +0200

    Merge pull request #541 from frankmorgner/appveyor
    
    added appveyor configuration

commit 69f92faec5009e7c3296993668ddd659993038e4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 3 16:02:26 2015 +0200

    added appveyor configuration

commit 68796edf36c610baef90755863f01ae7aab6a223
Author: Nicolas Schneider <nioncode+git@gmail.com>
Date:   Thu Sep 3 15:09:23 2015 +0200

    add '--raw' option to output 8 bit data instead of its hex representation

commit a52b2928cd4f815e53d9fd388851672e0886c8d4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Sep 3 05:41:20 2015 +0200

    retry on error with hdiutil

commit b2508b6c5956bf7f13f619303c20f362614528da
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 2 10:49:12 2015 +0200

    removed workaround for HP USB Smart Card Keyboard
    
    Has been fixed by the CCID driver
    https://lists.alioth.debian.org/pipermail/pcsclite-cvs-commit/2011-March/005218.html

commit cf2a9cbbb042538121b2deb0feaeca33fd5b5925
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Aug 12 00:22:20 2015 +0200

    added call back for getting vendor/product id
    
    implementation taken from
    https://github.com/jasp00/OpenSC/commit/83142d4caeae5958850795757c7d6c5cf072a15c

commit 29b85b43c09a5c7e62168ff80447ff87ee6a0d64
Merge: 9456db9 56c3764
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Sep 2 10:41:06 2015 +0200

    Merge pull request #483 from adminmt/master
    
    Update ATR and ATR mask for MaskTech smartcards

commit 9456db90fc0a2039567e2851e7ec537c479aa06b
Author: Andreas Kemnade <andreas@kemnade.info>
Date:   Sat Jan 24 21:43:15 2015 +0100

    handle record-based files correctly when doing file caching
    
    implementation copied from `sc_pkcs15_read_file`
    
    closes #372

commit c9efb2f643fa0706c753f7b2f8ac7dbd45211581
Author: Andreas Kemnade <andreas@kemnade.info>
Date:   Thu Feb 5 19:18:05 2015 +0100

    make file cache dir configurable
    
    in cases where you use pam_pkcs11, HOME might not be set
    so paths based on $HOME are not usable, so that the combination
    of home and caching does not work. Having the paths configurable
    (together with a good setting of access rights)
    resolves that problem.

commit a64bbc55aa88211ce391e32bf1c2fa06c62cc6d6
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Aug 31 22:23:59 2015 +0800

    [OpenPGP] Fix building without OpenSSL.

commit 70890a8f61187f15baeb4c412aa38d151ee312a5
Merge: 6409202 4df35b9
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Aug 31 21:55:14 2015 +0800

    Merge branch 'master' into gnuk
    
    Conflicts:
    	src/libopensc/card-openpgp.c
    	src/tools/openpgp-tool.c

commit 3f43bc46ef45d4ec088fab3568c27bc193b6a174
Merge: 162e714 fc02cb1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Aug 31 13:31:19 2015 +0200

    Merge pull request #534 from frankmorgner/card-sizes
    
    reactivate handling of `0` for max_recv/send_size

commit 162e71419ba9b84d37321acc05e32980a438ae9a
Merge: 4df35b9 8da31d2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Aug 31 13:28:41 2015 +0200

    Merge pull request #537 from martinpaljak/fix-183
    
    Fixes #183: export more symbols
    
    closes #340

commit 8da31d271e2f29e6ce67fcf4886301f2b5a7f1d2
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Sun Aug 30 18:58:00 2015 +0300

    Fix for #183: export more symbols
    
    - also export C_Initialize and C_Finalize to please vmware-view
    - have a single pkcs11.exports file for both pkcs11-spy and opensc-pkcs11

commit fc02cb10931cb280a2e17e3a58697f7fefebbe75
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Aug 26 22:01:26 2015 +0200

    added documentation for sc_get_max_recv/send_size

commit 2d9802308f5c7b0190e73f3f5ac1b61345689148
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Aug 26 02:39:28 2015 +0200

    reactivate handling of `0` for max_recv/send_size
    
    The special value still needs to be handled for commands that are issued
    during card initialization. This especially concerns T=0 cards that need
    to use iso_get_response.
    
    fixes #533
    regression of 85b79a33320b615c923a6a03b6d295d7543b3f55

commit 2897e6fb5cbb78696a887c68a675c696957bb455
Author: Nicholas Wilson <nicholas@nicholaswilson.me.uk>
Date:   Sun Aug 23 22:33:50 2015 +0100

    Leniently interpret the ISO7816 return codes in card-piv.c
    
    This adds support for the Yubikey NEO. I'm not sure whether it breaks
    the specification, or follows some other version of the spec, but in my
    testing it returns SW1=0x63, SW2=0x0N for N PIN tries remaining.
    Ignoring the top nibble seems a harmless change to the behaviour to
    support this device.

commit 5a11d0e2fd9c7734dcc11352483b6d4f7f9291b5
Author: Nicholas Wilson <nicholas.wilson@realvnc.com>
Date:   Fri Aug 21 18:51:30 2015 +0100

    Add support for C_GetTokenInfo pin status flags for ISO7816 cards
    
    This is already supported for a couple of the card drivers, but
    since it's a general feature of ISO7816 it should go in iso7816.c,
    rather than the current situation where identical code for this is
    copy and pasted in each driver.
    
    However, some cards apparently don't support this feature and count
    it as a failed PIN attempt, so I've added a flag for now to indicate
    whether the card supports this feature. It future, it could be moved
    to blacklist cards rather than whitelist them, subject to more testing.

commit 56c376489f4544d3f09bb71de675621ca51e6b12
Author: adminmt <md@masktech.de>
Date:   Mon Jun 15 14:56:47 2015 +0200

    ATR update card-masktech.c, customactions.cpp
    
    changed atqb + mask of MaskTech smart card (a) and (c)
    removed MaskTech smart card (d)
    added atr mask to MaskTech smart card (a) and (b)

commit 4df35b922c8eb7e0776a23260b65e570b33e4d42
Author: Nicholas Wilson <nicholas.wilson@realvnc.com>
Date:   Tue Aug 11 14:02:52 2015 +0100

    pkcs11: Fix to CKA_PRIVATE handling pcks11-tool
    
    There's a copy-and-paste bug in there, where the CKA_PRIVATE attribute
    is being set on the wrong variables! As well as fixing that, we should
    explicitly set CKA_PRIVATE to "false" for certificates and public keys,
    since the PKCS#11 spec doesn't specify a default and some drivers use
    "private" as the default, making it impossible to add a public key/cert
    using pkcs11-tool.

commit ff2d88a724d5a2dee9c915b7b46ccb6ede520bce
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Aug 16 20:18:29 2015 +0200

    libopensc: uncomplete changes in c48afdbf breaks windows builds

commit 9cae888dd877fcecc2e499b5d073f468ff917047
Merge: c86580a c14be48
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Wed Aug 12 16:49:17 2015 +0300

    Merge pull request #522 from HenryJacques/login_pin_fix
    
    really set the --login option when using --pin

commit c86580adae2211b5cdd0672eac52f6800f6e854b
Merge: 27b64c5 2e21163
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Aug 12 00:41:26 2015 +0200

    Merge pull request #515 from frankmorgner/send-recv
    
    don't always overwrite max_send_size/max_recv_size

commit 2e21163273978475b31f664f80ad1ad3c02755c7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 11 13:27:30 2015 +0200

    cardos: probe for transceive length

commit 85b79a33320b615c923a6a03b6d295d7543b3f55
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 4 23:06:25 2015 +0200

    don't always overwrite max_send_size/max_recv_size
    
    If the reader announces extended length support, but the card driver
    leaves max_send_size/max_recv_size at `0`, max_send_size/max_recv_size
    previously would have been overwritten with the reader's size though the
    card might not have set SC_CARD_CAP_APDU_EXT. This commit fixes this
    behavior.
    
    Additionally card->max_send_size/max_recv_size is always initialized to
    a value different from 0 after the card initialization. This removes the
    need to check for this special value in all subsequent calls.

commit c14be48ed94e59e6db61f4c1a0b8e070744c0c0b
Author: HenryJacques <caramba696@gmail.com>
Date:   Tue Aug 11 18:03:31 2015 +0200

    really set the --login option when using --pin
    
    Until now, if -p was used without -l, we didn't authenticate to the token (see man pkcs11-tool)

commit 6409202c2f7a3153b1a92a3533bc5bc8cd8b6863
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sat Aug 8 14:17:12 2015 +0800

    [OpenPGP] Fix warnings about type conversion.

commit 27b64c59992d0ae45f4a7ac78cbd84c1e3dbf28c
Merge: 5e352ea d6774aa
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Aug 5 10:56:36 2015 +0200

    Merge pull request #513 from CardContact/master
    
    Fixed wrong APDU case declaration detected after PR #500

commit d6774aae40710d5243a6a3ee86387343467a02f7
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Tue Aug 4 17:51:46 2015 +0200

    Fixed wrong APDU case declaration detected after PR #500

commit 5e352ea4774aa3ee7d6aae25000600e46f261462
Merge: 246c691 24d91ac
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 4 10:32:23 2015 +0200

    Merge pull request #504 from frankmorgner/find_tags
    
    Find tags with GET DATA

commit 246c6910874e17b85722657f9aa244acd81c3c67
Merge: d7d64ee 97e41cb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 4 10:32:14 2015 +0200

    Merge pull request #506 from frankmorgner/template
    
    added completion-template to distribution

commit d7d64ee8d4a588c89ff9a866ea2f27d0dd779b84
Merge: e957073 7cec500
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 4 10:32:01 2015 +0200

    Merge pull request #494 from frankmorgner/fork
    
    After a fork do not release resources shared with parent

commit e95707362f47ada231e961db118491cc382452db
Merge: c48afdb 9543cdb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jul 31 15:40:30 2015 +0200

    Merge pull request #357 from fancycode/startcos34_dtrust
    
    Added initial support for STARCOS 3.4 (German D-Trust cards).

commit c48afdbfcbce24637dd416e4be75e75e58fcfe60
Merge: 6bedd70 c92e3b4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jul 31 15:35:32 2015 +0200

    Merge pull request #500 from frankmorgner/reader_max_data_size
    
    honour PC/SC pt 10 dwMaxAPDUDataSize

commit 6bedd70ea3cddc6c39ae0e945eea753cd778c05d
Merge: d7496cc b44c98e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jul 31 15:35:19 2015 +0200

    Merge pull request #499 from frankmorgner/asn1
    
    asn1: fixed parsing "end of content"

commit d7496cc3b4409c7095f8492f44770c52f2ad6b02
Merge: 415c1b1 6d21903
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jul 31 15:35:08 2015 +0200

    Merge pull request #498 from frankmorgner/pkcs11
    
    fixed segfault for uninitialized IsoApplet

commit 415c1b17e59abf2bef2008067b853f7f7ef7037a
Merge: 86aad41 4fedad5
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Fri Jul 31 10:54:46 2015 +0300

    Merge pull request #492 from metsma/osx10_11
    
    Fix tokend install on OSX 10.11

commit 4fedad53dd3e36c3d2a43de7400f40dd4cd34b29
Author: Raul Metsma <raul@metsma.ee>
Date:   Thu Jul 2 16:17:51 2015 +0300

    Fix tokend install on OSX 10.11
    
    Install to /Library/Security/tokend instead /System/Library/Security/tokend
    http://forums.macrumors.com/threads/os-x-10-11-all-the-little-things.1890519/
    /System folder is readonly
    
    Depends https://github.com/OpenSC/OpenSC.tokend/pull/16
    
    Signed-off-by: Raul Metsma <raul@metsma.ee>

commit 97e41cb76ad7e567675ce0d5d4509aeca5de3ebe
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 30 15:23:14 2015 +0200

    added completion-template to distribution
    
    fixes #505

commit 86aad4130dec71fe2e11648893ed54d6f0573233
Merge: 7eb62a0 c6c8c6c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 30 12:31:34 2015 +0200

    Merge pull request #503 from OpenSC/bad_code
    
    Fix bad code. Maybe this is what was intended ?

commit 24d91acf69d0071f8d924e2be976246d8a32e2a3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 30 08:19:01 2015 +0200

    opensc-explorer: added command find_tags

commit c6c8c6cdb027b288ff230d6965ee449ff102ff51
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Thu Jul 30 10:12:04 2015 +0300

    Fix dead code:
    
    ../../src/libopensc/errors.h:73:37: warning: statement with no effect [-Wunused-value]
     #define SC_ERROR_INVALID_ARGUMENTS  -1300
                                         ^
    card-masktech.c:181:48: note: in expansion of macro 'SC_ERROR_INVALID_ARGUMENTS'
      if (crgram_len > SC_MAX_EXT_APDU_BUFFER_SIZE) SC_ERROR_INVALID_ARGUMENTS;

commit f71ef838e92a6999ca79d83ad5c94690d37d156b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 30 08:18:07 2015 +0200

    implemented get_data for iso7816
    
    mostly copied over from CardOS implementation

commit c92e3b4f9820c39209bb63e9b484c8afd103fe20
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Jul 28 09:49:44 2015 +0200

    honour PC/SC pt 10 dwMaxAPDUDataSize
    
    closes #306

commit b44c98e4d80d20451e015168a40ed8281392c4ed
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Jul 28 09:10:54 2015 +0200

    asn1: fixed parsing "end of content"
    
    fixes #190

commit 6d21903c907fff5d88314c962245776f37845dd8
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Jul 27 19:10:34 2015 +0200

    documented pkcs11_enable_InitToken flag

commit b3dc5ea32a66d0429f3e2ef0f133ecfc619f8d4a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Jul 27 18:43:51 2015 +0200

    fixed segfault for uninitialized IsoApplet
    
    fixes #400

commit 6cfd71c3875a12c239b4423a964afbdf9f3947ab
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Jul 27 16:15:33 2015 +0200

    avoid double detecting card on uninitialized reader
    
    initialize_reader already calls detect_card

commit 7eb62a089851dbf954ca0476e2e5c1664b8f00e4
Merge: 28de49b 9fed959
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Jul 27 01:36:34 2015 +0200

    Merge pull request #497 from tolonuga/master
    
    Fix regression tests: some parameters got renamed (#496)

commit 9fed9591caab588f3ca913eb1617f3571954c449
Author: Andreas Jellinghaus <andreas@ionisiert.de>
Date:   Sun Jul 26 21:35:29 2015 +0200

    Fix regression test crypt0007: it deals with 1024 bit keys (not 1048).
    
    Signed-off-by: Andreas Jellinghaus <andreas@ionisiert.de>

commit 4dfbf24a3ef3eb9ee0760db401c14852c82370e1
Author: Andreas Jellinghaus <andreas@ionisiert.de>
Date:   Sun Jul 26 21:34:51 2015 +0200

    Fix regression test suite: rename parameters to new names.
    
    Signed-off-by: Andreas Jellinghaus <andreas@ionisiert.de>

commit 28de49b34c02d8a0386b421ca951e2cdbfb16b21
Merge: ee68165 665807d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 23 13:11:39 2015 +0200

    Merge pull request #448 from sschutte/patch-1
    
    Create minidriver-italian-cns.reg

commit ee68165b1d193bc5128c6fd3642dc290c4109af2
Merge: 142323a 317cc30
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 23 13:10:14 2015 +0200

    Merge pull request #474 from germanblanco/memory_allocation_5
    
    Fixing part of the memory allocation problems in DNIe module. Issue #472

commit 142323af10d04d849eb39fe06de56361a9f9c9ca
Merge: 8f093b5 030f4d1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 23 13:08:46 2015 +0200

    Merge pull request #476 from germanblanco/dnie_ui_depends_on_ssl
    
    Empty user-interface.c if there is no SSL support. Related with issue #362

commit 8f093b5849f45b70d12018162e3966296de7940b
Merge: a51d4c8 5898eab
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 23 12:38:00 2015 +0200

    Merge pull request #486 from Hubitronic/patch-1
    
    Update card-muscle.c

commit a51d4c836735b6c721459e67e1b092a3d045e78c
Merge: b48fa70 e5ae77c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 23 12:32:42 2015 +0200

    Merge pull request #485 from carlhoerberg/osxsdkpath
    
    Restore compability on os x

commit 7cec500e549471cdbac2905eb6f5ae50cba2a4ee
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jul 22 17:25:35 2015 +0200

    added flags to sc_context_t
    
    - is initialized in sc_context_create with parm->flags
    - removes members paranoid_memory and enable_default_driver

commit edc839e072a5b16abc52ab73d60748c87b0fd4e0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jul 22 01:28:48 2015 +0200

    restrict access to card handles after fork
    
    fixes #333
    closes #493

commit 317cc302db8979d6365372a21774691aef857298
Author: German Blanco <german.blanco@gmail.com>
Date:   Fri Jul 10 12:38:22 2015 +0200

    making the size of e_tx in cwa-dnie.c dynamic

commit d0e3d1be3d7c7ca2036acf11e31d832a6f892995
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sat Jul 4 00:21:38 2015 +0800

    Fix tab & spaces

commit 5898eab3732f73550b36b6dae4a947dfd0c6f4e2
Author: Hubitronic <hubitronic@gmail.com>
Date:   Thu Jun 18 16:28:11 2015 +0200

    Update card-muscle.c
    
    re-enable opensc.conf flexibility again

commit e5ae77cae32fdcc7a23d6bd0013c2fd115a43591
Author: Carl Hörberg <carl.hoerberg@gmail.com>
Date:   Wed Jun 17 16:27:03 2015 +0200

    Restore compability on os x
    
    Fallback to
    /System/Library/Frameworks/PCSC.framework/Versions/Current/Headers when
    there are no OS X SDKs installed. Fixes bugs introduced in #308

commit 030f4d15597c2558c08175caec605716514a6eff
Author: German Blanco <german.blanco@gmail.com>
Date:   Mon Jun 1 08:21:25 2015 +0200

    Empty user-interface.c if there is no SSL support.

commit 0d14f3ffeed7e9c519df246b57b22d9501efccbc
Author: German Blanco <german.blanco@gmail.com>
Date:   Mon Jun 1 07:46:59 2015 +0200

    Correct initializing of a variable in card-dnie and revert buffer size change in cwa-dnie.

commit 76517b7d433f6d9e4a16a2217974804c339ef692
Author: German Blanco <german.blanco@gmail.com>
Date:   Tue May 26 21:44:13 2015 +0200

    Fixing part of the memory allocation problems in DNIe module.

commit b48fa703085f723f2209a92f22136b5915bd87a4
Author: Doug Engert <deengert@gmail.com>
Date:   Wed Feb 11 19:03:45 2015 -0600

    sc_pkcs11_card improvements
    
        This is name change only fix.
    
        The variable name "card" was being used to refer to a struct sc_card or a struct sc_pkcs11_card
        in some files including sc_pkcs11.h. In other files the variable name "p11card" is used for struct sc_pkcs11_card.
        This creates hard to read code, such as: slot->card->card.
    
        All definitations of sc_pkcs11_card *card now use p11card as the variable name.
    
    Fix #471

commit 31cb40db17cbb13595af1c03c19198b11ac7d649
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat May 16 21:31:47 2015 +0200

    revision: 0.15.0

commit 8c94662e9610ba7691a5dce06710ee305b163d70
Author: David Woodhouse <David.Woodhouse@intel.com>
Date:   Thu May 14 00:43:40 2015 +0100

    Add --test-fork option to pkcs11-tool
    
    The PKCS#11 Usage Guide, at least up to v2.40, says that calling
    C_Initialize() in the child after fork is "considered to be good
    Cryptoki programming practice, since it can prevent the existence of
    dangling duplicate resources that were created at the time of the fork()
    call."
    
    (It neglects to mention that doing so in the child of a multi-threaded
    process is a clear violation of POSIX, mind you. Not to mention being
    utterly pointless if all you're going to do in the child is exec something
    else anyway.)
    
    Regardless of the sagacity of this recommendation, we need to cope when
    it happens. Historically, we've been quite bad at that. Let's add a test
    to pkcs11-tool in the hope it'll help...
    
    Fixes #464

commit 01b395e636b92411dac9d6eb3f77be7cde0decdb
Author: vletoux <vincent.letoux@mysmartlogon.com>
Date:   Thu May 14 10:24:01 2015 +0200

    card-masktech.c: add 2 more ATR
    
    Fixes #465

commit 6349836ba26acfe2f15ce7b9612672f1485b4cb7
Author: Raul Metsma <raul@metsma.ee>
Date:   Fri May 15 12:03:00 2015 +0300

    Include onepin-opensc-pkcs11.dll in installer
    
    Fixes #466

commit 5be35fb3f40ecc651a4cfb88ca36ecdca5520eeb
Author: drew thomas <drew.thomas@tyfone.com>
Date:   Fri May 15 12:18:39 2015 -0700

    muscle: change TyfoneAT historical bytes to 'Tyfone 242R2'
    
    Fixes #467

commit a09ca246a797230c14bc33a34f2dddc4a4dbff40
Author: Andreas Kemnade <kemnade@unicept.de>
Date:   Mon May 11 14:17:54 2015 +0200

    libopensc: initialize value returned by sc_select_file
    
    several places in the code expect sc_select_file to set *file_out to NULL
    in case of failure. Adjust the function to behave like this.
    
    Fixes #460

commit 6a6ef61d1acba7ab3363df4157dffce3eb935bbc
Author: Andreas Kemnade <kemnade@unicept.de>
Date:   Fri May 8 15:49:30 2015 +0200

    some more error checks in minidriver in regards to card ejects

commit 492ffe0fd71d0bc2c6b0df7dfeb95f051b58d906
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun May 10 22:54:56 2015 +0200

    iso7816.c: allow file length stored in more than 2 bytes
    
    as indicated in iso7816-4 chapter 7.4.3 table 10
    
    Fixes #459

commit 8b62221abcaa8b32b5ffd9102bdec2995e660cba
Author: drew thomas <drew.thomas@tyfone.com>
Date:   Thu May 7 15:13:40 2015 -0700

    muscle: add ATR of Tyfone mSD card
    
    Add Tyfone Connected Smart Card ATR to list for MUSCLE support.
    
    SC_CARD_TYPE_MUSCLE_JCOP242_NO_APDU_EXT
    
    Fixes #463

commit c7af08c68a5bb3e753b008822e947d52016266c0
Author: Doug Engert <deengert@gmail.com>
Date:   Tue May 12 12:59:37 2015 -0500

    PIV - read just length of object to get size
    
    card-piv.c tries to read the first 8 bytes of an object to get object size
    so it can allocate a buffer. It then reads the whole object. apdu.c has changed
    over the years, and apdu.c will keep reading as long as the card returns
    status of 61 XX  thus apdu.c will read the whole object while discarding
    the extra data and returning to the caller only the first part of the data.
    This in effect causes a double read of objects.
    
    This patch sets SC_APDU_FLAGS_NO_GET_RESP to tell apdu to stop doing the
    extra get-response commands thus avoiding most of the extra overhead.
    
    This in not an optimal patch as it only works with T=1 cards/readers
    but the patch is confined to just card-piv.c.
    A better patch is in the works.
    
    Fixes #462

commit 72b5d8fe9adcd5ae3ecb89b4c617151222e44c8b
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun May 10 11:48:45 2015 +0200

    md: use 'store-or-update' store certificate mode

commit 7784d24ee136c96a353ccc810ab2394887c9fefc
Author: vletoux <vincent.letoux@gmail.com>
Date:   Thu May 7 15:54:07 2015 +0200

    win32/customactions.cpp: add the MaskTech card minidriver registration data

commit 8ec000e80d500d4b993f74465442cc509e1c90cb
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat May 2 23:44:05 2015 +0200

    minidriver: change the icon of the pinpad dialog

commit ac82a96ccc7cd2ef54d5d1cbc1fa7a32aee582ee
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Apr 26 19:54:09 2015 +0200

    minidriver: add my name in the author list
    setup: change the url to match the new one

commit aede9b164beeb35cba493f3e00bb2136c455ee44
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 25 23:29:03 2015 +0200

    minidriver: fix compilation warnings on x64 (size_t <> DWORD)

commit 2f6d1b5c9783fcd52d73881baa61e5d2a895862b
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 25 19:30:31 2015 +0200

    avoid the failure: "Failed to get file version of custom action dll"

commit 0b683472b0749b45c14c181c22b1e86f0775dc64
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 25 17:04:17 2015 +0200

    win32 setup: add basic minidriver card registration and unregistration via a custom action

commit 9e07a75968a3d829a072c12aa0c6b128bbec3310
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 25 15:03:39 2015 +0200

    detect the wix components installed on the build machine

commit 5a1ca44c11e463b5ac6fe16c529f2266358ea589
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 24 15:58:54 2015 +0200

    custom action skeleton (without actions) - help welcome ...

commit 017d98f87f5061116f0a48ba37f2c98b391aee8e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 24 14:46:24 2015 +0200

    trying to fix image path when compiling

commit 33cf1619413c88f491d6ff5db2359b81faa2914b
Author: vletoux <vincent.letoux@gmail.com>
Date:   Mon Apr 20 23:25:57 2015 +0200

    minidriver: pinpad authentication is now working for smart card logon !!! (still needs 5 pinpad entries)
    
    minidriver: minor fixes

commit 6127fe6b779227070c9a1f37feb2f6168832ed5e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Apr 19 19:51:22 2015 +0200

    minidriver: change the UI (remplace a messagebox by a nice dialog) ; add a translation function for errors

commit 7d225e28f7474f8837e7de3bde7f707ba7b1f8ad
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 18 21:43:13 2015 +0200

    minidriver: add support for the special msroot file which contains the root certificates stored on the card.

commit 6b58b1db01a77754d6cefc39ca0a1f3ffa076869
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 18 19:09:45 2015 +0200

    minidriver: merge CardUnblockPin and CardChangeAuthenticator into CardChangeAuthenticatorEx

commit a671cf8fe2e4ac2eb824aae395d9bc30fcc655a8
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 18 15:26:42 2015 +0200

    CardAuthenticateEx: test for remaining attempts before ...

commit 659da4f538fcf9d427779f42a0cd598c3076eced
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 18 15:23:18 2015 +0200

    minidriver: CardSignData - better parameter checking

commit f3c9525137bcaf4a96576ba63a3d9b21a55875d9
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 17 23:04:39 2015 +0200

    fix attempt remaining regression if the card is blocked

commit d96e53b102fc73afd11d20b6bd8d372daac38bfe
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 17 23:02:41 2015 +0200

    minidriver: better error code if CARD_PIN_SILENT_CONTEXT is set

commit ad47d4d043f11122f75cc3de18037fcc0d0b2c27
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 17 21:39:41 2015 +0200

    minidriver:
    * factorize the code from CardAuthenticatePIN into CardAuthenticateEx
    * allows authentication with the PINPAD without a UI
    
    minidriver: fix some code analysis warnings

commit 8062eac14575611cb70e2cfc431fed2507180f2f
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 17 18:04:05 2015 +0200

    minidriver: fix CardQueryCapabilities and CardGetProperty fKeyGen flag. A read only card cannot generate keys

commit f331b35c4ee80a71acc7cbdcb5c873a012b24a9f
Author: vletoux <vincent.letoux@gmail.com>
Date:   Fri Apr 17 16:39:48 2015 +0200

    minidriver: make the parameter check be aware of pinpad capabilities

commit a5593afc781ee7bffb3b061618b9086273099e6c
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Apr 12 14:06:36 2015 +0200

    minidriver: better parameter checking with CardQueryKeySizes and CardGetContainerProperty

commit 1e78e16e657803bc21cc33e180643bfdd9a70cee
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Apr 12 13:34:18 2015 +0200

    fix memory leak in minidriver: the virtual filesystem is never freed and in some case when an error occurs

commit 9601041f75392c11521201dd509be60ef0f7d900
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Apr 12 08:47:09 2015 +0200

    win32 setup:
    * change the default wix background image (aka brand the setup)
    * add the missing ARPCONTACT property

commit 8036388f292b13cd2df36dd6b8b08c5a34093321
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 11 16:30:17 2015 +0200

    minidriver PINPAD: fix a regression issue (the parameter - message - can be set to null)
    Improve the error code when the user cancel the operation ("The operation was canceled by the user" instead of "invalid parameter")
    
    Signed-off-by: vletoux <vincent.letoux@gmail.com>

commit cb38657d47ad0bebfb7ae9763d746ce1c0018532
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 11 14:17:20 2015 +0200

    CardSignData: add support for missing hash algorithm

commit c5efcae0292ee86b1bc800ca06626998a25ef881
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 11 11:08:52 2015 +0200

    CardRSADecrypt: better parameter checking
    
    CardRSADecrypt & CardSignData: better OpenSC -> minidriver error code translation

commit 9544844d83e56891c5f164ddcd2418c337164868
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 11 10:34:33 2015 +0200

    CardSignData: better error message if the card do not support the signing operation with the algorithm
    (replace the return code from internal error to unsupported)

commit 54f462368b170e5a026b8dbf723f8cb2dc72cbf2
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 11 08:52:22 2015 +0200

    Fix CardSignData "invalid signature" bug when called from CryptSignHash(CRYPT_NOHASHOID)

commit 6aaf9d462c6488fa2d21143bf15007842661783b
Author: vletoux <vincent.letoux@gmail.com>
Date:   Thu Apr 9 22:29:50 2015 +0200

    fix a problem: CardDeauthenticate(ex) do nothing, but the base CSP think that the user is deauthenticate from the card.
    The user is still authenticated !

commit b7f000d6b8ce28a8724e381b23bdc1f9d5f1902a
Author: vletoux <vincent.letoux@gmail.com>
Date:   Thu Apr 9 22:02:10 2015 +0200

    add parameter checking for CardSignData

commit 2667394f228f49c274787a753920e7838245620d
Author: vletoux <vincent.letoux@gmail.com>
Date:   Tue Apr 7 22:50:39 2015 +0200

    better parameter checks for CardGetProperty and CardSetProperty
    Added value for secure key injection (to reject it properly because it is not implemented)

commit 6a2e9aa3b6c1bdb4ff9e0da3757420b302f574f6
Author: vletoux <vincent.letoux@gmail.com>
Date:   Mon Apr 6 19:38:15 2015 +0200

    Merge branch 'upstream/master'
    
    Conflicts:
    	src/libopensc/card-openpgp.c
    	src/libopensc/pkcs15-gemsafeV1.c
    	src/pkcs11/mechanism.c

commit e0aec3764ad4162631c07c1663b680575ca0eb08
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun May 10 11:46:42 2015 +0200

    pkcs15init: 'store-or-update' certificate option

commit 3cf56d8fb7f8a54a16eb89ca3230b07bf3f7e4be
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun May 10 11:44:04 2015 +0200

    pkcs15init: fix non-unique-ID control

commit f154cdcaa4ac3bb4a53b3ed9a886cd23d4ef4ec4
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Apr 18 22:13:12 2015 +0200

    pkcs15-pin: sc_pkcs15_unblock_pin: avoid to ask the PUK twice

commit 3e0356b170a3a6d2f85fce231e9e2064336671c8
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri May 8 20:41:47 2015 +0200

    register CKM_ECDSA and CKM_ECDSA_SHA1 depending on card capabilities
    
    fix #429

commit 254320e34cda81720b8a102c7bbf59deff5d68ba
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Mon Apr 6 13:04:59 2015 +0200

    myeid: seperate ECC from RSA flags
    
    Should keep the existing behavior, but improve readability.

commit 4142456c74a56c3f0a7a276f3a3711c52bb41f4b
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sat Apr 4 18:46:30 2015 +0200

    PIV, sc-hsm, myeid: register ECDH card capabilites
    
    Prior to 066132327c71300188aa66180fde2fb3d90c5140, CKM_ECDH1_DERIVE and
    CKM_ECDH1_COFACTOR_DERIVE were always registered for cards that support
    SC_ALGORITHM_ECDSA_RAW.
    The mentioned commit changed this behavior, so that the ECDH mechanisms
    are only registered for cards that set the SC_ALGORITHM_ECDH_CDH_RAW
    capability flag.
    To keep the existing behavior for the cards, they need to set this flag
    in the card driver.

commit 78e434da93077e5b002d364df308847c62cb76a2
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Apr 1 23:28:39 2015 +0200

    register EC mechanisms with flags independent of RSA flags
    
    Prior to this commit, all hashes registered for RSA or other key types were
    registered for ECDSA as well.
    
    register ECDH mechanism only when supported by card
    
    ECDH should only be registered if the card driver sets the
    SC_ALGORITHM_ECDH_CDH_RAW flag.
    
    register software PKCS#1 (1.5) padding only when RAW RSA is supported by card
    
    If OpenSC supports PSS/OAEP padding or other padding mechanisms in
    future, and there would be a card that enforces hardware PSS/OAEP
    padding, the PKCS#1 v1.5 padding mechanism should not be registered.

commit 37b6f0bbdfcb88a3bd761209cab211d710cc3666
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Apr 1 23:26:40 2015 +0200

    IsoApplet: fix EC mechanism ext_flag

commit fd3d07a88496dc0adfa2f6ff7eca9078ec087985
Author: Hector Sanjuan <hector@convivencial.org>
Date:   Wed May 6 20:37:20 2015 +0200

    Issue #451: Newer DNIe not working with OpenSC.
    
    This patch fixes 3 issues which consecutively have shown up when debugging the original problem:
    
    1 - Newer DNIe report a byte count for public certificates which is the compressed size,
    while older DNIe report the uncompressed size. This resulted in short-reading the x509 certificates,
    and in an error parsing. Therefore, during initialization we proceed to set path->count for
    public certificates to -1. This ensures that the lenght of the certificates for reading
    will be set to file-> length, which has the correct size.
    
    2 - pkcs11-tool -t was broken for DNIe (old and new)as it tried to strip pcks11 padding
    from the data to sign and OpenSC tried signatures with non-padded data
    (as the card had SC_ALGORITHM_RSA_RAW).
    The new algoflags (SC_ALGORITHM_RSA_HASH_NONE | SC_ALGORITHM_RSA_PAD_PKCS1) and the
    removal of the strip-padding call fix the issue.
    
    3 - The new cards won't allow setting the LE bytes when calculating the TLV, when LE equals
    256. This caused an wrong SM object error response (0x69 0x88). Therefore,
    we don't send the LE bytes anymore in this case.
    
    The patch has been tested to work on the new problematic card and on another old one.
    
    close #451

commit ef4edb74ba5dfb1830a3a21b0c895553e9d4eedc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri May 1 12:50:19 2015 +0200

    fixed invalid free
    
    We duplicate mechanisms based on OpenSSL so that they can be freed along
    all the card's algorithms created via sc_pkcs11_new_fw_mechanism. Fixes
    regression from eaf548aa3dab80a9bbf51da8291e7db978e3a2ad

commit e338b7c1ab2b6d39bf9d57c85f789279abd0a1ca
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 30 06:46:31 2015 +0200

    framework-pkcs15: fixed memory leak when encoding pubkey

commit e84951a5bf7f65d20061b49b6ebd8d739dd76708
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 30 01:45:23 2015 +0200

    fix resource leaks in while registering PKCS#11 mechanisms
    
    introduces a free_mech_data for sc_pkcs11_mechanism_type_t to clear the
    mechanisms private memory

commit 2c32575e8970a997223f201caeeef12b53fd0174
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 30 00:07:11 2015 +0200

    pkcs11-tool: fixed resource leak

commit ecc9b9dac9fe4edc08d55a5aad9a94b990f4f370
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 30 00:07:10 2015 +0200

    openssl: fixed resource leak

commit 8838388ceb9818873227e399d4fca741df3659b9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 30 00:07:10 2015 +0200

    pkcs15-infocamere: fixed resource leak

commit bbb803ff2e75d56e8e27d6973fde389a5f08d4f7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:30 2015 +0200

    sc-hsm-tool: fixed resource leak

commit d96f25c147d1e19efab4f3141cf8ed8dbd55678c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:30 2015 +0200

    pkcs15-tool: fixed resource leak

commit 1f16f24052d5567bb2de92f080378421fa9719e2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:30 2015 +0200

    pkcs15-init: fixed resource leak

commit a83da8a947232c0c6f084cbbfeb7b979fe554368
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:30 2015 +0200

    pkcs15-crypt: fixed resource leak

commit c65caed7f4ce3b3146054eafc5bb2ed426931a38
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    openpgp-tool: fixed resource leak
    
    VTA: slightly touched, original commit f0ddbf4

commit b0a708b0bb2f25be9d417e56b78ba6f20f2a1d78
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    pintest: fixed resource leak

commit efbd4068af4e475ead56c295b85911af89959d0d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    sm-cwa14890: fixed resource leak

commit 01e573b9876b6538d85e85c16d2a3f2085ebb1cd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    profile: fixed resource leak

commit 6cb99be8219026e7d1354ab3216af26596c66f49
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    pkcs15-setcos: fixed resource leak

commit 44253c63d08f39c0ea35eab2b96d46719c3abcef
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:29 2015 +0200

    pkcs15-rtecp: fixed resource leak

commit d636338eaf597e20e3e7c2a33146c5de7c9bc413
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu May 7 22:33:39 2015 +0200

    pkcs15-oberthur: fix memory leakage

commit ac84d282b1a5e7aae8d68ea7b15a214d4f28687d
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu May 7 22:04:25 2015 +0200

    myeid:  fixed resource leak
    
    pkcs15-myeid: fix memory leakage
    myeid: fix memory leakage

commit 475ce71453080c190ffddaba38d04fe6c8d43087
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu May 7 21:55:26 2015 +0200

    iasecc:  fixed resource leak
    
    pkcs15-iasecc: fix memory leakage
    iasecc: fix memory leakage

commit 68becc8fc491cc27a7eb3f8cd8e5291308457f7c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    pkcs15-gpk: fixed resource leak

commit d4fd135e2040670b35c79c9fbe5c641d31c9bd00
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    pkcs15-cflex: fixed resource leak

commit 4af4308d19ebcfccf757202e3bd0fc6eed49aefe
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    authentic:  fixed resource leak
    
    pkcs15-authentic: fixed resource leak
    card-authentic: fixed resource leak

commit e215b7b4fb5d51d72dc44bb7ac9dbc6fb5348426
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    sm-common: fixed resource leak

commit 3cfb44d70464ad126e5a098a283a8c9c32135594
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    pkcs15-syn: fixed resource leak

commit 841d89dda685c1698a0011a7b3c50d29527ade74
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:28 2015 +0200

    pkcs15-pubkey: fixed resource leak

commit 18e962942baddb943ae53c91b4ab061580e4636e
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu May 7 18:52:57 2015 +0200

    pkcs15-data: fix memory leakage

commit 3a6c4a0e1d2a40b1746b5cd9f4212347a9dc364d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    pkcs15-cache: fixed resource leak

commit 9263da49aaa33b3bc1d26e396a392eb9ca06400b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    pkcs15: fixed resource leak

commit c7afbb4ca2bdeec80e5c60008bbf800d6916d86c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 29 23:22:27 2015 +0200

    pkcs15-algo: fixed resource leak

commit 1f69a0d6879d969aaa88af0efba09810d3208567
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Apr 24 18:24:42 2015 +0200

    fixed indenting

commit 6523f3fcb9fe78650597be2710e69818e0c92b13
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Apr 24 18:13:34 2015 +0200

    added LOG_TEST_GOTO_ERR and SC_TEST_GOTO_ERR
    
    Don't forget to set the error label!

commit 689ece205ae04ac65a9941b7568ab84b36f94475
Author: vletoux <vincent.letoux@gmail.com>
Date:   Thu May 7 15:39:22 2015 +0200

    card-masktech.c: code improvements
    
    fixes #457

commit 976db5cb0400147e9108d434796d68c27f7b4c5c
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat May 2 12:37:50 2015 +0200

    card-masktech: initial commit
    
    card-masktech.c: fix building issues on the integration platform
    
    card-masktech.c: fix linux compilation errors
    
    honour HAVE_CONFIG_H
    
    card-masktech.c: take in account Frank's remark about extended APDU in masktech_decipher
    
    remove trailing spaces

commit 1586f240f43d134ab7225fbbf9624d445a925d0e
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun May 3 12:48:26 2015 +0200

    iso7816.c: fix SC_PIN_CMD_IMPLICIT_CHANGE with pinpad
    
    When a pinpad is used, the old pin is asked whatever, even if a previous authentication happenened or if the card doesn't support it.

commit ed588d24434f5e7b2df9d0fc32f24fc7226db0ad
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Apr 27 21:21:35 2015 +0200

    pkcs11: fixed broken C_Decrypt
    
    Fixed broken C_Decrypt from 643080baf9ffd404c88cb99493668eacfff3ab5e
    
    fix #449

commit f0189e8378fb44403eb2e412e4346962298f441e
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu Apr 30 13:50:28 2015 +0200

    pkcs11-tool: option to 'decrypt some data'

commit 0dba2d453fa50d0ff5e62b59aa9f67cbc057892e
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Apr 27 22:31:19 2015 +0200

    sc-hsm: fix signed char for ARM platforms
    
    char is unsigned by default on ARM
    
    fix #450

commit c754e3f1971c141111871573053a6df3752c1f9d
Merge: 0a754b6 9f318b8
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Sat Apr 25 13:04:07 2015 +0200

    Merge pull request #444 from frankmorgner/pkcs11-error-handling
    
    Improved error handling for PKCS#11 module

commit 0a754b694ee8c95f51b7e1794bdf65f670b9ce74
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Apr 22 17:40:36 2015 +0200

    pkcs11-tool: pass key usage flags to created objs
    
      * Command-line parameters were introduced to specify key usage
      (--usage-{sign,decrypt,derive}). However, those are not used when importing
      external objects using C_CreateObject function.
    
    fix #445

commit ee23d286547d730dc82011857b318186140b31f5
Author: Doug Engert <deengert@gmail.com>
Date:   Thu Apr 16 19:40:22 2015 -0500

    EC field_length changes for non-multiple of 8 bits curves
    
    In OpenSC the EC field_length is the number of bits in the field.
    Most curves have a field_length which is a multiple of 8 bits
    but there are many that are not.
    
    The X and Y points and privateD are stored in octetstrings
    so there may need to be an extra byte in the octetstring.
    
    An OpenSSL BIGNUM will drop leading zero bytes, so its size can not be used
    to determine the field_length.
    
    fix #440
    fix #433

commit 3b545b513af8c59e2fc40012b62923ce6f38548d
Merge: 17eb40e de5c224
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Sat Apr 25 12:00:42 2015 +0200

    Merge pull request #446 from frankmorgner/protocol
    
    Honour HAVE_CONFIG_H

commit 665807d6de3f6494fe10f7f6fcf4ed5d3bd34210
Author: Shaun Schutte <schuttebs@gmail.com>
Date:   Fri Apr 24 09:45:20 2015 +0200

    Rename minidriver-italian-cns to minidriver-italian-cns.reg

commit e456074fd98e45c0a3d69487e0f5a9d786bd9440
Author: Shaun Schutte <schuttebs@gmail.com>
Date:   Thu Apr 23 16:54:11 2015 +0200

    Create minidriver-italian-cns
    
    These are the required registry values to get the Italian CNS card working under Windows 7 32 bit and 64 bit.

commit de5c224201b54632a7c2a0d4bf629bca8c442c1c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 23 00:09:19 2015 +0200

    silence some shell commands in Makefile

commit bcb5fc15e5b6224d2bdd8edb3c0346812dc89d38
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 22 23:55:33 2015 +0200

    honour HAVE_CONFIG_H

commit 9f318b829fb9e2fa42d875a4e2afd576d5fc73ad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Apr 21 02:00:06 2015 +0200

    remove slots of removed readers

commit 02f3997632d147ad3e55a51a74794602d38144eb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Apr 21 01:32:37 2015 +0200

    added error handling to print_ssh_key

commit e359b2a310c739c8f7f2447d716a65268cbb40cd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Apr 21 00:57:22 2015 +0200

    handle unexpected meltdown of PC/SC service

commit cbc43eeb88c619b1f488dd937d89b2fc5546ef83
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Apr 20 23:04:47 2015 +0200

    fixed compiler warning

commit c8a7c8bc7aec67f95254dd900f394f6c55429f4e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Apr 20 22:44:33 2015 +0200

    fixed typo

commit 54f285d57ada65fc7774e82e2f0d10c35060d7ed
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Apr 20 23:30:06 2015 +0200

    correctly handle readers that have been removed

commit c45c90a337a3126f8e37031a552c23578d298c0b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Apr 20 16:18:11 2015 +0200

    sc_pkcs11_close_all_sessions: close all sessions even if closing one fails

commit 17eb40e5f9eadc760945e7df3be2436d330ef592
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Wed Apr 15 09:33:24 2015 +0200

    doc: add 'signature-format' option for pkcs15-crypt

commit 23ca1f101db0b4fca09bfb51b4fb4d67dbfc2435
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Tue Apr 14 17:52:22 2015 +0200

    pkcs11-tool: Add support for creating EC privkey
    
      * This patch allows to create EC private keys. The feature re-use the GOST
      parsing function as instanciating an ECDSA key is the same as a GOST key.

commit a7a903fd811fbe95606fad4b8087f936d6f711cf
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Apr 14 13:26:27 2015 +0200

    check ATRs even for forced card driver
    
    some card drivers depend on a card type which is initialized by matching the card's ATR

commit 96556dea7bff431e794641fcae6b732395e00854
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Apr 12 13:35:20 2015 +0200

    fix #433: EC privateD octetstring may need leading zeros

commit 6caa85f238d437198f92a70644675df7e2128c20
Author: German Blanco <german.blanco@gmail.com>
Date:   Wed Apr 8 15:04:42 2015 +0200

    Issue 395. Avoiding a couple of memory leaks.

commit 6e84ee0ba779c4c527f5c979ef2751ee256da0ba
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Apr 10 07:42:00 2015 +0200

    pkcs11-tool: honour unsupported signature mechs

commit 643080baf9ffd404c88cb99493668eacfff3ab5e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Apr 10 07:28:13 2015 +0200

    honour key capabilities for decryption/verification
    
    fixes #419

commit d7ab0df51d3df026522f811e5d86809112e294d2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Apr 4 03:02:54 2015 +0200

    export sc_pkcs15_bind_internal
    
    allows bootstrapping an external pkcs15 driver

commit 3e2d51e0bacfef4a6cbaa1110874333772b9e598
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Apr 11 16:47:06 2015 +0200

    iasecc: use PIN PAD with variable PIN length

commit 5757d82cc965bf6851e2601cb1f48e84db02b8b2
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Apr 11 16:45:17 2015 +0200

    libopensc: stored-length member in PIN CMD data

commit 49598b601631ec23df5512d21f77a9bb9be9e7e4
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu Apr 9 11:48:59 2015 +0200

    libopensc: invalid OID comparison for EC keys
    
    Thanks to Peter Popovec <popovec.peter@gmail.com>

commit ce962c14f4368c2e5be4d0f3fb0f85f4d96ea69c
Author: vletoux <vincent.letoux@gmail.com>
Date:   Mon Apr 6 16:43:17 2015 +0200

    fix #425: guid computation issue
    
    Compilation without OpenSSL - guid computation issue
    This case is triggered when:
    - built without OpenSSL
    - called from a minidriver where id.len = 1
    - card number is less than 15 bytes
    
    (VTA: codding style slightly touched)

commit 4000e6d5b0c6227f2621408fa15c9d1661d65b24
Author: Dirk-Willem van Gulik <dirkx@webweaving.org>
Date:   Tue Apr 7 17:35:43 2015 +0200

    Add missed option debug info
    Fix misspelled key in --help output (thanks Philip Wendland).

commit 8ea328ff7fb311e582f312fe4f145c1af0d52390
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sun Mar 29 15:55:10 2015 +0200

    Minor code quality improvements.
    
    Basically checks that the memory allocation succeed.
    
    The ctbcs.c change improve the readability
    because count = 0 and len > 254 does not add any value.
    
    VTA: added few coding style changes

commit db860c0d2aa58501375530f7bb0b364cda73d693
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Apr 2 08:05:24 2015 +0200

    export sc_sm_stop

commit fa045d44ecf7235b73d9fb55ed7261eb36252b0c
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Apr 3 14:01:41 2015 +0200

    pkcs11-tool: Let the user choose the ECDSA signature format
    
    Instead of hard-coding the format depending on whether OpenSC was compiled with
    OpenSSL or not, the user should be able to choose the format himself.
    The default format now is the normal concatenation of R,S both for CKM_ECDSA
    and CKM_ECDSA_SHA1.

commit f93835add98343d454b8f4321c9a7f8708012b74
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Apr 3 21:07:49 2015 +0200

    Allow log functions to be called with ctx==NULL
    
    This change allows functions to be used from places where there is no
    sc_context (ctx) available.

commit 95ad11a2530c3d35fa8220c82391f3dd0e8869dd
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Apr 4 21:05:19 2015 +0200

    iasecc: special case for 'Gemalto GemPC Pinpad'
    
    issue 424
    VTA: this pinpad, the only available, do not accept different values
    for min and max PIN lengths in P10 block.

commit c0fac2a4f6c58b5f84c7b2e3344e8e19a765e3d7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 1 21:03:25 2015 +0200

    stop SM in case of SM errors

commit e07c4bcfbbc55eaca08eba625e189697ff18f3d5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 1 20:50:37 2015 +0200

    added sc_sm_stop
    
    implementation taken from the ISO SM driver of
    https://github.com/frankmorgner/vsmartcard/tree/master/npa

commit 00b04254f7e42e29db1b845364606080ed3abc52
Merge: 30b24e7 88fa362
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Wed Apr 1 09:55:11 2015 +0200

    Merge pull request #420 from frankmorgner/osx
    
    Travis OSX integrations

commit 30b24e79c08e6c027ffa3aa8136c10f689ce7a63
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 1 02:01:41 2015 +0200

    fixed memory corruption in encode_file_structure
    
    as suggested by Peter Popovec

commit 88fa362b5b3e27d47ff2d57e4e04e694e5e07c87
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 1 01:07:05 2015 +0200

    nobody likes being pedantic

commit 311958e13f43abfe29d5ba15f62fdf4ad22b16b8
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Apr 1 00:13:19 2015 +0200

    Travis-ci: build dmg on OS X

commit a251b9335c7b3c827685337e9498b3d4493d9c09
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Mar 31 23:57:19 2015 +0200

    use xcodebuild with `-target OpenSC`
    
    patch by Dirk-Willem van Gulik

commit 88ec461bc5b6041e0417df569de74875253f05d3
Author: Dirk-Willem van Gulik <dirkx@webweaving.org>
Date:   Tue Mar 17 12:42:01 2015 +0100

    tool: RFC4716 compliant key output
    
    Add a comment field to the ssh key output if a label is set on the key. Add RFC4716 compliant key output for the new breed of modern (mobile) SSH clients.
    
    VTA: use short form of log call in iso7816

commit 0790969b97083c1d90ec97292904d8fb7164d238
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Mar 31 14:17:40 2015 +0200

    recognize short EF identifier

commit a05e7ca84df68b21728ee11a5d1637bbacbd6ae9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Mar 31 14:29:42 2015 +0200

    ignore errors on `apt-get update`

commit 4a4d750e7383da4a4b71f55465efe3749df63735
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Tue Mar 31 16:52:05 2015 +0200

    iasecc: Fix log output is always displayed
    
      * iasecc_read_public_key function uses SC_SUCCESS instead of log level
      value, hence the log output is always displayed. This uses
      SC_LOG_DEBUG_NORMAL instead.
    
    VTA: updated to use short form of LOG macro

commit 117f3a74beb715f7d0fd43bd11a378ecf9db928e
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Tue Mar 31 15:33:43 2015 +0200

    iasecc: Fix key usage when provisioning card
    
      * Avoids overriding key_usage when creating objects on the card.

commit 548c2780d3faf9419c09aea5d5909b5d82685515
Author: Robert Quattlebaum <darco@deepdarc.com>
Date:   Thu Jan 15 14:44:21 2015 -0800

    Add support for ACOS5-64 cards.
    
    The ACOS5-64 cards have a different ATR than the original
    ACOS5-32 cards. This change simply adds this ATR so that it
    will be recognized properly.

commit 5007e9fc9fbcd866eef1eb54912fb1d97f805583
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Mar 28 13:04:41 2015 +0100

    md: fix build without OPENSSL_VERSION_NUMBER
    
    Fix the WCHAR / CHAR conversion problem in CardAuthenticateEx in case of PinPAD (vs->wzPinContext is UNICODE)
    Fix UNICODE compilation problem( MessageBoxA instead of MessageBox)

commit 3b873adad2e0fe22ff13cd7c2c9f5e87abe4ba4a
Author: vletoux <vincent.letoux@gmail.com>
Date:   Sat Mar 28 10:00:47 2015 +0100

    win32: allows UNICODE built.
    
    UNICODE is set by default by Visual Studio (but can be deactived)
    The trick is to force ANSI version by appending a A to the function calls.

commit c8d206ece1e3dd22282cf91c5047d993e316273e
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Mar 25 11:21:29 2015 +0100

    IsoApplet: Increase indicated version to 00.06
    
    Backward compatiblity with 00.05 is kept.

commit 907885667596b50b4e5be28e6afbb54433b5ec48
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Mon Mar 23 00:09:30 2015 +0100

    IsoApplet: register ECC mechanisms only when ECC is supported by card
    
    There are few Java Cards that do not support ECDSA at all.
    Starting with IsoApplet version 00.06, the applet returns whether the card
    supports ECDSA or not. This commit uses this information to decider whether to
    register ECDSA mechanisms or not.

commit 76facf0d73deea58bb15a8b8771006ef43e74bf3
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Mon Mar 23 00:08:11 2015 +0100

    IsoApplet: add support for GET CHALLENGE

commit e258cec13e417ce10c05be6c40fe3539824301b7
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sun Mar 22 14:49:59 2015 +0100

    IsoApplet: Add nistp224, secp192k1 and secp256k1 curves
    
    secp*k1 curves are only supported applet version >= 0.6.0 because of an issue
    with encoding ECC public keys with small parameters.

commit ab5ca331b2d8eb229bc83247fc69ab134ab5cd4f
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sun Mar 22 14:03:02 2015 +0100

    IsoApplet: Obtain applet version and card capabilities *after* match_card()

commit bba6e17aa982443a0a5337d21649d26201f899b0
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sat Mar 21 10:24:01 2015 +0100

    isoApplet: Fix indentation of isoApplet.profile

commit 090aed2fc239e4a2eda2fac5b4f22a7b281da275
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Mar 29 13:08:01 2015 +0200

    ec: fix length of allocated mem for EC signature
    
    discussion in PR #398

commit 4b51b997482d30e62725176422a98689958d77fa
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sun Mar 22 13:49:00 2015 +0100

    pkcs11-tool: harmonize supported ECC curves
    
    pkcs15-pubkey.c holds a struct containing supported ECC curves. The contents of
    this struct are being harmonized with pkcs11-tool supported curves.

commit f3573ede0db55b1ce08a3d8d71d7236cfa618761
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Mar 25 06:04:34 2015 +0100

    fixed requesting PACE features

commit b1bdfae20094de41c5d8435dc4d64b8896e04773
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Sun Mar 22 17:38:51 2015 +0100

    sc-hsm: revert broken a4c8d671
    
    sc-hsm: Fixed minimum value for number of password shares

commit 5149dd3e62594eb2477f699d834584991ab54d5f
Author: Wouter Verhelst <wouter.verhelst@fedict.be>
Date:   Thu Mar 26 13:16:04 2015 +0100

    belpic: Support 2K cards
    
    Recent BELPIC cards (issued since March 2014) have a validity of 10
    years (rather than 5 as before), and therefore also increased the key
    size from 1024 bits to 2048 bits.
    
    Key size can be detected by checking the applet version, for which we
    have to issue a "GetCardData" command. If the applet is version 0x17 or
    higher, keys are 2048 bits.
    
    Use #defines rather than magic numbers
    
    Keeps the code slightly more readable.
    
    While we're at it, refactor slightly so that the code which issues the
    GET CARD DATA command doesn't just keep the applet version, but also
    makes other things available.
    
    This latter in preparation of setting the serial number.

commit c019a6230900e0703c2b701332f9cb34166adc0e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Mar 28 01:36:52 2015 +0100

    pkcs11: parameter checking for 'get_mechanism_list'
    
    fixes #409

commit 435291f2166935e741e67539a55f191695874268
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Fri Mar 27 17:11:12 2015 +0100

    iasecc: initial support for Morpho IAS Agent Card
    
      * This commit adds initial support for Morpho French Agent card which is an
        IAS card. Signature operations are working. Since my test card was
        read-only, I was unable to test object management functions.
    
      * Add missing copy of AID in structure

commit c0c8a89126a0a11d315badcd778670d757b60f4c
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri Mar 20 18:08:18 2015 +0100

    mcrd: move driver to the end of detection list
    
    the drivers that need to probe the AIDs to recognize its supported card
    have to be placed at the end of the list of internal drivers

commit 2fffbce65cb4e616dacd5a9549379eac92e20687
Author: Hannu Honkanen <hannu.honkanen@aventra.fi>
Date:   Sun Feb 15 13:59:11 2015 +0100

    myeid: update EC support for MyEID-v4 card

commit b8c0df725a24ce6b89277fed596ab06fc859a9d4
Merge: 877fa86 1becc45
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Mar 11 21:55:04 2015 +0100

    Merge pull request #390 from lbakman/master
    
    Fixed issue with building dnie-tool bash_completion script
    
    closes #392

commit 1becc45c108f0934423e72da5cfda63c29c76079
Author: Lau bakman <lau@bakman.dk>
Date:   Tue Mar 10 09:15:11 2015 +0100

    Updated dnie-tool.1.xml for consistency
    
    Experienced a problem with dnie-tool where I would receive a warning with the content of /etc/bash_completion.d/dnie-tool.
    
    The cause of the error was a missing case label which in turn was caused by the formatting of the dnie-tool.1.xml.
    
    Options were formatted like <term><option--xarg, -x</option></term> which were not handled by the sed regular expression in the makefiles.
    
    Modified the dnie-tool.1.xml file to be consistent with the other doc files and to generate the dnie-tool file correctly.

commit 877fa862d99ee6177973ac2d80178449836cb5c3
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Mar 8 11:26:16 2015 +0100

    isoApplet: prototype of asn1_sig_value_sequence_to_rs() has changed

commit 595be37feeeb7b2355c9f543d8061da980a39be8
Merge: 2abe135 74aeb8c
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Sat Mar 7 23:36:25 2015 +0100

    Merge pull request #305 from philipWendland/master
    
    Add support for the IsoApplet Java Card applet

commit 2abe135f971aca7a3ecc231d10f96b5fddee078a
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Mar 7 21:36:16 2015 +0100

    asn1: re-fix error in EC signature encode helper
    
    see comment for https://github.com/OpenSC/OpenSC/commit/8cf99a93726e735e04ed2563f14e315a60a4a859

commit 1739300657dfa6148f82c39b5a062bc679357649
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu Mar 5 10:31:13 2015 +0100

    pkcs15: fix name of EC curve, add new ones

commit 6f6286de99a62ab0d2edf6023f39cfa8db139420
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Feb 24 17:38:39 2015 +0100

    pkcs11: generate EC key: use allocated EC params
    
    For internal use allocate and copy the EC params data from the caller's template,
    rather then use them directly as a pointer in internal public key data.

commit 31124ac4f906ba8a331bde47d23bc89757f1829f
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Mar 1 13:38:50 2015 +0100

    pkcs15init: allocate EC parameters

commit 1123768ac3b722afe3a0d662967515c547530554
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Feb 24 18:13:53 2015 +0100

    libopensc: invalid 'free' and 'assign NULL' order

commit 8cf99a93726e735e04ed2563f14e315a60a4a859
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Wed Mar 4 19:20:12 2015 +0100

    asn1: fix error in EC signature encode helper
    
    The raw format of EC signature was invalid when 'r' and 's' had different length.
    https://github.com/OpenSC/OpenSC/pull/381#issuecomment-77016382
    
    According to PKCS#11 v2.20:
    "If r and s have different octet length, the shorter of both must
    be padded with leading zero octets such that both have the same octet length."

commit 74aeb8c92325ab7730f32712144c79c0ffee98bb
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sun Feb 22 23:08:18 2015 +0100

    IsoApplet: register supported EC curve *per curve*

commit 58d1f1db3f0c8a8880d05301b803fb5524eabdc8
Merge: 9f3dbaa 0ffad3f
Author: Doug Engert <deengert@gmail.com>
Date:   Sat Feb 21 21:51:50 2015 -0600

    Merge pull request #385 from darconeous/patch-2
    
    Allow PKCS15 cache to work with PIV cards (if enabled)

commit 85d16fbc57170bf2177e0d29d7c70993fb01d27c
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Feb 17 20:23:21 2015 +0100

    IsoApplet: use helper function sc_asn1_sig_value_sequence_to_rs() introduced in #381

commit 1aeebdaf1c0ad1143329eac62aaf75cf3f0fe055
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Feb 20 22:56:23 2015 +0100

    IsoApplet: react to changes of _sc_card_add_ec_alg() in fa923831f8e8073f0b57ea492c9e2e93f661a373

commit 59eeacb74b3971c0f510230feba01516c5e8e9d1
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Feb 20 22:07:49 2015 +0100

    IsoApplet: react to removal of sc_pkcs15_ec_parameters in fa923831f8e8073f0b57ea492c9e2e93f661a373

commit a9d43af4bf08d46b369bf4f59ad892005e325085
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Thu Feb 19 21:10:38 2015 +0100

    IsoApplet: use a buffer large enough when generating EC keys larger than 320 bit

commit 3312c1e2b9967942e04f498c7a84b939ec5f8b96
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Feb 17 23:24:42 2015 +0100

    IsoApplet: install isoApplet.profile on windows

commit da05fa2a473354ab8beb6edff89c9dc84d102148
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Feb 3 21:59:28 2015 +0100

    IsoApplet: try to fix EC parameters when importing private keys from file

commit 44d724b012484b751bb24d40c20196ff29105242
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Sat Nov 29 15:43:23 2014 +0100

    IsoApplet: fix more (comment) alignment issues with tabstop=8

commit 5628a06353e34c5462b132a9f288a438204d52bd
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Nov 28 19:06:21 2014 +0100

    IsoApplet: Align comments with spaces instead of tabs
    
    Better view with tabstop=8.

commit 43fa99c0f2943fc86a241501919bba3491a8c1f7
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Nov 28 18:14:24 2014 +0100

    IsoApplet: Move the key gen debug info to the right places

commit 0473decae4dbc3b463028c59015a6086f9e3fa00
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Nov 28 18:06:13 2014 +0100

    IsoApplet: clear memory after prkey import.
    
    Private key import via plain APDUs is dangerous and not recommended anyway, but clearing the apdu buffer does not hurt anyone.

commit 73b391731b49ad37625ef52ca60f84f56112963a
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Nov 19 21:54:10 2014 +0100

    IsoApplet: Don't set ECC field length of 512
    
    512 is wrong for EC FP (correct would be 521 bit), and neither of those
    two are currently supported by OpenSC.

commit e791948e4230cad5d8def22f5148ceaf9248e837
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Nov 19 14:04:40 2014 +0100

    IsoApplet: Simplify the private key import
    
    Use the new features of sc_asn1_put_tag introduced in OpenSC/OpenSC#314.
    Additionally, a RSA private key is sent from one large buffer using either extended APDUs or chaining (in compliance to IsoApplet API version 00.05).

commit 6cdf6c08a598779903ff5eb81850d8cf574f6ba0
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Thu Nov 13 13:51:10 2014 +0100

    IsoApplet: use AID directly when selecting applet
    
    Now that apdu.data is const (see ef94c6b875b7927bb80e49139a29a3ce2b4937b7), this can be done without discarding the const qualifier of the aid parameter.

commit 09acfd7ec00d6561a9561c243cc75470d414cd2e
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Oct 31 17:17:00 2014 +0100

    IsoApplet: ECDSA signatures - only strip excess zeroes
    
    It is required to strip excessive zeroes returned by some Java Cards when removeing the ASN1 structural information for PKCS#11 so that the x/y can be calculated by dividing the signature length by 2. However, the leading zero may only be stripped if it is excessive (outside the field length). Otherwise generated signatures are wrong in rare cases (1 out of 256).

commit c463f1a7a1e4bfa653c6d34f5ee4f0a2d41883b1
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Oct 28 11:17:45 2014 +0100

    IsoApplet: Do not set RSA hashes
    
    See: 189e998486a5813bca2f6737a465ad62abb318c7
    The IsoApplet requires the host to do the hashes with RSA. OpenSC will
    add all hashes that are available in software and will not expect the
    card to do the hashing.

commit e3cc851b728ce7c5e681f67c58ef9788f74ca2fd
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Oct 28 08:58:30 2014 +0100

    IsoApplet: EC key-gen rework and refactorings
    
    Rework the EC key generation mechanism to send the curve parameters to
    the card. In earlier versions, the applet had a copy of the curve
    parameters and there was a different algorithm reference for every
    curve. This is unfeasible when trying to support a larger number of
    curves because of size limitations of the applet.
    This commit additionally includes some refactorings that should not
    change the functionality.

commit 6f9e894ebe8189eaf64fc20f644c3683b3f42930
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Oct 21 16:05:06 2014 +0200

    IsoApplet: set lock when doing command chaining

commit 48bd6b09645014365a2be8361d113757a1736814
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Thu Aug 28 14:29:16 2014 +0200

    Add support for the IsoApplet (Java Card applet)
    
    The IsoApplet can be found here:
    https://github.com/philipWendland/IsoApplet
    Add read/write support for this applet, including RSA and
    ECC support.

commit 9f3dbaa39dbb2c6c4515bb2ea0ec78023d10bdb4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 9 23:23:12 2015 +0100

    honour warnings

commit bff0ea483711a044f514ccee0e4ab5552dbea2bb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 9 23:16:31 2015 +0100

    fixed compiler warning

commit 16ea926d2980ab9b92d94bd649cdb9a4ce6d769a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 9 23:11:58 2015 +0100

    fixed indentation

commit 236e68b17c85be8b7507615a99663f5f6da3438c
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Feb 5 17:43:14 2015 +0100

    fixed NULL dereference

commit da07e22c97effe27d8decf4037f314e4015da1eb
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Feb 5 17:40:43 2015 +0100

    use memmove for overlapping memory

commit ced77ae6c7360914e746178b369561ad7fac84dc
Author: Pedro Martelletto <pedro@ambientworks.net>
Date:   Tue Feb 17 17:14:40 2015 +0100

    cardos: overwrite content of deleted private key
    
    when deleting a private key object, overwrite its contents so the key can no longer be used.
    
    (VTA: original commit touched to use LOG macros and add debug logs)

commit b08671fab5b500ed18e7fe189d8e6aadbaf22f4b
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Feb 15 13:57:47 2015 +0100

    pkcs15-crypt: option for output format of ECDSA signature

commit 80c496671f5bb513a1298b462040ed12d549fb2b
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Feb 15 13:56:51 2015 +0100

    helper functions to change format of ECDSA signature

commit fa923831f8e8073f0b57ea492c9e2e93f661a373
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Feb 14 17:47:59 2015 +0100

    introduce EC curve OID into algorithm info data
    
    needed to store information about EC curve supported by card.
    Primary usage is when importing/generating key to get know if particular curve is supported by card.

commit 45a4def5fdb0f0ea05bd36661f5ecc617b16af8c
Merge: e37690a d7475c8
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Feb 16 10:57:01 2015 -0600

    Merge pull request #382 from dengert/piv-fix1
    
    Add brackets   in card-piv.c

commit d7475c8180c7fe96a85f13184c05bbe0fec20c3c
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Feb 16 10:43:19 2015 -0600

    Add brackets   in card-piv.c

commit e37690aed56d36dcdfd43762ee910465b9f44e87
Merge: 14ed749 572218c
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Feb 16 10:29:36 2015 -0600

    Merge pull request #376 from dengert/piv-reverts
    
    Fix-up changes caused by Coverity scan See #366 in PIV code

commit 572218c59c8323c76a243763604801fb3587bf63
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Feb 16 10:11:24 2015 -0600

    Fall through comment before break

commit 14ed749a88432f1b061302dd75a55e27b5d2be79
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Fri Feb 13 16:52:10 2015 +0200

    Create CONTRIBUTING.md
    
    So that new issues and pull requests could get some information.

commit 0ffad3f3bb9c893ab5a06998c7c7f0d571e7918d
Author: Robert Quattlebaum <darco@deepdarc.com>
Date:   Mon Feb 9 02:13:37 2015 -0800

    Fix for bad caching behavior of PIV PKCS15 emulator.

commit 981a0fbbaf36b9f2e0b725e5c19c7a42e3e32c61
Author: Doug Engert <deengert@gmail.com>
Date:   Wed Feb 11 13:39:59 2015 -0600

    Fix-up changes caused by Coverity scan
    
    piv-tool.c add  /* fall through */ to avoif false warning
    card-piv.c - clean up if sc_lock fails.

commit 3c1d8ad69557adf6aab08bc549188425c8b33a92
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Feb 7 21:14:17 2015 +0100

    accept no output for 'SELECT' MF and 'SELECT' DF_NAME
    
    PR #342

commit d1621439648f29b0b1a5306bdf108007e695380b
Author: Martin Campbell <martin@campbellsoftware.co.uk>
Date:   Wed Jan 28 11:54:58 2015 +0000

    Updating to fix failure of ePass2003 USB smart card due to failure to re-authenticate secure messaging when card is reset due to multiple applications using PKCS11 sessions

commit 22fb49b5545a09bf7b4be071ef189388e6a582b1
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Jan 28 17:57:58 2015 +0100

    PKCS#11: Improve compliance for public keys.
    
      * Key usage required when calling C_CreateObject for public key are not used.
        This adds the logic to convert from PKCS#11 attributes to PKCS#15 in the
        structure that is sent to underlying _store_pubkey functions.

commit 96265e6d08a0be51d7d83468d9e42bd54a7b409a
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Feb 3 19:05:19 2015 +0100

    pkcs15init: superpluous 'ec-params' in init data
    
    Pkcs15init data, used to import/generate key objects, includes twice the same EC parameters data:
     - explicit 'params' data
     - part of sc_pkcs15_pubkey/sc_pkcs15_prkey
    Explicit 'ec-params' data is removed.

commit e374f88b82b047a55ce557f3e90a80b76eb0108e
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon Feb 2 16:39:18 2015 +0100

    pkcs15-pubkey: add EC params in SPKI encoding

commit 9148f21cd1079c53796b420f16e42b3b365d41aa
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon Feb 2 16:34:37 2015 +0100

    pkcs15-pubkey: possible NULL dereference, logs
    
    ... remove obsolete comments, minor coding style corrections

commit faaa11e091001f063dac46f29f0aad28c2494a18
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Wed Jan 28 22:59:28 2015 +0100

    Prefer serial number from EF(TokenInfo) and cached serials over CARDCTL
    
    sc_pkcs15_get_object_guid() should prefer the serial number from
    EF(TokenInfo) over card->serialnr because the user may override the
    card's serial number with "pkcs15-init -C --serial". The card->serialnr
    should be used before calling card CTL with SC_CARDCTL_GET_SERIALNR
    because it might contain a cached value.
    
    This change *should* allow cards to be used with the minidriver even if
    SC_CARDCTL_GET_SERIALNR is not implemented. For example, a driver might
    set card->serialnr at initialization or the user might initialize a
    PKCS#15 card with its own "--serial".
    
    See also the discussion at the mailing list:
    [Opensc-devel] AT_SIGNATURE and AT_EXCHANGE Problem

commit 08eb700b9749c17e8ff29ddb45b3132d8d38308e
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Feb 7 18:55:02 2015 +0100

    revert or partially revert some of recent commits
    
    b94c163 - invalid, non-tested
    11881a6 -- src/libopensc/card-iasecc.c -- return from select has to be ignored,
    3a92bf7 -- src/pkcs11/slot.c -- SEGFAULT issue #373
    3a92bf7 -- src/tools/piv-tool.c -- confirmed by author
    6759c04 -- src/pkcs15init/pkcs15-lib.c -- file instantiation error has to be ignored

commit 3a92bf7af5aaa85fdbc0434d0a55393e68e0f98d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Feb 5 01:36:40 2015 +0100

    fixed resource leaks

commit 11881a61b8247bde7618cf0f842bf7fc0285e803
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Feb 5 00:43:05 2015 +0100

    removed/fixed dead code

commit a3fc62f79ff867ca2a2c5be24aff1759d3476417
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 4 19:19:57 2015 +0100

    fixed NULL dereference (or warning thereof)

commit 8d902d1ed3f0763d89e3b064f6c24d214818bf96
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 4 09:24:50 2015 +0100

    fixed out of bounds read/write/access

commit a4c8d671108bca5ce93472f4e3555d59682aff55
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 4 09:03:27 2015 +0100

    fixed improper use of negative value

commit 761e1752122c789a58c620a645cace4652af9801
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 4 08:52:30 2015 +0100

    fixed sc_driver_version check

commit 5cafbe0f4b6fe07abf002f1094bfafbd5244b25d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 4 08:50:19 2015 +0100

    fixed undefined shift behaviour

commit ed9572422fa39e673cbbd260a28b079bd5c752a9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:51:04 2015 +0100

    check return values

commit 47df45f5f260f0b89e23e44d1442f4f15d82cb6b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:34:42 2015 +0100

    set le instead of p2 twice

commit 5e3d54186ac5ca24b0d6181b13888787610ba019
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:31:55 2015 +0100

    removed useless check for non-null array

commit ac4da89d0dfebfbf87be3f4936daa42a0ebc6477
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:30:50 2015 +0100

    use memmove for overlapping memory

commit 53e1992cc2c51f2fe701be2fa258fd06cf51d101
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:26:56 2015 +0100

    use strerror for failure of gettimeofday

commit 9cb4a09e302cbe4f4055aac194bb0b029d5fe528
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Feb 3 09:45:40 2015 +0100

    readme.md: add jenkins build status

commit 44ed1a3d6b84da6bac473c12d24acfcd462f3b41
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Feb 3 09:27:16 2015 +0100

    readme.md: fix url of status icon

commit 6a7875c4af474a474816fccbf17bbf2aa028bc9f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 3 00:21:41 2015 +0100

    use general travis-ci badge

commit 2a7db13d3429b48f0b2f81e3ca56e875b1a7ff7d
Merge: 02214dc db0cb75
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 2 23:59:59 2015 +0100

    Merge branch 'master' into coverity_scan
    
    Conflicts:
    	.travis.yml

commit db0cb7557cf1b16eef99b9a2989bb4021ec816fd
Merge: 2f3eaa1 ea40322
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 2 23:51:54 2015 +0100

    Merge pull request #363 from frankmorgner/travis-ci
    
    added travis-ci configuration

commit 2f3eaa1dbec3bd28177284e265847662b14910a2
Merge: 3047fe2 6759c04
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Feb 2 23:51:10 2015 +0100

    Merge pull request #366 from frankmorgner/coverity
    
    Fixes for Problems reported by Coverity Scan

commit 3047fe2c3b366c6e15f256e3a604f03c77779413
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon Feb 2 16:25:54 2015 +0100

    log: implement 'dump OID'

commit 8e9a2361c6819b7ac991acfe8034a2d8f14dfe70
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon Feb 2 16:24:16 2015 +0100

    pkcs15-tool: print length of EC public key
    
    when this key is read from dedicated EF

commit 6759c04b26127b62fbe01f368daa764e94ffe08d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 04:45:08 2015 +0100

    don't ignore errors

commit 2e04fa99c11c47b2c5c7f5b4bd5474bc310e51ad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:39:35 2015 +0100

    fixed pointless array comparisons

commit bd3cfcf5ef9770535369f679351d256a8c1e8a6d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:26:34 2015 +0100

    fixed copy/paste error

commit b94c16394f89b78f9d43ecd7a8fb25f3e25b842e
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:25:46 2015 +0100

    card-asepcos: fixed puk handling

commit 734cb67924be16d0d03a8dadd92043e1f4396fd4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:23:34 2015 +0100

    fixed algo ref

commit 3a557ad0dddcd89e569ef69c048ceae8955974a7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:22:03 2015 +0100

    fixed parsing pace output data

commit 92ad6eb63c5d32ac12331f2f8d13780f1b8a75e5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:21:55 2015 +0100

    fixed determining ef type

commit 7fb495ac314b97e4196732a5b0bc6b789afdc2c7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:10:57 2015 +0100

    fixed self assignment

commit ac0424e947098a65a011368f1e13242aa0416e6b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:09:02 2015 +0100

    fixed pkcs11spy's version number

commit b9f1fb333ccc2a3fbdc3d351c4253310e32720dc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:07:33 2015 +0100

    fixed bad output data length

commit 08fcfcc8f0b4b3c7a987b25d22430acbe8868975
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:04:02 2015 +0100

    fixed wrong sizeof argument

commit 87b2403673ca84870698b5d8ccf0efe831506c14
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 07:00:02 2015 +0100

    fixed out of bounds access/write

commit 68d86644fd642f71e0295a81aa356e7fde319abd
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 06:10:16 2015 +0100

    fixed use after free

commit b1b99ce7e5973569e743c3ce285b2730d759ed72
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 06:03:52 2015 +0100

    fixed integer underflow

commit 027e4a08679c1bacb139e990ec33b8a61f3d416a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 05:59:41 2015 +0100

    fixed out of bounds read

commit 7c497b324f8a79cec3dc374373efe6e2040bab2b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 05:51:00 2015 +0100

    fixed not null terminated buffer

commit 77752f442d90665b814f5a7fbbe5d3f28000860b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 05:47:20 2015 +0100

    fixed unused value

commit fdd38f6e0437077086a793dadc912f07c75d8774
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 28 04:30:40 2015 +0100

    fixed copy into fixed size buffer

commit ea40322a30a8053ee859a3a5ae9d20d17af830da
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Jan 21 16:57:02 2015 +0100

    added travis-ci configuration

commit 02214dca86d44064939b8dff61bd571cb0c793ac
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Jan 27 08:54:32 2015 +0100

    coverity-scan: test build

commit b6a935a261d87fa77f1682763ff7c7f55189f246
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 23:12:47 2015 +0100

    fixed memory leak

commit 00330b2c7937bbceae3e3ebfae112c626c7ae231
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 22:16:22 2015 +0100

    fixed resource leak

commit 6641cbf45559050ebcc059ed3df33e26ea185c15
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 20:17:26 2015 +0100

    fixed potential string overflow

commit 3f64d3a805b93f1c436c321c3fb832757d4c07b4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 20:11:16 2015 +0100

    fixed bad memory allocation

commit 9a4b58800b8c1fc89f598d52b28994be2fbf8bd7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 20:00:03 2015 +0100

    fixed Printf arg type mismatch

commit fca3a37097a7653dfc318ca8e99450cbd2747eea
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 19:47:01 2015 +0100

    fixed truncated stdio return value

commit 8df9896204f4d776bd312f725436f2f791abd377
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 19:25:11 2015 +0100

    pass big parameter by reference
    
    reported by coverity scan

commit c9213164450775c0e32cec062150b67ee13af9d9
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat Jan 24 19:23:33 2015 +0100

    coverity-scan: connect to GitHub

commit 1b53b59ed393057cc7840b916d4081ef64a1da74
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Jan 24 19:22:39 2015 +0100

    fixed potential use after free
    
    reported by coverity scan

commit 7a34c204c1904b789a1842003071b4da3d7c0932
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jan 22 20:29:33 2015 +0100

    fixed dereference before null check
    
    silence warnings reported by coverity-scan

commit b13bb3cbf53fede96e5d397329fd2ece18b98d0c
Merge: f143d7b 762d466
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Wed Jan 21 08:55:34 2015 +0100

    Merge pull request #360 from mbrossard/pullrequest
    
    PKCS#11 updates

commit 762d466b237409b23ab597df4a380b41e755b638
Author: Mathias Brossard <mathias@brossard.org>
Date:   Tue Jan 20 23:02:35 2015 -0800

    Add display of Elliptic Curve flags

commit 7a455f64c79018e3bd6234ee19080047f3a11c81
Author: Mathias Brossard <mathias@brossard.org>
Date:   Tue Jan 20 23:01:30 2015 -0800

    Support of additional type, mechanisms and attributes

commit 3dadd3fba170db7dcfac7b80cdfa063520fd9da9
Author: Mathias Brossard <mathias@brossard.org>
Date:   Tue Jan 20 23:00:28 2015 -0800

    Add some missing PKCS#11 values

commit 17c1cffb3d90739238dd3ffc3c73af2a1dc87bb3
Author: Mathias Brossard <mathias@brossard.org>
Date:   Tue Jan 20 22:58:13 2015 -0800

    Fix typo on CKF_EC_UNCOMPRESS

commit c3a0bbc71583e80f9e794aca0896040c693db53e
Author: Mathias Brossard <mathias@brossard.org>
Date:   Tue Jan 20 23:14:36 2015 -0800

    Update email and year

commit f143d7b73e2274ae840d4c4cd512885a927cfc54
Merge: 79f1539 28ea6bc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Jan 20 23:43:48 2015 +0100

    Merge pull request #346 from frankmorgner/pkcs11provider
    
    use OpenSC as default PKCS#11 provider

commit 9543cdb121924b331bcf6cbfbccf9f3928472fa9
Author: Joachim Bauch <bauch@struktur.de>
Date:   Tue Jan 20 16:52:30 2015 +0100

    Handle case where input data is already padded.

commit 87cc05c03fefdb0e00fe53546b3286ed048c60de
Author: Joachim Bauch <bauch@struktur.de>
Date:   Tue Jan 20 16:49:11 2015 +0100

    Receive signature to temporary buffer, will be copied to output buffer later.

commit 79f1539e6897d9527fc8657a1b6cb3446339e9c9
Merge: 4915eaa 91ddcfb
Author: viktorTarasov <viktor.tarasov@gmail.com>
Date:   Tue Jan 20 10:18:27 2015 +0100

    Merge pull request #352 from tc-anssi/better-compliance
    
    Better PKCS#11 compliance

commit 28ea6bc607dafa1f502d661d1ee6a855e678e7cc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Jan 20 00:53:51 2015 +0100

    added DEFAULT_PKCS11_PROVIDER to winconfig.h.in

commit 19bbfc76f5ace2ef17f2cb17f0315889e1607b39
Author: Joachim Bauch <bauch@struktur.de>
Date:   Mon Jan 19 18:04:12 2015 +0100

    Added initial support for STARCOS 3.4 (German D-Trust cards).
    
    Code inspired by experimental STARCOS 3 driver by Martin Vogt:
    http://article.gmane.org/gmane.comp.encryption.opensc.devel/9846
    
    Supports `opensc-explorer`, `pkcs15-tool` and `pkcs15-crypt` (signing with PKCS#1 padding).
    
    Cards available from `https://www.bundesdruckerei.de/en/768-d-trust-signature-cards`.

commit 91ddcfb514991b75dacc143e427f8dd01f98c5e9
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Fri Jan 16 10:03:13 2015 +0100

    PKCS15: remove redundant code for access_flags.
    
      * With commit facaf59, access_flags were set for most cards. A closer look
        revealed that this is already done in `sc_pkcs15emu_add_rsa_prkey`.
        Therefore, this removes the duplicated code for cards calling this function.

commit ed87ea38b9e8439eb7a20f6497f23b40beff25f8
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Jan 14 17:37:08 2015 +0100

    PKCS#11: Fetch real value of CKA_LOCAL for pubkey
    
      * Fetch value from pub_info structure for CKA_LOCAL attribute.

commit d727acb47a58684dd46c7dd5c452eee07eac1a6f
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Jan 14 17:22:43 2015 +0100

    PKCS#11: Remove inconsistent attributes
    
      * Improve compliance related to PKCS#11 attribute fetching.

commit 4915eaa56b4e81346e1696b2cb38a0f2df14db5b
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Dec 3 17:59:04 2014 +0100

    Improve PKCS#11 compliance. Issue #335
    
      * This simple patch allows for values of PKCS#11 attributes to be fetched
      from the underlying card.

commit bbedd4ef00bf457fdf11be7899c64579248885e1
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Wed Dec 3 18:05:32 2014 +0100

    IAS-ECC: improve PKCS#11 compliance Issue #336
    
      * Ensure CKA_ALWAYS_SENSITIVE and CKA_NEVER_EXTRACTABLE are only set when
      generating the key on board, not reason to set them when importing a private
      key.

commit 32d8173b4c48e94fe39c97d2d2ba9b48aa47e19e
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Fri Dec 19 17:21:37 2014 +0100

    IAS-ECC: Improve detection Gemalto cards(Issue #343)
    
      * Improve IAS-ECC card detection using the ATRMask.
        Previous commit was revert since work was not done in topic branch.

commit 7e7a44acff9d3aec082076b556a9363081df862a
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Tue Oct 28 09:05:02 2014 +0100

    sc_asn1_put_tag - support larger tags
    
    Enhance sc_asn1_put_tag to support larger tag names and larger tags.
    Prior to this, sc_asn1_put_tag did only support tags with a length of at most 127 bytes and tag names of one byte.

commit 3961275d8c680771b1669f44a388d6d84a614e14
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Nov 3 15:49:28 2014 +0100

    Allow user to overwrite SO-PIN when using PIN-PAD reader

commit facaf5969bc80ac82395fa2789df32c48e373085
Author: Thomas Calderon <thomas.calderon@ssi.gouv.fr>
Date:   Fri Dec 19 17:15:41 2014 +0100

    Improve PKCS#11 compliance. Issue #335
    
      * Add default behavior for cards using the PKCS#15 emulation layer.
        Hence, this patch provide a default value for access_flags compatible with
        current OpenSC's behavior while allowing compatible cards to fetch the real
        value from the card (IAS-ECC and AuthentIC).

commit 291e9dab9e9032348908283675c71d563ec5fe95
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 19 22:12:25 2014 +0100

    use OpenSC as default PKCS#11 provider
    
    closes #229

commit 2a966734f48c93b1cb5cb84aa0d017647d681bc5
Merge: 1197fbe aa7886f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 19 17:38:56 2014 +0100

    Merge pull request #345 from philipWendland/upstr-pkcs15-init
    
    pkcs15-init: fix memory corruption

commit aa7886f36dd99de34c7105aa66c216f4a50dd248
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Fri Dec 19 16:52:14 2014 +0100

    pkcs15-init: fix memory corruption

commit 1197fbea3677dd2bca84ad8ce0061d5489eb9d07
Merge: 4167455 d6bb845
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 19 11:59:12 2014 +0100

    Merge pull request #330 from dengert/pkcs11-buf-too-small-simple
    
    C_Digest does not check if buffer too small before update. Issue #327

commit 41674553624e828fe37f55403eec3dfd93853c2e
Merge: a7bf05e 867176b
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 19 11:47:26 2014 +0100

    Merge pull request #321 from resoli/master
    
    Implementation of card_ctl function with SC_CARDCTL_GET_SERIALNR

commit a7bf05ecc4bb73c7f6b82287f97e6b8d11216521
Merge: 99e42df 45fe965
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 19 11:37:48 2014 +0100

    Merge pull request #337 from frankmorgner/7816
    
    7816

commit 99e42df7bc89e8431c250857c6948244cd8515c3
Merge: c2d33fd 4d5997d
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Mon Dec 15 21:45:50 2014 +0200

    Merge pull request #341 from frankmorgner/muscle
    
    Fix MuscleApplet selection

commit 4d5997dfba5845820e301e8804c3335122403bad
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Dec 12 22:30:21 2014 +0100

    fixed selection of muscle applet for some JCREs
    
    Previously, partial DF name selection was used, which is not mandatory
    to implement for a JCRE. We now use the full DF name which must always
    be implemented.
    
    Note that the MUSCLE applet is deprecated and should not be used.
    
    fixes #135

commit 45fe96579fed3433ecd75cc1bd8d1516c4142aa2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 10 22:58:48 2014 +0100

    added support for sc_path_t with only aid set

commit 73715e37d92f60b4afbc6c608cbc281313781eb1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Dec 7 17:19:57 2014 +0100

    fixed compiler warnings
    
    fixed warnings introduced with b18c86e64621fa61555831802d9cd597e24e0ebc
    
    fixes memory leaks in pkcs15-init and pkcs15-tool

commit e137396d5655917e66bd34022026bb6462e9c541
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Dec 7 17:19:45 2014 +0100

    workaround for compiler warnings

commit e1fbdc030bab6355d9c69026da692bf50df06295
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Dec 7 11:52:14 2014 +0100

    iso7816: make select agnosting to sc_path_t's aid

commit 69b27179eb65f645939aaa36faf72a38c5b07143
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Dec 7 11:32:14 2014 +0100

    use path only if it is actually present

commit c71a453ff1e19721a9245b8a2d637eabd9f12e54
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Thu Dec 11 12:51:15 2014 +0800

    openpgp-tool: Fix wrong operator
    
    Used "!=" instead of "|="

commit c2d33fd72eb4f9daafb14348727910bda39d00a3
Merge: ec2eb86 238b9e3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 10 11:08:15 2014 +0100

    Merge pull request #339 from OpenSC/revert-318-master
    
    Revert "Added ATR for ItalianCNS - Prov. BZ"

commit 238b9e344abfda7bde1876955213f1bad3052803
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Dec 10 11:07:56 2014 +0100

    Revert "Added ATR for ItalianCNS - Prov. BZ"

commit 99b5cb53e1da2f0d7692f28dceff8485d4b74daf
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Dec 10 03:59:54 2014 +0800

    OpenPGP: Remove unused variables and fix type cast.

commit 7f089832407d7e5dcc22a75e383065fccf9a0d36
Merge: 4ab317a ec2eb86
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Tue Dec 9 02:40:33 2014 +0800

    Merge branch 'master' into gnuk
    
    Conflicts:
    	src/tools/openpgp-tool.c

commit ec2eb86bec4d24ff7e3779a1614c85b40f1627b4
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sun Dec 7 23:51:25 2014 +0100

    don't reimplement output of status words
    
    Closes #326

commit 9cbec38cfa2afb87013866e4e114afbdc6865e9d
Author: Etienne Cordonnier <etienne.cordonnier@theobroma-systems.com>
Date:   Mon Nov 10 18:24:56 2014 +0100

    Fix bug in verbose flag handling.
    
    Using the verbose flag was causing cardos-tool to return as if an error
    had occured.

commit 1408e25e4bc059cbbb1cd36f99545d53f0f9e237
Author: germanblanco <german.blanco@gmail.com>
Date:   Fri Nov 21 11:37:41 2014 +0100

    Removal of cache, fixing a compiler warning and removing recursive functions.

commit fce847bf2504617b2de246753de3de5362a220a5
Merge: a2ba4d3 ccd87e7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Dec 6 23:32:31 2014 +0100

    Merge pull request #318 from sschutte/master
    
    Added ATR for ItalianCNS - Prov. BZ

commit a2ba4d3baed3391736807452ea6f2652d974d9da
Merge: b18c86e d014056
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Dec 6 23:22:43 2014 +0100

    Merge pull request #319 from CardContact/add-sec-k-curves
    
    sc-hsm: Add support for Koblitz curves secp192k1 and secp256k1 (Bitcoin)

commit b18c86e64621fa61555831802d9cd597e24e0ebc
Merge: 8188b8a aa45685
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Dec 6 23:21:39 2014 +0100

    Merge pull request #320 from frankmorgner/tools-pin
    
    Optimize util_get_pin from #289

commit 8188b8acacb201e4627242edb65db02b3af38bb6
Merge: cd01a73 3f442c5
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Dec 6 23:16:21 2014 +0100

    Merge pull request #322 from frankmorgner/iso-ext
    
    adjust send/receive size accoriding to card capabilities

commit cd01a73cafd89ef7672c9d5602428dccb549f32d
Author: Doug Engert <deengert@gmail.com>
Date:   Wed Nov 19 19:31:18 2014 -0600

    C_Digest does not check if buffer too small before update. Issue #327
    
    C_Digest will now query for the buffer size using sc_pkcs15_md_final
    before calling sc_pkcs15_md_update. This avoids doing a double update
    when the user passes in a buffer to small, then gets the buffer and calls
    C_Digest again.

commit 8aadbbd678730dbafb819382da553439887499fd
Merge: 67fcda1 0c0b214
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 26 20:16:37 2014 +0100

    Merge pull request #332 from Ecordonnier-theobroma/westcos-tool
    
    Translate French to English.

commit 0c0b2145ac3483e0477bb2c6d3198802f05e45c0
Author: Etienne Cordonnier <etienne.cordonnier@theobroma-systems.com>
Date:   Wed Nov 26 18:59:33 2014 +0100

    Translate French to English.

commit d6bb845a22953587459e56e6874d1a944588f7d1
Author: Doug Engert <deengert@gmail.com>
Date:   Wed Nov 19 19:31:18 2014 -0600

    C_Digest does not check if buffer too small before update. Issue #327
    
    C_Digest will now query for the buffer size using sc_pkcs15_md_final
    before calling sc_pkcs15_md_update. This avoids doing a double update
    when the user passes in a buffer to small, then gets the buffer and calls
    C_Digest again.

commit 3f442c560870f9d2af05e436c358dc414edd07f9
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Nov 7 00:05:54 2014 +0100

    adjust send/receive size accoriding to card capabilities

commit 4ab317ad2f2883ed78b7d95f206d308a0b2489fc
Merge: 901c795 8d21cea
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Nov 12 01:33:58 2014 +0800

    Merge pull request #3 from Nitrokey/gnuk
    
    hardcode->defines for DO's

commit 8d21cea7fcea9960f52fa9e0f7893435f01521a4
Author: george <ggkitsas@yahoo.com>
Date:   Tue Nov 11 16:16:15 2014 +0100

    hardcode->defines for DO's

commit 901c7952c1d833860f488b0dd2e2382662198ec9
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Nov 9 15:58:40 2014 +0700

    Replace hardcode.

commit 67fcda16363764fb154047d06a802cb9ed1d8a0f
Merge: 57cd22e 5448901
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Sat Nov 8 18:30:40 2014 +0200

    Merge pull request #308 from martinpaljak/yosemite
    
    Building on newer OSX versions without xcode command line tools

commit 57cd22e586c933bb19b677db4628d6dde83394b4
Merge: d00d7b3 4dbfba3
Author: Doug Engert <deengert@gmail.com>
Date:   Fri Nov 7 20:01:52 2014 -0600

    Merge pull request #324 from dengert/piv-gzip-cert
    
    Use correct bit when writing PIV certificate object with gzipped certifi...

commit 4dbfba3102929e731faca5320be028394a83f994
Author: Doug Engert <deengert@gmail.com>
Date:   Fri Nov 7 19:49:36 2014 -0600

    Use correct bit when writing PIV certificate object with gzipped certificate
    
    NIST 800-73 clarified the CertInfo flag for gzipped certificate is 0x01
    piv-tool was writting 0x80.
    OpenSC card-piv.c continues to accept both.

commit 867176b0f7f50df6e31d3bea0bb07cd8b12a0aae
Author: resoli <roberto@resolutions.it>
Date:   Fri Nov 7 12:49:44 2014 +0100

    itacns_get_serialnr(): check sc_read_binary() returned data length (only).

commit 7fea6eb8ba0caa431cf1c8ff493c4ac5a216a11f
Author: resoli <roberto@resolutions.it>
Date:   Fri Nov 7 12:48:43 2014 +0100

    itacns_get_serialnr(): check sc_read_binary() returned data length.

commit 56684d857c4c757c5ff86f0ab2b1a5392e845ab8
Author: resoli <roberto@resolutions.it>
Date:   Fri Nov 7 12:35:21 2014 +0100

    itacns_get_serialnr(): check sc_read_binary() returned data length.

commit f83f8d28dfe93855c23c3f45fa8c21717cb5f24a
Author: resoli <roberto@resolutions.it>
Date:   Fri Nov 7 11:42:16 2014 +0100

    itacns_get_serialnr(): relaxed checking on sc_select_file returned length, added debug log.

commit 255c0335a1e0c6d79706479ded5e8a919f00646f
Author: emRoberto Resoli/em <emroberto@resolutions.it/em>
Date:   Thu Nov 6 16:17:51 2014 +0100

    Indenting fix and stronger limit on serial number length.

commit 0e064277542377012b0d1b142f4d6d798a4a8057
Author: resoli <roberto@resolutions.it>
Date:   Wed Nov 5 22:57:25 2014 +0100

    Implementation of card_ctl function with SC_CARDCTL_GET_SERIALNR
    
    Implementation of card_ctl function with SC_CARDCTL_GET_SERIALNR

commit d00d7b349849193ead27fbe252a01e112c7e07b2
Merge: ea55c19 d135496
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 5 10:57:26 2014 +0100

    Merge pull request #276 from asmw/fix_return
    
    openpgp-tool: Return EXIT_SUCCESS if no error occurs

commit ea55c194392ec48ba9855af8876a4186cb6a2d09
Merge: cb7f40a a0ceaee
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 5 10:56:01 2014 +0100

    Merge pull request #195 from rainermetsvahi/master
    
    Add AzeDIT 3.5 card support

commit cb7f40a40d5c037f3797f4519893cf80baf9f0e6
Merge: ef94c6b 87d430f
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 5 10:40:11 2014 +0100

    Merge pull request #260 from frankmorgner/iso-ext
    
    iso7816: allow extended length APDUs

commit ef94c6b875b7927bb80e49139a29a3ce2b4937b7
Merge: 8672291 3d9118a
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 5 10:39:05 2014 +0100

    Merge pull request #311 from frankmorgner/const-data
    
    changed sc_apdu_t.data back to const unsigned char *

commit 8672291a732566dd7f075bde55caa1693fdba0bc
Merge: 7a5f9b2 d3c8fbc
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Nov 5 10:38:42 2014 +0100

    Merge pull request #312 from frankmorgner/fix-p15
    
    fixed type of pkcs15init_initialize

commit aa45685e0b90ef81c5f6999a0159a192b2a48234
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Nov 4 22:12:04 2014 +0100

    fixed documentation of dnie-tool

commit 4459e146c41ba63efccc2b4d80bb0b1bcb19ec17
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Nov 4 21:44:02 2014 +0100

    use util_get_pin in tools

commit e63f40c2d31996d5647d471f625f8d91811ff578
Author: Sumedha Widyadharma <sumedha@widyadharma.de>
Date:   Fri Sep 26 22:53:39 2014 +0200

    tools: Add util_get_pin helper function
    
    Using this helper PINs can be passed via the command line, stdin and an
    environment variable.
    
    For now only used in the openpgp tool.
    
    closes #289

commit d014056f1d7e2513f4b421a7b8cd2206dd619a7e
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Tue Nov 4 17:11:34 2014 +0100

    sc-hsm: Add support for Koblitz curves secp192k1 and secp256k1 (Bitcoin)

commit 7a5f9b2a16a5fb2b34517181d547f4f543b8aa6a
Merge: 0154ee0 fd22098
Author: Doug Engert <deengert@gmail.com>
Date:   Tue Nov 4 07:28:37 2014 -0600

    Merge pull request #315 from dengert/privateObjects
    
    Public certs and pubkeys with an auth_id are treated as private (See #291)

commit ccd87e7c0cf7e06fc12a00451f5f95eb3e8c9eac
Author: Shaun Schutte <schuttebs@gmail.com>
Date:   Tue Nov 4 09:01:36 2014 +0100

    Added ATR for ItalianCNS - Prov. BZ

commit 0154ee07e0ddbc66d49e94de58106ed9cb54d7e8
Merge: 8ed4db7 b2dcae3
Author: Martin Paljak <martin.paljak@gmail.com>
Date:   Mon Nov 3 19:22:01 2014 +0200

    Merge pull request #317 from CardContact/fix-Lc-in-PINblock
    
    sc-hsm: Fix Lc byte in VERIFY PIN block for PC/SC PIN PAD reader

commit b2dcae34cac205cb27835fb0be7d26a1965c8538
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Nov 3 15:52:54 2014 +0100

    Fix Lc byte in VERIFY PIN block for PC/SC PIN PAD reader

commit fd22098e194d24f00833bbb47e5d7cd5c00d9cf0
Author: Doug Engert <deengert@gmail.com>
Date:   Sat Nov 1 14:02:39 2014 -0500

    Public certs and pubkeys with an auth_id are treated as private (See #291)
    
    Code to test for an auth_id for certs and pubkeys was removed.
    See: PKCS#15 section 4.1.3 Access methods
    
    This is conseritive change and all objects could be treaded the same.

commit d3c8fbcf1d1e8c15dab6cc78ada19c6e167503d7
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 27 23:22:40 2014 +0100

    fixed type of pkcs15init_initialize
    
    regression from 95b6b4cc

commit 3d9118a8709126e5adae8c6020989cc48060ccc2
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Oct 27 22:48:34 2014 +0100

    changed sc_apdu_t.data back to const unsigned char *

commit 54489011609d05935c8cdd0012e461a9edb3bb09
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Sun Oct 26 11:48:57 2014 +0200

    macosx: update the minimal building instructions.

commit 82624a98b79895e66fbb18dc86af142a4a1ab147
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Sat Oct 25 20:07:36 2014 +0300

    macosx: locate and target the latest SDK to build against.

commit 1145bed3203ed0e489369801b0b1ac13e783d183
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Sat Oct 25 20:01:38 2014 +0300

    macosx: locate the best newest SDK present on the computer.
    
    With recent versions of XCode, PC/SC headers are hidden inside
    the SDK folder inside XCode app, and the global path is not
    guaranteed to be present. This allows to build easily from source
    without depending on a specific XCode/OSX version.

commit 8ed4db76c8f712c059a674dcec204b551178ee69
Merge: 73a1503 d72324d
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Oct 22 16:15:29 2014 +0200

    Merge pull request #238 from eighthave/master
    
    generate bash completion scripts from XML doc files

commit 73a150352b8c1b43dc608fafec2b56097121136a
Merge: 0dfb45b 189e998
Author: Doug Engert <deengert@gmail.com>
Date:   Thu Oct 16 08:48:32 2014 -0500

    Merge pull request #298 from dengert/pkcs11Hashes
    
    PKCS#11 hashes for cards without RAW (see #241)

commit 0dfb45b420e54daecee86f28ab36a61b67d18660
Merge: 34587ea 9a82a95
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Oct 13 21:51:41 2014 -0500

    Merge pull request #279 from dengert/master
    
    pkcs11-tool sets CKA_DECRYPT=true rather then CKA_DERIVE=true when gener...

commit 189e998486a5813bca2f6737a465ad62abb318c7
Author: Doug Engert <deengert@gmail.com>
Date:   Mon Oct 13 10:29:27 2014 -0500

    PKCS#11 hashes for cards without RAW (see #241)
    
        The framework-pkcs15.c did not add hashes correctly if the card did not support RSA RAW.
        This change fixes that and only adds hashes if the card did not specify a list of hashes.
        It also will not add hashes done in software if ENABLE_OPENSSL is not specified.
        Some error conditions are also tested for EC mechanisms.
    
        See bug report #241 for more information.

commit 9a82a95132ccd88f88aeb710128714ec01e62252
Merge: b84a1c9 34587ea
Author: Doug Engert <deengert@gmail.com>
Date:   Fri Oct 3 06:50:04 2014 -0500

    Merge branch 'master' of github.com:OpenSC/OpenSC

commit d72324ddf58f594a00c6b56b6abb8c4937b0794e
Author: Hans-Christoph Steiner <hans@eds.org>
Date:   Wed Oct 1 20:53:30 2014 -0400

    generate bash completion scripts from XML doc files
    
    This generates the scripts that lets bash do completion per specific tool.
    It gets the options from the documentation XML files that are also the
    source for the man pages and HTML.

commit 34587eac9c608d38c6b067881580cd5cf7e9835a
Author: Ludovic Rousseau <ludovic.rousseau+github@gmail.com>
Date:   Wed Oct 1 22:01:40 2014 +0200

    Fix compiler warning
    
    p15card-helper.c:23:5: warning: 'ENABLE_OPENSSL' is not defined, evaluates to 0
          [-Wundef]
        ^

commit 09c2847b7ed20c0a90337cffc967c9fe3a8d8975
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Wed Oct 1 22:05:01 2014 +0200

    Fix compiler warning
    
    pkcs15-dnie.c:242:13: warning: function declaration isn't a prototype [-Wstrict-prototypes]
     const char *sc_driver_version()
                 ^

commit fb7bbf1e800715c7fe153fd9c738b78e3bd38521
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Wed Oct 1 21:41:12 2014 +0200

    build: disable Secure Messaging if OpenSSL is not used
    
    If OpenSSL is not present or --disable-openssl then Secure Messaging is
    disabled.
    
    The problem was that some Secure Messaging code is missing if OpenSSL is
    absent. The build/link failed with some missing symbols.
    
    Fix issue #293

commit c8545baf9087cca9116a1b1aa6f8430ec7863270
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Wed Oct 1 21:12:28 2014 +0200

    pkcs15-dnie: fix compilation when OpenSSL is not used
    
    If OpenSSL is not used then the functions from card-dnie.c are not
    defined and in particular dnie_match_card() is not defined.
    In that case we use a fake dnie_match_card() that just returns false.

commit 955a3391481f6b116ee38f4d6762c6fd3967551c
Author: Philip Wendland <wendlandphilip@gmail.com>
Date:   Thu Sep 25 17:12:02 2014 +0200

    Merge PR#288 from philipWendland:upstream-ecc-fix
    
    add the possibility to store public ECC keys encoded according to SPKI
    EC pubkey storing: Check if params are available before copying.
    pkcs15-lib.c / sc_pkcs15init_store_public_key may be called with keyargs->key.u.ec.params.value == NULL. In this case, allocating and copying the parameters will fail. Add a check to prevent this.

commit 4e73d0e36f78633e8b2966122ba8df4ac0c93e60
Author: Dirk-Willem van Gulik <dirkx@webweaving.org>
Date:   Mon Sep 22 09:52:38 2014 +0200

    Merge PR#280 from dirkx/master: --no-prompt flag
    
    Add a --no-prompt flag to pkcs15-tool (i.e. the equivalent of the --no-prompt flag of pkcs15-init). As to aid readers with keypads (as commonly used in the medical space).

commit ea712bfd56737170a9c285f3b0a4ebd09e1425af
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Mon Sep 29 16:01:17 2014 +0200

    Fix compiler warning
    
    The same function iasecc_sm_external_authentication() was declared in
    two different .h files.
    
    In file included from ../../src/libopensc/iasecc.h:27:0,
                     from sm-card-iasecc.c:44:
    ../../src/libopensc/iasecc-sdo.h:324:5: warning: redundant redeclaration of `iasecc_sm_external_authentication' [-Wredundant-decls]
    In file included from ../../src/libopensc/opensc.h:44:0,
                     from sm-card-iasecc.c:40:
    ../../src/libopensc/sm.h:352:5: note: previous declaration of `iasecc_sm_external_authentication' was here

commit cb89a870aed943c6b2df2de41d9524ba4ca2e45a
Merge: 9928179 3a0ca5a
Author: Doug Engert <deengert@gmail.com>
Date:   Thu Sep 18 16:32:21 2014 -0500

    Merge pull request #280 from shootingatshadow/aes-support
    
    Remove hardcodes from Mutual Authenticate

commit 99281793e08fdc9767fcb89ada881e951b59bca8
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Tue Sep 16 15:23:47 2014 +0200

    Fix secure messaging library name on Mac OS X
    
    Mac OS X uses "libsmm-local.3.dylib" as library name. The default value
    "libsmm-local.so.3" is correct for Linux but not for Mac OS X.
    
    This bug prevented the "opensc-tool -a" to work correctly and return the
    ATR if an IAS card is present in the reader.

commit be200ab3c8165510736ef945b2a29eedcbea99a0
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Sep 3 17:25:36 2014 +0200

    Merge pull request #282 from CardContact/fix-deleted-related-public-key
    
    framework-pkcs15: Duplicate public key related to private key rather than referencing the framework object
    
    Referencing the related public key is required to return PKCS#11 attributes for a private key only available
    in the public key object (i.e. CKA_MODULUS). This patch adds a copy of the public key to the private key object rather than
    referencing the public key object in the framework. This prevents SEGV when the public key framework object
    is deleted with C_DestroyObject, but the reference from the public key remains intact.
    
    The bug leads to all kind of stability problems when keys are created and deleted in the same session.
    
    The patch is in particular important if OpenSC is used with EJBCA or any other application using the
    SUN PKCS#11 provider: When generating key pairs, then the public key object is eventually garbage collected
    which removes the related object in the PKCS#11 module. Because there is no fixed time for this operation,
    corruption occurs at random.
    
    In a next step, the remaining related_xxx fields in sc_pkcs11_object should be revised and possibly removed.
    
    framework: Added more error checking

commit 7db99500a0e705f1a813574a2c069415eb3b9564
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Sep 3 17:16:59 2014 +0200

    sc-hsm: Fix certificate delete bug
    
    If a certificate is deleted after the related private key, then the driver
    picks the wrong certificate EF, leading to an CKR_GENERAL_ERROR or the wrong
    certificate being deleted.

commit f9b8b2c2200feeb2ac2d35c848ce9abd5d89b1e8
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Sun Jul 13 12:13:04 2014 +0200

    sc-hsm: Added error if private key import tried
    
    Private key import is not supported by the SmartCard-HSM. However there is no error code
    if it is still tried using pkcs15-init or from within Firefox.

commit 08f07adf592d4c2b46d80e149f7b6124278aaf2f
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Aug 25 21:46:52 2014 +0200

    sc-hsm: Improve error detection and reporting in sc-hsm-tool

commit 1fc0a7e7d66c4bbb41d04855faa510a2b380351f
Author: Sumedha Widyadharma <sumedha@widyadharma.de>
Date:   Tue Aug 12 22:54:22 2014 +0200

    Merge pull request #274 from github-asmw/private-do-3
    
    openpgp-tool: Added PRIVATE-DO-3 dump option
    
    The bytes of private-do-3 will be written to stdout raw.
    Requires pin and verify to work.
    
    openpgp-tool: Fix private-do-3 dump for Windows
    
    fwrite will convert line endings on Windows if the destination
    is not openend in binary mode. As this actually dumps binary data,
    it makes sense to reopen stdout in binary mode for the dump.
    
    openpgp-tool: Enable dumping of all DOs
    
    PRIVATE-DO-<X> can now be dumped via the -d/--do switches and
    the DO number as a parameter.
    PRIVATE-DO-[12] can be dumped without verification.
    PRIVATE-DO-3 requires CHV2, PRIVATE-DO-4 CHV3.
    
    openpgp-tool: Dump DOs as hex into a tty, binary otherwise
    
    This prevents messing up a terminal if there really _is_
    binary data in a private DO. To force the binary data to a terminal,
    pipe through cat.
    
    openpgp-tool: Hint at the pin and verify options on error
    
    SC_ERROR_SECURITY_STATUS_NOT_SATISFIED is the error code
    here when dumping a private DO without the appropriate verification.
    
    openpgp-tool: Explictly use --raw for binary ouput
    
    The --raw switch already exists. If present, raw binary will be written,
    a pretty-printed hex/ascii representation otherwise.

commit 139333f85aa5fa3a99c22f8305701d20d588415e
Author: andbil <andbil@users.noreply.github.com>
Date:   Sun Aug 3 12:15:58 2014 +0200

    Fix error when signing with Swedish BankID card
    
    Added card type check in addition to check for SC_SEC_ENV_KEY_REF_PRESENT
    
    Added card type check in addition to check for SC_SEC_ENV_KEY_REF_PRESENT

commit bb160bfd99c8fa11f656e944855f24b68f68e756
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jul 17 15:52:45 2014 +0200

    pkcs15-tool: fixed file reading

commit e6505b3d9c34097df095695ec9c98c0dccbc97a8
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Mon Jul 14 17:37:09 2014 +0200

    pkcs11: Fixed wrong reference to PIN object in C_SetPIN() for SO-PIN

commit f80759b65e4d93c6f94c8587aa8c10a3a115df05
Author: Raul Metsma <raul@metsma.ee>
Date:   Thu Jun 26 11:50:45 2014 +0300

    Target minimum OSX version to 10.7

commit ed73851c41aa18f9f869d610d39d9beef8872b81
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Thu Jun 26 21:09:16 2014 +0200

    fixed pkcs15 version check

commit 5d6c4b391dbcab979e1fc74b78ef684c7b4849e6
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jun 6 23:50:14 2014 +0200

    Merge pull request #253 from github-frankmorgner/remove-deadcode
    
    card-asepcos: removed dead code
    card-authentic: removed dead code
    card-belpic: removed dead code
    card-epass2003: removed dead code
    card-flex: removed dead code
    card-gpk: removed dead code
    card-oberthur: removed dead code
    card-piv: removed dead code
    card-setcos: removed dead code
    ctbcs: removed dead code
    cwa14890: removed dead code
    muscle: removed dead code
    pkcs15-atrust-acos: removed dead code
    pkcs15-gemsafeV1: removed dead code
    pkcs15-skey: removed dead code
    reader-ctapi: removed dead code
    framework-pkcs15: removed dead code
    pkcs11-object: removed dead code
    pkcs15-asepcos: removed dead code
    pkcs15-cardos: removed dead code
    pkcs15-jcop: removed dead code
    pkcs15-lib: removed dead code
    pkcs15-oberthur: removed dead code
    parse: removed dead code
    sclex: removed dead code
    sm-card-authentic: removed dead code
    sm-card-iasecc: removed dead code
    sm-cwa14890: removed dead code
    sm-global-platform: removed dead code
    sc-test: removed dead code
    pkcs11-tool: removed dead code
    pkcs15-tool: removed dead code

commit df959efab5c32ad2820197fed3436da0ed05bb69
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri Jul 11 17:07:48 2014 +0200

    md: install minidriver by default

commit 3a0ca5aa7d950e448503750254f7035901bf66c8
Author: William Roberts <w2.roberts@samsung.com>
Date:   Tue Sep 2 12:16:53 2014 -0700

    Remove hardcodes from Mutual Authenticate
    
    Support nonces that are not only 8 bytes in
    Mutual Authenticate. Use the witness length
    to determine the nonce size, thus existing
    systems using 8 bytes will continue to use 8
    bytes. However, with AES 256, the nonces could
    be a single block size of 16 bytes or greater.

commit b84a1c9a90be8c048f29237346008ac5736decb0
Merge: 2de38a1 3260ca3
Author: Doug Engert <deengert@gmail.com>
Date:   Tue Sep 2 16:37:45 2014 -0500

    Merge branch 'master' of github.com:OpenSC/OpenSC

commit 3260ca3eab735013bf72e62281c23363f1394441
Merge: 5279bfa 295c523
Author: Doug Engert <deengert@gmail.com>
Date:   Tue Sep 2 16:29:57 2014 -0500

    Merge pull request #270 from shootingatshadow/aes-support
    
    Add AES support for PIV General Authenticate
    
     adds new routine sc_right_trim in sc.c and opensc.h. It is used by  PIV card driver when using the piv-tool.

commit 87d430f300ed7ba4aaf0f4ce3b44fba23b888b87
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Aug 26 21:21:26 2014 +0200

    iso7816: propagate the length of the computed signature

commit 2de38a12309cdab740548efbde7aef4791bf6ea6
Author: Doug Engert <deengert@gmail.com>
Date:   Tue Aug 26 09:59:40 2014 -0500

    pkcs11-tool sets CKA_DECRYPT=true rather then CKA_DERIVE=true when generating EC keys (#277)
    
    RSA and EC keys have different usage attributes. Appropriate attributes are set
    When using --keypairgen the user can use the --usage-sign, --usage-decrypt,
    and --usage-derive. to get finer control.
    
     Changes to be committed:
    	modified:   tools/pkcs11-tool.c

commit 295c523e4e174a4adef7cae6e0463b1164e52c75
Author: William Roberts <w2.roberts@samsung.com>
Date:   Tue Jul 8 13:52:48 2014 -0700

    Add AES support for PIV General Authenticate
    
    This adds algorithm IDs 0xA, 0xA, 0xC which as documented
    by the NIST PIV specification is algorithms AES-128, AES-192
    and AES-256 respectively.
    
    This patch also addresses some of the hardcodes that prevented
    nonces greater than the single byte TLV length tags would allow.
    It was explicitly tested with AES-256 and 256 byte nonces.
    
    Signed-off-by: William Roberts <w2.roberts@samsung.com>

commit d13549600d7d7e33106dbc19da16cc40f50daacd
Author: Sumedha Widyadharma <sumedha@widyadharma.de>
Date:   Wed Aug 20 21:45:42 2014 +0200

    openpgp-tool: Return EXIT_SUCCESS if no error occurs
    
    exit_status is either set directly or a function return is ORed with it,
    in which case EXIT_SUCCESS can never be returned if the initial value is !=
    0;

commit 7c9bc4d283a353791bd4c23e16e6bcddbb8a6fc5
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Jul 14 01:30:28 2014 +0800

    OpenPGP: Fix crash after accessing inexistent file.

commit c71934af67c2978e1f14b5dc822235fa80a83796
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Jul 13 19:41:36 2014 +0800

    OpenPGP: Rename private "blob" type to avoid confusing with variable name.
    
    This name has been used for both data type and variable name of that
    type.

commit aded490b649bec1e4f31d8a84d3d36ab89db7b27
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Jul 13 17:37:59 2014 +0800

    OpenPGP: Use directly binary array of APDUs for ERASE command.
    
    I used a string presentation before and it needed an extra conversion step.

commit 968c9bb06140d081838737cf48df49badbe7790f
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Nov 3 11:26:25 2013 +0800

    OpenPGP: Don't reimplement gnuk_delete_key in openpgp-tool.

commit ba4fe34700a92f9bc89b09227f8883d473cadea3
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Nov 3 02:53:35 2013 +0800

    OpenPGP: Don't use sc_log in openpgp-tool.

commit 7c27cea61ff1ef4a8d036af2b8a8b2abb889bdc8
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Sun Nov 3 01:45:56 2013 +0800

    OpenPGP: Make indentation consistent (space -> tab).

commit 6aa4896b358bde7a17e6d68c37d4b61c5a11d465
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed May 8 16:51:21 2013 +0700

    Move declaration to top of block.

commit 7ba89893da4bcd743030ddbea425d18d186a6b8a
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Tue Apr 16 16:02:17 2013 +0700

    OpenPGP: Make code neater

commit a42eb5e5854ec92b2f2cba0a3e0fc82d7cfc3060
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Tue Apr 16 10:19:34 2013 +0700

    OpenPGP: Correct parameter checking.

commit a1c8c99858b49cc1597c8737d5717ccbf1c8b5df
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Fri Apr 12 15:33:31 2013 +0700

    OpenPGP: Delete key as file, for Gnuk.

commit e71906ed23f436b49f78942363ce060f9260172b
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Thu Apr 11 16:18:31 2013 +0700

    OpenPGP: Overcome the restriction of even data length of Gnuk.
    
    When write certificate with odd length to Gnuk, we add zero padding to make it even.

commit bbca9c4827bd164f8b3e5a5d8966d990b6a68b75
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Apr 10 18:35:58 2013 +0700

    pkcs15-openpgp: Change to sc_put_data instead of sc_update_binary when writing certificate.

commit cbc53b9a97e96dddfd6339a8ebddb87c472efb7e
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Thu Apr 11 11:47:51 2013 +0700

    OpenPGP: Support write certificate for Gnuk.

commit ebbebb4fa67d2f0d5b2ec549ff9b2efd568fd1b0
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Fri Apr 5 17:18:50 2013 +0700

    OpenPGP: Provide enough buffer to read pubkey from Gnuk.

commit 9a2a6e6dc0f55679e8c0e918802af76c41d07a31
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Mar 27 11:39:33 2013 +0700

    PKCS15-OpenPGP: Allow to store data to pkcs15 data object.
    
    Only one DO is supported now.

commit 6a55c09793fb185cc617cb2812d385d1c87c35de
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Mar 27 11:38:42 2013 +0700

    PKCS15-OpenPGP: Do not show empty DO in pkcs15 emu_init.

commit 1df3daeb62942f5b1ee0e683465790348905bb21
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Mar 25 11:58:38 2013 +0700

    OpenPGP: Read some empty DOs from Gnuk.
    
    In Gnuk, some empty DOs are returned as not exist, instead of existing with empty value.
    So, we will consider them exist in driver.

commit db39041cc1596245c8d35ab07b440513c280e748
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Mar 4 18:14:51 2013 +0700

    OpenPGP: Correct building Extended Header List when importing keys.

commit c4bbfa67593c61d9a820b1b9bcd76c2cffe0d09e
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Mar 4 18:13:03 2013 +0700

    openpgp-tool: Support deleting key in Gnuk.

commit 3b8f77882b7ddca14d5da1404d1b8c13dc476757
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Mon Mar 4 11:28:08 2013 +0700

    OpenPGP: Support erasing (reset) card.
    
    Command: openpgp-tool --erase

commit 24e3bdb87280275fe91a176d2e1c012f516bf4fd
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Tue Feb 26 17:37:16 2013 +0700

    PKCS15-OpenPGP: Declare DATA objects.
    
    Begin to support read/write DATA object for PKCS-OpenPGP binding.
    This object is used by TrueCrypt.

commit c81eab5a70bb7aa71d0d69745015cee9deb74370
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Fri Mar 22 17:37:16 2013 +0700

    OpenPGP: Include private DO to filesystem at driver initialization.
    
    In old implementation, the DOs which their access is restricted by
    PIN (like DOs 0101 -> 0104) were excluded from the fake filesystem,
    leading to that we cannot read their data later, even if we verified PIN.

commit a4d92610878d4d13449c458a9fba5f885e769f70
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Fri Apr 12 17:24:00 2013 +0700

    OpenPGP: Add Gnuk in pkcs15 emulation layer.

commit 1789cf034588e8cd7fc0334b515e14637c84563a
Author: Nguyễn Hồng Quân <ng.hong.quan@gmail.com>
Date:   Wed Feb 20 11:54:30 2013 +0700

    OpenPGP: Detect and support Gnuk Token.
    
    http://www.fsij.org/gnuk/

commit 5279bfa2d14d2186b31189748bcf89d908f00512
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Wed Jul 9 14:22:51 2014 +0200

    sc-hsm: Prevent double-free crash if key generation fails
    
    Fixes #262 (SEGV when reader does not support extended length ADPU)

commit bb92019e5362147cf6fdcfee946ac723071334d3
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jun 27 08:26:35 2014 +0200

    iso7816: allow extended length APDUs

commit db60f8da59ef05fa987decfc5a6b5abb9bc93f42
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Thu Jun 26 19:15:33 2014 +0200

    release 0.14.0

commit 440289a09113d19d83b20cfecd2ba8dd98ba5826
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Tue Jun 17 14:45:45 2014 +0200

    sc-hsm: reduce indicated maximum PIN length to 15
    
    Fix bogus minimum PIN length to support more PIN pad readers

commit cd7fbe3f8c00e9f96dcc5c50a114b9bda9d47215
Author: Raul Metsma <raul@metsma.ee>
Date:   Thu Jun 26 11:49:45 2014 +0300

    MacOSX: Build fat binaries i386...
    
    revert part of 6e255a95
    
    Chrome is still 32 bit only
    This allows plugins running in Chrome (32bit) to use OpenSC PKCS#11, which would otherwise be only 64bit. Tokend "hides" the cpu architecture issue otherwise.

commit 852a4719cfb9b92917bb88cfa4d25bc62dd46374
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon Jun 9 16:34:06 2014 +0200

    release: OpenSC-0.14.0 RTM

commit 35b74f392379537e1271870a1685f82ee5b5e9f1
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jun 6 22:17:14 2014 +0200

    fixed warning unused variable

commit 359660c45468faa27fb8a5a81d9efcb955538619
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Fri Jun 6 23:16:50 2014 +0200

    dnie: removed dead and untested SM wrapping code

commit 55bb8e9ff83b332662dbac202b91230e898d3519
Author: Raul Metsma <raul@metsma.ee>
Date:   Mon Jun 9 12:44:49 2014 +0300

    New generation card-s don't have issues with T1 and 3.5 card with same ATR has issues with T0 (recursive GET BINARY/GET DATA)

commit 072dfeb71cffc053d50a0e5fa0b075335899c6ee
Author: Andreas Schwier <andreas.schwier@cardcontact.de>
Date:   Fri Jun 6 21:10:28 2014 +0200

    sc-hsm-tool: Fixed SEGV if no or invalid card in reader

commit b1b5a39ffad95814901d1955360555d9b3608c5e
Author: Henryk Plötz <henryk@ploetzli.ch>
Date:   Sun May 25 04:49:28 2014 +0200

    Use sc_pkcs15_find_pin_by_auth_id() in asepcos_create_key() to correctly set the newly created key up for use with the configured PIN.

commit 77d8fa390dfff48c5c502c175a0316da57a5c4bc
Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Thu Jun 5 11:37:25 2014 +0200

    base64 decoding: Do not assume that char is signed.
    
    In the systems where char is unsigned by default the base64 decoding
    would crash.

commit 2f6b5174a81a7aa72da6efabfd347252e911d41c
Author: Joachim Bauch <bauch@struktur.de>
Date:   Thu Jun 5 11:50:49 2014 +0200

    Support "D-TRUST card 2.4 2ce".

commit 3f13f571c0aa4ecec44ce54f06bab6e7946c2927
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun Jun 1 19:42:01 2014 +0200

    openpgp-tool: issue-220: read and display OpenPGP data

commit ee0566af090ab89a4446084f98dbcc94fb0be149
Author: Emanuele Pucciarelli <ep@corp.it>
Date:   Sun May 18 00:22:07 2014 +0200

    pkcs11: pr-239: PKCS15 pubkey release fix

commit 77c71be833bbcf10ed807c2320e26efd5b0fe683
Author: Raul Metsma <raul@metsma.ee>
Date:   Wed Apr 30 16:10:27 2014 +0300

    Don't depend configuration default value

commit ccf6da2dbe3e156a68591a7d2b5adfb91a236cae
Author: Raul Metsma <raul@metsma.ee>
Date:   Wed Apr 23 13:01:36 2014 +0300

    Add windows onepin makefile

commit 8e13acf51ebd18d6fa4aeb4fb38c240c11595f3d
Author: Raul Metsma <raul@metsma.ee>
Date:   Wed Apr 23 11:50:38 2014 +0300

    Restore pkcs11 onepin module for Firefox usage

commit f87a364ddcdfe58def14e179c772027f78ce2fb0
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sat May 31 20:02:42 2014 +0200

    release: candidate for the next stable version

commit cfc9461fe5fada9147d018bb434e50df5ea0006a
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri May 16 16:51:01 2014 +0200

    Update NEWS for opensc-0.13.1

commit 612c7fe43a3d7ffbe85d8e102c582e9f0618786a
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri May 16 16:50:27 2014 +0200

    git: ignore version.m4.ci

commit 3418e9c1461217b661fc6d5f179d026d08a3cefa
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri May 16 09:18:17 2014 +0200

    OpenSC 0.13.1 rc1

commit de6d61405b271e22244376e4817e16b49018e1ce
Author: Henrik Andersson <henrik.4e@gmail.com>
Date:   Mon Mar 17 08:44:49 2014 +0100

    Dont use sha256 if openssl is older than 0.9.8.

commit 1df8570a66b401e20d42eeca0752c92fd0eb6e19
Author: Henrik Andersson <henrik.4e@gmail.com>
Date:   Fri Mar 14 09:11:10 2014 +0100

    Add fence against using EVP_sha256 mech.
    
    Which is only available in >=0.9.8

commit e41d94ca1a26230ffe48a26cd796cdf08b7ce870
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue May 13 14:57:01 2014 +0200

    md: fix return code in 'CardGetContainerInfo'

commit 808fff2246c985c1e69a8aea6bcc71152c5ddbbc
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon May 12 22:12:29 2014 +0200

    pkcs11: take pubkey CKA_VALUE from pub_data

commit b6ad7a92f58853b0c6be02e29db012d4ef960791
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon May 12 22:12:29 2014 +0200

    pkcs11: more of debug messages

commit 7dcb4359ffc930c6603dbb656c457669ea213edb
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun May 11 21:12:38 2014 +0200

    build: put PACKAGE_VERSION_REVISION into version.m4

commit 24fa9d8cc27b54b8929d824563c2d2cc7656ab91
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon May 5 09:03:28 2014 +0200

    build: by default enable SM support

commit 7b1e2e5dd33fe8d2f3075e927ff198db8afae984
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Sun May 11 17:44:05 2014 +0200

    build: uninstall-hook for opensc.conf

commit d4195e297ce244de152cd2dc73a16a984c77e481
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Mon May 5 08:46:29 2014 +0200

    build: bootstrap script has expected content
    
    added CI specific 'bootstrap' script version: with parameters it creates the 'm4.version.ci' -- CI specific 'm4.version'

commit 4bed397fbc25227f6323c977f2e9f34153aab0d6
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Tue Apr 29 16:56:15 2014 +0200

    build: return to standard use of 'autoconf'
    
    Following http://sourceforge.net/p/opensc/mailman/message/32009859/
    
    * 'configure.ac' is not mored created by bootstrap script, but present in source
    * 'version.m4' is introduced and contains the 'volatile' package settings:
       settings that can be changed for the needs of particular build (ex. change PACKAGE_SUFFIX using the Git 'describe' or 'commit' data)
    * 'bootstrap' script facilitate change of the package setting during the 'autoconf' phase

commit 5f45739ecb6230a1fba68ff514961ee3310f9d02
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Mar 3 08:06:12 2014 +0100

    fixed one more warning

commit e1fd9d2a4c12ca460cc50b6f324c46b4846c5737
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Mon Mar 3 08:05:10 2014 +0100

    cardos,incrypto34: restored semantics of select_pin_reference

commit 511c8e63829837ab7b48aebd9894ab42fa11a2aa
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Mar 1 17:05:38 2014 +0100

    dnie: dont ignore error on sm free operation
    
    Signed-off-by: Frank Morgner <morgner@informatik.hu-berlin.de>

commit b483d1d27dd7eb299035d1bf06458b4c3cb4b3e0
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Mar 1 17:00:12 2014 +0100

    westcos: fixed initialization of driver data
    
    Signed-off-by: Frank Morgner <morgner@informatik.hu-berlin.de>
    
    Updated by Viktor Tarasov

commit 3b50ccc0eae5d8198a7f6e86624a24fdd3ddd0cf
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Sat Mar 1 16:32:39 2014 +0100

    fixed incompatible function usage
    
    Signed-off-by: Frank Morgner <morgner@informatik.hu-berlin.de>

commit a64326e7683020826372d7a90963cd3a0de94750
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Tue Feb 25 09:07:09 2014 +0100

    fixed compiler warnings (partially submitted)
    
    Signed-off-by: Frank Morgner <morgner@informatik.hu-berlin.de>
    
    PR-222: commit https://github.com/frankmorgner/OpenSC/commit/0b567dbaa83741675497a76d867645675f57262c
    partially submitted by Viktor Tarasov

commit 883d42b1f8ec4a8b67d6eabde334bfa4259efdf9
Author: Viktor Tarasov <viktor.tarasov@gmail.com>
Date:   Fri May 2 13:39:05 2014 +0200

    libopensc: export 'iasecc_sdo_encode_update_field'
    
    used by 'local SMM' module

commit 8d000774dfebff00489b40fdcd07a69b1a4b818b
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Fri Feb 14 11:50:20 2014 +0000

    EstEID: match card only based on presence of application.
    
    Contact cards have ATR-s, contactless not. Only contact
    cards should be broken so that they answer 0x9000 to application
    selection, so this should be failsafe.

commit ba66459f338d597675e2b729ee25f58c9256bed9
Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Tue Feb 25 10:41:18 2014 +0100

    When setting pointers to a template, ensure they do not get out of scope prior of being used.
    
    This was causing issues when using pkcs11-tool with opencryptoki:
    https://bugzilla.redhat.com/show_bug.cgi?id=1062307
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

commit 46b0bed93f3bb7b3d8edd4401c94f1cf6399fa55
Author: Frank Morgner <morgner@informatik.hu-berlin.de>
Date:   Wed Feb 26 23:57:41 2014 +0100

    fixed PUK handling
    
    Note that
    `SC_PKCS15_PIN_AUTH_TYPE_PIN` is used for `sc_pkcs15_auth_info_t.auth_type`
    `SC_PKCS15_TYPE_AUTH_PIN`     is used for `sc_pkcs15_object_t.type`

commit 218d198bdc6a0de525e86f9e20181ffa6d19cce4
Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Fri Feb 28 16:17:37 2014 +0100

    Call dlclose() only when having a valid handle.
    
    Signed-off-by: Nikos Mavrogiannopoulos <nmav@redhat.com>

commit fc5714a4c9f2c886b4fbce74c79a16bea6f0db30
Author: Henrik Andersson <henrik.4e@gmail.com>
Date:   Wed Mar 12 14:57:47 2014 +0100

    Set missing default create_slots_flags.
    
    Without this pkcs11 cant be used without a configuration file
    or a configfile without pkcs11 block due to the missing initialization
    of default flag.

commit 332ced5be7aae383921cd14325aa5288f4a08411
Author: Martin Paljak <martin@martinpaljak.net>
Date:   Sun Mar 16 16:39:26 2014 +0000

    Remove the bogus javacard "driver".
    
    I had some ideas on how to improve the experience for JavaCards
    but that path did not get implemented further and my approach now
    is very different.
    
    While it would be nice if OpenSC (command line) detected
    somehow blank JavaCard-s and informed the user that steps a-b-c
    should be taken to make use of it, it doesn't really fit in.

commit 7796d2c95c2170487498a8fa28136863a4e625fa
Author: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date:   Mon Mar 17 13:34:33 2014 +0100

    Mention that create_slots_for_pins can be used to get opensc-onepin behavior.

commit e7cda857f07fb7d012d2b150532c57d0c22a8a59
Author: Raul Metsma <raul@metsma.ee>
Date:   Wed Apr 2 09:48:14 2014 +0300

    Fix memory leak, sc_pkcs15_cert_t *cert is never freed

commit cdc379fa2559a616b73405e59793e3ebd37e96dc
Author: Ludovic Rousseau <ludovic.rousseau@gmail.com>
Date:   Thu Apr 10 16:40:12 2014 +0200

